<?php

namespace App;
use Laravel\Passport\HasApiTokens;
use Illuminate\Notifications\Notifiable;
use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Zizaco\Entrust\Traits\EntrustUserTrait;
use Depsimon\Wallet\HasWallet;

class AppUser extends Authenticatable
{
    use Notifiable,HasApiTokens;
    use EntrustUserTrait;
    use HasWallet;
    
    protected $guard = 'admins';
    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'name', 'email', 'password','image','dob','login_status','referral_code','package_name'
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
        'password', 'remember_token',
    ];
    public function vehicles()
    {
        return $this->hasMany('App\AppUserVehicles'); 
    }
    
    public function profile()
    {
        return $this->hasOne('App\AppUserProfile'); 
    }

    public function getFullNameAttribute()
    {
        return ucfirst($this->first_name) . " " . ucfirst($this->last_name);
    }


    public function message()
    {
        return $this->hasMany('App\Message'); 
    }



  
    
}
