<?php
namespace App\Classes;
use File;
use Form;
use Session;
use DB;
use App\CustomField;
use App\CustomFieldValue;
use App\Designation;
use App\SMTP;
use Validator;
use App\AppUser;
use App\AppUserVehicles;
use App\AppUserProfile;
use URL;
use App\Countrys;
use App\States;
use App\Cities;
use App\Years;
use Auth;
use PDF;
use Mail;
use Entrust;
use Swift_Mailer;
use Swift_Message;
use Carbon\Carbon;
use Swift_SmtpTransport;
use Services_Twilio;
use Services_Twilio_RestException;

    Class Helper{


        public static function toWord($word){
            $word = str_replace('_', ' ', $word);
            $word = str_replace('-', ' ', $word);
            $word = ucwords($word);
            return $word;
        }

    public static function getNames($table,$id)
    {
        $data=DB::table($table)->select('name')->where('id',$id)->first();
        if(count($data)>0){
            return $data->name;
        }

        
    }


    public static function dateDiff($date1,$date2){
        if($date2 > $date1)
            return date_diff(date_create($date1),date_create($date2))->days + 1;
        else
            return date_diff(date_create($date2),date_create($date1))->days + 1;
    }

    public static function daySuffix($num){
        $num = $num % 100; // protect against large numbers
        if($num < 11 || $num > 13){
             switch($num % 10){
                case 1: return 'st';
                case 2: return 'nd';
                case 3: return 'rd';
            }
        }
        return 'th';
    }
  public static  function getDateDiff($date){
    $difference = date('z',strtotime($date)) - date('z') + 1;
    if($difference == 0)
        return trans('messages.today');
    elseif($difference == 1)
        return trans('messages.tomorrow');
    elseif($difference == -1)
        return trans('messages.yesterday');
    else
        return 0;
}


        public static function putCustomHeads($form, $col_heads){
            $custom_fields = CustomField::whereForm($form)->get();
            foreach($custom_fields as $custom_field)
                array_push($col_heads, $custom_field->title);
            return $col_heads;
        }

    public static    function showDate($date = ''){
    if($date == '' || $date == null)
        return;

    if(config('config.date_format') == 'dd MM YYYY')
        $format = 'd-M-Y';
    elseif(config('config.date_format') == 'mm dd YYYY')
        $format = 'm-d-Y';
    elseif(config('config.date_format') == 'MM dd YYYY')
        $format = 'M-d-Y';
    else
        $format = 'd-m-Y';

    return date($format,strtotime($date));
}
        
    public static function delete_form($param, $name = '', $data_table_row_delete = 0, $label = '')
    {
    $form = Form::open(['method' => 'DELETE','route' => $param,'class' => 'form-inline','id' => $name.'_'.$param[1],'data-table-row-delete' => $data_table_row_delete]);
    $form .= (Form::button('<i class="icon ion-close tx-20 icon-properties delete" data-toggle="modal" 
    data-target="#delete"></i>'.$label,['data-toggle' => 'tooltip','title' => ('Delete'),
    'data-submit-confirm-text' => 'Yes',
    'type' => 'submit','id'=>'confirm-delete',
    'data-toggle'=>"modal" ,'data-target'=>'#delete',
    'style'=>'border: none; background-color: #f9f9f9;','onclick'=>'return confirm("Do you Want to Delete This");']));
    return $form .= Form::close();


    
}
        public static function sendMails($name,$email,$subject,$blade,$body){

            $smtp=SMTP::get()->first();
                  
            $transport = new Swift_SmtpTransport($smtp->host, $smtp->port);
            $transport->setUsername($smtp->username);
            $transport->setPassword($smtp->password);

            $mailer = new Swift_Mailer($transport);

            $message = (new Swift_Message($subject))
            ->setFrom($smtp->username, $name)
            ->setTo($email)
            ->setBody(view('emails.'.$blade, ['body'=>$body])->render(),'text/html');
            return $result = $mailer->send($message);
		}  
		
		


        public static function getCustomFields($form, $custom_field_values = array()){
			
			$custom_fields = CustomField::whereForm($form)->get();
			
			foreach($custom_fields as $custom_field){
			  
			  $c_values = (array_key_exists($custom_field->name, $custom_field_values)) ? $custom_field_values[$custom_field->name] : '';
			  $options = explode(',',$custom_field->options);
			  
			  $required = '';
			  
			  // if($custom_field->is_required)
			  // 	$required = 'required';
		      
		      echo '<div class="form-group">';
			  echo '<label for="'.$custom_field->name.'">'.$custom_field->title.'</label>';
			  
			  if($custom_field->type == 'select'){
			  	echo '<select class="form-control input-xlarge select2me" placeholder="'.trans('messages.select_one').'" id="'.$custom_field->name.'" name="'.$custom_field->name.'"'.$required.'>
			  	<option value=""></option>';
			  	foreach($options as $option){
			  		if($option == $c_values)
			  			echo '<option value="'.$option.'" selected>'.ucfirst($option).'</option>';
			  		else
			  			echo '<option value="'.$option.'">'.ucfirst($option).'</option>';
			  	}
			  	echo '</select>';
			  }
			  elseif($custom_field->type == 'radio'){
			  	echo '<div>
					<div class="radio">';
					foreach($options as $option){
						if($option == $c_values)
							$checked = "checked";
						else
							$checked = "";
						echo '<label><input type="radio" name="'.$custom_field->name.'" id="'.$custom_field->name.'" value="'.$option.'" '.$required.' '.$checked.' > '.ucfirst($option).'</label> ';
					}
				echo '</div>
				</div>';
			  }
			  elseif($custom_field->type == 'checkbox'){
			  	echo '<div>
					<div class="checkbox">';
					foreach($options as $option){
						if(in_array($option,explode(',',$c_values)))
							$checked = "checked";
						else
							$checked = "";
						echo '<label><input type="checkbox" name="'.$custom_field->name.'[]" id="'.$custom_field->name.'" value="'.$option.'" '.$checked.' '.$required.'> '.ucfirst($option).'</label> ';
					}
				echo '</div>
				</div>';
			  }
			  elseif($custom_field->type == 'textarea')
			   echo '<textarea class="form-control" data-limit="'.config('config.textarea_limit').'" placeholder="'.$custom_field->title.'" name="'.$custom_field->name.'" cols="30" rows="3" id="'.$custom_field->name.'"'.$required.' data-show-counter=1 data-autoresize=1>'.$c_values.'</textarea><span class="countdown"></span>';
			  else
			  	echo '<input class="form-control '.(($custom_field->type == 'date') ? 'datepicker' : '').'" value="'.$c_values.'" placeholder="'.$custom_field->title.'" name="'.$custom_field->name.'" type="text" value="" id="'.$custom_field->name.'"'.$required.' '.(($custom_field->type == 'date') ? 'readonly' : '').'>';
			  echo '</div>';
			}
        }
        
        public static function getCustomFieldValues($form,$id){
			return DB::table('custom_fields')
			->join('custom_field_values','custom_field_values.field_id','=','custom_fields.id')
			->where('form','=',$form)
			->where('unique_id','=',$id)
			->pluck('value','name');
		}
		public static function translateList($lists){
			
			if(!empty($lists)){
			$translated_list = array();
			foreach($lists as $key => $list)
				$translated_list[$key] = trans('messages.'.$key);

			return $translated_list;
			}
			return array(''=>'');
        }
		
		public static function setPkgConfig($config_vars){
		
				$array['companys']=[];
		foreach($config_vars as $config_var){
				$array['companys']=array('status','enable');
				//config('list.companys.'.$config_var->name)]);
	        }
			//config('list.companys.'.$array);
			Config(['list.companys' , $array]);

	}
        
        public static function setConfig($config_vars){
			
			foreach($config_vars as $config_var){
				config(['config.'.$config_var->name => (isset($config_var->value) 
				&& $config_var->value != '' && $config_var->value != null) ? $config_var->value : 
				config('config.'.$config_var->name)]);
	        }

			config([
            'mail.driver' => ($config_vars->where('name','driver')->first()) ? $config_vars->where('name','driver')->first()->value : '',
            'mail.from.address' => ($config_vars->where('name','from_address')->first()) ? $config_vars->where('name','from_address')->first()->value : '',
            'mail.from.name' => ($config_vars->where('name','from_name')->first()) ? $config_vars->where('name','from_name')->first()->value : '',
            'mail.encryption' => ($config_vars->where('name','encryption')->first()) ? $config_vars->where('name','encryption')->first()->value : ''
            ]);

	        if(config('mail.driver') == 'smtp'){
	            config([
	            'mail.host' => ($config_vars->where('name','host')->first()) ? $config_vars->where('name','host')->first()->value : '',
	            'mail.port' => ($config_vars->where('name','port')->first()) ? $config_vars->where('name','port')->first()->value : '',
	            'mail.username' => ($config_vars->where('name','username')->first()) ? $config_vars->where('name','username')->first()->value : '',
	            'mail.password' => ($config_vars->where('name','password')->first()) ? $config_vars->where('name','password')->first()->value : ''
	            ]);
	        }

			     
	      	        
        }
        
        public static function validateIp(){

			 $ip = \Request::getClientIp();

			$wl_ips = \App\Ip::all();
			$allowedIps = array();
			foreach($wl_ips as $wl_ip){
				if($wl_ip->end)
					$allowedIps[] = $wl_ip->start.'-'.$wl_ip->end;
				else
					$allowedIps[] = $wl_ip->start;
            }
            


			foreach ($allowedIps as $allowedIp) 
	        {
	            if (strpos($allowedIp, '*')) 
	            {
	               $range = [ 
	                    str_replace('*', '0', $allowedIp),
	                    str_replace('*', '255', $allowedIp)
                    ];
                    
                   
	                if(Helper::ipExistsInRange($range, $ip)) return true;
	            } 
	            else if(strpos($allowedIp, '-'))
	            {
	                $range = explode('-', str_replace(' ', '', $allowedIp));
	                if(Helper::ipExistsInRange($range, $ip)) return true;
	            }
	            else 
	            {
	                if (ip2long($allowedIp) === ip2long($ip)) return true;
                }
                
	        }
	        return false;
		}

		public static function ipExistsInRange(array $range, $ip)
	    {
	        if (ip2long($ip) >= ip2long($range[0]) && ip2long($ip) <= ip2long($range[1])) 
	            return true;
	        return false;
		}
		



		public static function getAvatar($id, $size = null){
			$user = \App\AppUser::find($id);
			$profile = $user->Profile;
			$name = ($user->full_name) ? : $user->username;
			$tooltip = $name;
			if($size == null)
				$size = '40px';
			if(isset($user->image))
				return '<img src="/'.config('constants.upload_path.profile_images').$user->image.'" class="wd-40 rounded-circle"  style="width:'.$size.';float:left;" alt="User avatar" data-toggle="tooltip" title="'.$tooltip.'">';
			else 
				return '<div class="wd-40 rounded-circle"  data-toggle="tooltip" title="'.$tooltip.'">'.$name.'</div>';
		}

		public static function verifyCsrf($token){
			if($token == Session::token())
				return 1;
			else
				return 0;
		}




		public static function callCurl($url,$postData){
			$ch = curl_init($url);
	        curl_setopt_array($ch, array(
	            CURLOPT_URL => $url,
	            CURLOPT_RETURNTRANSFER => true,
	            CURLOPT_POST => true,
	            CURLOPT_POSTFIELDS => $postData
	        ));
	        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
	        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);

	        $data = curl_exec($ch);
	        if(curl_errno($ch))
	            return response()->json(['error' => '108']);

	        curl_close($ch);

	        return json_decode($data, true);
		}



		// $nozzle_id=Helper::nozzilCode($station_code);

		public static function nozzilCode($station_code)
		{
		$nozzle_id="NOZZ".$station_code.randomString(4);
		$nozzil = \App\StationNozzle::where('nozzle_id',$nozzle_id)->get()->first();
		if($nozzil){
			Helper::nozzilCode($station_code);
		}else{

			return $nozzle_id;

		}
	}

			public static function sendMsg($to,$message){
			$sms_body=str_replace(" ","%20",$message);
			return $payload = file_get_contents('http://api.msg91.com/api/sendhttp.php?country=91&sender=EVMIND&route=4&mobiles='.$to.'&authkey=250198AYB7KiVGSM715c052062&message='.$sms_body.'');
				
			}



			public static function	sendOrderDetails($user,$transaction){

			$mail['subject'] = ' duration '.date('d-m-Y').' to '.date('d-m-Y');
            $body=$transaction->order_status;

             //$mail['email'] = $user->email;
			$pdf = PDF::loadView('emails.email',compact('body'));
			$mail = array();
			$mail['subject'] = ' duration '.date('d-m-Y').' to '.date('d-m-Y');
			$body=' duration '.date('d-m-Y').' to '.date('d-m-Y');

            $mail['email'] = "eharishwarreddy666@gmail.com";
	   	 	$mail['filename'] = 'charging_history_'.date('d-m-Y').'.pdf';

	   	 	Mail::send('emails.email', compact('body'), function ($message) use($pdf,$mail) {
	   	 		$message->attachData($pdf->output(), $mail['filename']);
	   	 		$message->to($mail['email'])->subject($mail['subject']);
				});
			}



	public static function getUserDetails($users){
		$co='';
		$stat='';
		$cit='';
	  if($users->profile->country_id){$country  =Countrys::where('country_id',$users->profile->country_id)->get()->first();
			if($country){
			  $co=$country->country_name;
		  } }
	  if($users->profile->state_id){$state   =States::where('state_id',$users->profile->state_id)->get()->first(); 
			if($state){
			  $stat=$state->state_name;
		  } }
	  if($users->profile->city_id){$city     =Cities::where('city_id',$users->profile->city_id)->get()->first(); 
			if($city){
			  $cit=$city->city_name;
		  }  }
	   
		 
		$vehicles=AppUserVehicles::where(['app_user_id'=>$users->id,'status'=>1])->get()->first();
		
		return $data=array(
			'status'     =>'success',
			'id'         => $users->id,
			'first_name' => $users->first_name,
			'last_name'  => $users->last_name,
			'email'      => $users->email,
			'mobile'     => $users->mobile,
			'image'      => URL::to('/').'/'.$users->image,
			'dob'        =>  strval($users->dob),
			'mobile'     =>  strval($users->mobile),
			'country_id'    =>   $co,
			'referral_code' =>$users->referral_code,
			'state_id'      =>   $stat,
			'city_id'       =>   $cit,
			'owner_ship' =>   strval($users->profile->owner_ship),
			'address1'   =>  strval($users->profile->address1),
			'address2'   =>  strval($users->profile->address2),
			'pin_code'   =>  strval($users->profile->pin_code),
			'car_capacity'	=>$vehicles->capacity,
			'tag'			=> $users->tag_id,
		  );
	}
 
	}
	
	


?>
