<?php

namespace App\Http\Controllers\Api;

use Illuminate\Http\Request;
use App\AppUser;
use App\Http\Controllers\Controller;
use Validator;
use File;
use App\Countrys;
use App\AppUserVehicles;
use App\States;
use App\Cities;
use \App\Classes\Helper;
use URL;

class AppUserController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */

    public function index()
    {
        //
    }

    public function profile(Request $request){


    $request->user_id;

       $user=AppUser::find($request->user_id);


        if($user){
            $profile=array(
                'id'                =>  strval($user->id),
                'first_name'        =>  strval($user->first_name),
                'last_name'         =>  strval($user->last_name),
                'email'             =>  strval($user->email),
                'dob'               =>  strval($user->dob),
                'mobile'            =>  strval($user->mobile),
                'country_id'        =>  strval($user->profile->country_id),
                'state_id'          =>  strval($user->profile->state_id),
                'city_id'           =>  strval($user->profile->city_id),
                'address1'          =>  strval($user->profile->address1),
                'address2'          =>  strval($user->profile->address2),
            );
            return $profile;
        }else{
            return response()->json(['status'=>'false','message' => 'Details Not Found'], 401); 
        }
     

    }

    public function update(Request $request){


       $validator = Validator::make($request->all(), [ 

           'email'         => 'required|unique:app_users,email,' .$request->user_id.',id',
           'mobile'        => 'required|unique:app_users,mobile,' .$request->user_id.',id',

       ]);
       if ($validator->fails()) { 
        $message=$validator->errors()->first();
           return response()->json(['status'=>'false',"message"=>$message], 401);
       }
       $app_user=AppUser::find($request->user_id);
           $app_user->first_name             =   $request->first_name;
           $app_user->email                  =   $request->email;
           $app_user->mobile                 =   $request->mobile;
           $app_user->dob                    =   $request->dob;

           //return $app_user;
           $app_user->save();

           $users=AppUser::find($request->user_id);
          $data=Helper::getUserDetails($users);
 
          return response()->json($data, 200); 

    }



    public function updateProfilePic(Request $request){

        //return $request;
                  $app_user=AppUser::find($request->user_id);

                $path = "uploads/app_users/profile_images";
                $image_path=str_replace("/", "\\", $app_user->image);

                $old_image=$app_user->image;

               $image_pat=$path.'/'.$image_path;
                

                
                 if(!is_dir($path)) { mkdir($path, 0777, true); } 
                 $c=0;$imagepath='';$sp=1;
                 $image=$request->image;
          
                 $image_data = base64_decode(preg_replace('#^data:image/\w+;base64,#i', '', $image));
                 $tmpFilePath=sys_get_temp_dir().'/'.uniqid(); 
                 file_put_contents($tmpFilePath, $image_data); 
                 $f = finfo_open();
                 $mime_type = finfo_buffer($f, $image_data, FILEINFO_MIME_TYPE);
                 $imageName = str_replace(" ","_",$app_user->first_name).'_'.'profile'.'_'.time().'.png';
               
                 $fp = fopen($path.'/'.$imageName, 'wb');
                 fwrite($fp, $image_data);
                 fclose($fp);

               $app_user->image='uploads/app_users/profile_images/'.$imageName;
               $app_user->save();

               if($old_image!='uploads/avatar.png'){
               
                if(File::exists($image_pat)) {
                   File::delete($image_pat);
                }
            }
               
              
           $users=AppUser::find($request->user_id);
           $data=Helper::getUserDetails($users);
 
          return response()->json($data, 200);

             
               //return response()->json(['status'=>'false','message' => 'Something Went Wrong'], 401); 
  
            }




    public function updatePassword(Request $request){


         $user=AppUser::find($request->user_id);

         $user->password=bcrypt($request->password);
         $user->save();

        //  $template = \App\Template::whereCategory('password_reset')->first();

        //  $mail = array();
        //  if(!$template){
        //  } else {
        //      $body = $template->body;
        //      $body = str_replace('[NAME]',$user->full_name,$body);
        //      $mail['email'] = $user->email;
        //      $mail['subject'] = $template->subject;
        //      $blade="welcome_mail";
 
           
        //      $status =Helper::sendMails($template->name,$user->email,$mail['subject'],$blade,$body);
            
        //  }   
         return response()->json(['status'=>'true','message' => "Password Changed Successfully"],201); 

    }

	 public function updateSecure(Request $request){


       $validator = Validator::make($request->all(), [ 

          // 'email'         => 'required|unique:app_users,email,' .$request->user_id.',id',
          // 'mobile'        => 'required|unique:app_users,mobile,' .$request->user_id.',id',

       ]);
       if ($validator->fails()) { 
        $message=$validator->errors()->first();
           return response()->json(['status'=>'false',"message"=>$message], 401);
       }
       $app_user=AppUser::find($request->user_id);
	   $vehicles=AppUserVehicles::where(['app_user_id'=>$request->user_id,'status'=>1])->get()->first();

           $app_user->first_name             =   $request->first_name;
           $app_user->email                  =   $request->email;
           $app_user->mobile                 =   $request->mobile;
           $app_user->dob                    =   $request->dob;

           //return $app_user;
           $app_user->save();

           $users=AppUser::find($request->user_id);
           $data=Helper::getUserDetails($users);

 
          return response()->json($data, 200); 

    }
	
	

    public function updateProfilePicSecure(Request $request){

        //return $request;
                  $app_user=AppUser::find($request->user_id);

                $path = "uploads/app_users/profile_images";
                $image_path=str_replace("/", "\\", $app_user->image);
                $old_image=$app_user->image;

               $image_pat=$path.'/'.$image_path;
                

                
                 if(!is_dir($path)) { mkdir($path, 0777, true); } 
                 $c=0;$imagepath='';$sp=1;
                 $image=$request->image;
          
                 $image_data = base64_decode(preg_replace('#^data:image/\w+;base64,#i', '', $image));
                 $tmpFilePath=sys_get_temp_dir().'/'.uniqid(); 
                 file_put_contents($tmpFilePath, $image_data); 
                 $f = finfo_open();
                 $mime_type = finfo_buffer($f, $image_data, FILEINFO_MIME_TYPE);
                 $imageName = str_replace(" ","_",$app_user->first_name).'_'.'profile'.'_'.time().'.png';
               
                 $fp = fopen($path.'/'.$imageName, 'wb');
                 fwrite($fp, $image_data);
                 fclose($fp);

            //    $image_path =$app_user->image;  // Value is not URL but directory file path
               $app_user->image='uploads/app_users/profile_images/'.$imageName;
               $app_user->save();

               if($old_image!='uploads/avatar.png'){
               
                if(File::exists($image_pat)) {
                   File::delete($image_pat);
                }
            }
           $users=AppUser::find($request->user_id);
           $data=Helper::getUserDetails($users);
          return response()->json($data, 200);

      
            }




    public function updatePasswordSecure(Request $request){


         $user=AppUser::find($request->user_id);

         $user->password=bcrypt($request->password);
         $user->save();
  
         return response()->json(['status'=>'true','message' => "Password Changed Successfully"],201); 

    }

            
public function removeProfileImage(Request $request){
    
        $app_user=AppUser::find($request->user_id);

        if($app_user->image!='uploads/avatar.png'){

        $path = "uploads/app_users/profile_images";
       
        $image_pat=public_path().'/'.$path.'/'.$app_user->image;

        $app_user->image='uploads/avatar.png';
        $app_user->save();

        if(File::exists($image_pat)) {
           File::delete($image_pat);
          // File::delete(base_path()."/..".$user->userInfo->photo);
        }

    }
  
        $users=AppUser::find($request->user_id);
        $data=Helper::getUserDetails($users);
       return response()->json($data, 200);

        // return response()->json(['status'=>'true','message' => "Password Changed Successfully"],201); 

}

}
