<?php

namespace App\Http\Controllers\API;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;

use App\ChargingHistory;
use DB;
use App\Transaction;

class ChargingController extends Controller
{
    public function startCharging(Request $request){

      

        return response()->json(['status'=>'true'], 200); 

    }



    public function storeChargingHistory(Request $request){


       try {
            
            $ocpp_details = \App\StationNozzle::whereNozzleId($request->ocpp_id)->get()->first();
            $price  =  $ocpp_details->price;
            $station_details = \App\Station::whereStationId($request->station_id)->get()->first();
            $taxes=json_decode($station_details->service_tax);

            $app_user_id    =  $request->user_id;
            $charging_id    =  $request->transaction_id;
            $station_id     =  $request->station_id;
            $nozzle_id      =  $request->ocpp_id;
            $charger_id     =  $request->charger_id;
            $plug_in_time   =  $request->starting_time;
            $plug_out_time  =  $request->ending_time;
            $starting_meter =  $request->starting_meter;
            $ending_meter                   =  $request->ending_meter;
            $user_charging_transaction_id   =  $request->user_transaction_id;



            

           $watts = $ending_meter-$starting_meter;
           $usage= floatval($watts)/1000;
           $base_fare= floatval($price)*floatval($usage);
           $service_tax=0;
           $gst=array();
            if($taxes){
            foreach ($taxes as $key => $value) {
            if($value->value){
                    $tax=$value->value;
                    $service_tax=floatval($service_tax)+(($base_fare*floatval($tax))/100);
                     $gst[ $value->name]=number_format(floatval(($base_fare*floatval($tax))/100),2);
                    }
                }
            }
        // $total_fare=$base_fare+$service_tax;
        $total_fare=$base_fare;
        $starting_time= date('d-m-Y h:i:s',strtotime($plug_in_time));
        $ending_time=   date('d-m-Y h:i:s',strtotime($plug_out_time));

       // return  strtotime($charging_id);

        DB::beginTransaction();

        $trans_Id=$this->generateTransactionNumber();
        $transaction=new Transaction;
		$transaction->trans_id			= $trans_Id;
		$transaction->app_user_id		= $app_user_id;
		$transaction->order_id			= $charging_id;
		$transaction->amount			= $total_fare;
		$transaction->currency			= "INR";
        $transaction->order_status		= "success";
        $transaction->type		        = "Cash";
		$transaction->ocpp_id			= $nozzle_id;
		$transaction->charger_id		= $charger_id;
		$transaction->station_id		= $station_id;
	    $transaction->mer_amount		= $base_fare;
		$transaction->discount_value	= 0.00;
		$transaction->transaction_date = date('Y-m-d');
		$transaction->transaction_time = date('h:i:s');
        $transaction->save();
        
        $charge=new ChargingHistory;
        $charge->charging_id     = $charging_id;
        $charge->app_user_id     = $app_user_id;
        $charge->transaction_id  = $trans_Id;
        $charge->station_id      = $station_id ;
        $charge->nozzle_id       = $nozzle_id  ;
        $charge->charger_id      = $charger_id;
        $charge->power_usage                      = $usage;
        $charge->user_charging_transaction_id     = $user_charging_transaction_id;
        $charge->starting_meter                   = $starting_meter ;
        $charge->ending_meter    = $ending_meter ;
        $charge->plug_in_time    = $plug_in_time;
        $charge->plug_out_time   = $plug_out_time;
        $charge->service_tax     = json_encode($gst);
        $charge->base_fare       = $base_fare;
        $charge->amount          = $total_fare;
        $charge->save();
           DB::commit(); 
           return response()->json(['status'=>'true','message'=>'Success'], 401); 

       } catch (\Exception $e) {

           DB::rollBack();
          \Log::error("File:" . $e->getFile(). " Line:" . $e->getLine(). " Message:" . $e->getMessage());
          return response()->json(['status'=>'false','message'=>'Something Went Wrong'], 401); 
      }


    }

    function generateTransactionNumber() {
        $number = mt_rand(1000000000, 9999999999); // better than rand()
    
        // call the same function if the barcode exists already
        if ($this->transactionNumberExists($number)) {
            return generateTransactionNumber();
        }
    
        // otherwise, it's valid and can be used
        return $number;
    }
    
    function transactionNumberExists($number) {
        // query the database and return a boolean
        // for instance, it might look like this in Laravel
        return Transaction::whereTransId($number)->exists();
    }


    function generatOrderNumber() {
        $number = mt_rand(1000000000, 9999999999); // better than rand()
    
        // call the same function if the barcode exists already
        if (OrderNumberExists($number)) {
            return generatOrderNumber();
        }
    
        // otherwise, it's valid and can be used
        return $number;
    }
    
    function OrderNumberExists($number) {
        // query the database and return a boolean
        // for instance, it might look like this in Laravel
        return Transaction::whereOrderId($number)->exists();
    }

    



}
