<?php 
namespace App\Http\Controllers\API;

use Illuminate\Http\Request;
use App\Http\Controllers\API\BaseController as BaseController;
use App\AppUser;
use App\Station;
use Illuminate\Support\Facades\Auth;
use Validator;
use Carbon\Carbon;
use App\Classes\Helper;
use Mail;
use DB;
use App\States;
use App\Cities;

class DashboardController extends BaseController

{
    public function index(){

     $dashboard=array();
     $station=Station::select("station_id","station_name","status","latitude","longitude")->get();
      return $station;
    }

        public function  getStateList(Request $request){
         
            $iddd=$request->country_id;

          $id=str_replace('"','',$iddd);
            if(empty($id)){
               $states=States::select('state_id','state_name')->get();

            }else{
                $states=States::select('state_id','state_name')->where(['country_id'=>$id])->get();
            }
        $states_list=array();

                foreach($states as $state){

                    $one=array(
                        'state_id'          =>  strval($state->state_id),
                        'state_name'        =>  $state->state_name
                    );
                    array_push($states_list,$one);
                    
                }
                return $states_list;
            
        }

        public function getCities(Request $request){

            $iddd=$request->state_id;
            $id=str_replace('"','',$iddd);
            if(!empty($id)){
                
                $cities=Cities::select('city_name','city_id')->where(['state_id'=>$id])->get();

                $cities_list=array();

                foreach($cities as $city){

                    $one=array(
                        'city_id'          =>  strval($city->city_id),
                        'city_name'        =>  $city->city_name
                    );
                    array_push($cities_list,$one);
                    
                }
                return $cities_list;
            }else{
                return response()->json(['status'=>'false',"message"=>"Cities Not Found"], 401);
            }

           
        }



     public function points(Request $request){
        $data='Nothing Found';
        $latitude           =   $request->lat;
        $longitude          =   $request->lng;
        $range              =   $request->radius;
		$car_capacity		=   $request->car_capacity;
		
		
		$capacity=str_replace('KWT','',$car_capacity);



        if(isset($request->data)&&!empty($request->data)){

           // \Log::info($request->all());
           // \Log::info('event', 'User sent out 2 emails.');
            $filter=json_decode($request->data);

            $citygfgf              =    str_replace('[','',$filter[0]->city1);

            $cityi                 =    str_replace(']','',$citygfgf);

          


            $fruits_ar = explode(', ', $cityi);
            $city2              =   $filter[0]->city2;
            $chademo            =   $filter[0]->chademo;
            $gb                 =   $filter[0]->gbt;
            $css                =   $filter[0]->css;
            $type               =   $filter[0]->TYPE;
            $usage              =   $filter[0]->Uses;
			$car_capacity		=   $filter[0]->car_capacity;
			
			$capacity=str_replace('KWT','',$car_capacity);
			
			
			// $city=array();
			$usages=array();
			$connections=array();
			// if(!empty($city1)){
			// 	array_push($city, $city1);
			// }
			// if(!empty($city2)){
			// 	array_push($city, $city2);
			// }
			
			if(!empty($usage)){
				array_push($usages, $usage);
			}
			
			
			if(!empty($chademo)){
				array_push($connections, $chademo);
			}
			if(!empty($gb)){
				array_push($connections, $gb);
			}
			if(!empty($type)){
				array_push($connections, $type);
			}
			if(!empty($css)){
				array_push($connections, $css);
			}

			$data=DB::table('stations')->select("stations.station_id","latitude","longitude",'station_name','stations.status','stations.opening_time','stations.closing_time')
               ->leftjoin('station_nozzles','station_nozzles.station_id','=','stations.station_id');
			   //->where('station_nozzles.power_rating',$capacity);
               if($fruits_ar){
                // $fruits_ar = explode(', ', $city1);
                $data->wherein('city_id',$fruits_ar);
               }
               if($usages){
                $data->wherein('stations.status',$usages);
               }
               if($connections){
                $data->wherein('station_nozzles.type',$connections);
               }
              return $data->distinct('stations.station_id')->get();
    } 
	    if(!empty($latitude)&&!empty($longitude)&&!empty($range)){
		
       $data=DB::table("stations")
        ->select("stations.station_id","stations.latitude","stations.longitude",'stations.station_name','stations.status','stations.opening_time','stations.closing_time'
            ,DB::raw("6367 * acos(cos(radians(" . $latitude . ")) 
            * cos(radians(stations.latitude)) 
            * cos(radians(stations.longitude) - radians(" . $longitude . ")) 
            + sin(radians(" .$latitude. ")) 
            * sin(radians(stations.latitude))) AS distance "))
            ->having('distance', '<', $range)
			->join('station_nozzles','station_nozzles.station_id','=','stations.station_id')
			//->where('station_nozzles.power_rating',$capacity)
            ->orderBy('distance')
            ->get();
    
        }
    return json_encode($data);    
    
    }


}