<?php 
namespace App\Http\Controllers\API;

use Illuminate\Http\Request;
use App\Http\Controllers\API\BaseController as BaseController;
use App\AppUser;
use App\PasswordReset;
use Illuminate\Support\Facades\Auth;
use Validator;
use Swift_Mailer;
use Swift_Message;
use Carbon\Carbon;
use Swift_SmtpTransport;
use App\Notifications\PasswordResetRequest;
use App\Notifications\PasswordResetSuccess;
use Illuminate\Notifications\Messages\MailMessage;
use App\Classes\Helper;
use Mail;
class ForgotPassword extends BaseController

{
    public $successStatus=200;


    public function forgotpassword(Request $request){

      $mobile_email=$request->mobile_email;

         $user = AppUser::where('mobile', $mobile_email)->first();
        if ($user){
        $otp= $this->generateotp(6);
        $user->otp=$otp;
        $user->save();

          if($user->package_name=="plugngo"){
            $app="PlugNgo";
            }else{
            $app="REIL";
            }
        $messages="One Time Password to change password of ".$app." User Account is ".$otp." Please use the Code to Reset password. Please do not share this with any one";

        $status= Helper::sendMsg($mobile_email,$messages);


    //   $template = \App\Template::whereCategory('otp_email')->first();

    //     $mail = array();
    //     if(!$template){
    //         // $body = 'Welcome Mail';
    //     } else {
    //         // $template = \App\Template::whereCategory('welcome_email')->first();
    //         $body = $template->body;
    //         $body = str_replace('[NAME]',$user->full_name,$body);
    //         $body = str_replace('[OTP]',$otp,$body);
    //         $mail['email'] = $user->email;
    //         $mail['subject'] = $template->subject;
    //         $blade="welcome_mail";
    //         $status =Helper::sendMails($template->name,$user->email,$mail['subject'],$blade,$body);
    //         return response()->json(['status'=>'true','message' => "Successfully Sended Otp",'mobile'=>$user->mobile], $this-> successStatus); 
    //     }    
        
        return response()->json(['status'=>'true','message' => "OTP Sent Successfully",'mobile'=>$user->mobile], $this-> successStatus); 


        }
            return response()->json(['status'=>'false','message' => 'Details Not Found'], 401); 

        }

        public function ConfirmOtp(Request $request){

            if(empty($request->mobile)){
                return response()->json(['status'=>'false','message' => 'Mobile Required.' ], 404);
            }
            if(empty($request->otp)){
                return response()->json(['status'=>'false','message' => 'Otp Required.' ], 404);
            }
            $user = AppUser::where(['mobile'=>$request->mobile])->get()->first();
            if(!$user){
                return response()->json(['status'=>'false','message' => 'Mobile Not Found.' ], 404);
            }
    
           $user = AppUser::where(['mobile'=>$request->mobile,'otp'=>$request->otp])->get()->first();
           if($user){
            return response()->json(['status'=>'true','message' =>'Successfully Verified','mobile'=>$request->mobile], 201);
           }else{
            return response()->json(['status'=>'false','message' => 'This OTP is invalid.' ], 404);
           }


        //    $url='';
        //    $title="Success";
        //    $status =Helper::sendMails($user->email,$subject,$user->name,$url,$blade);

        }

        public function UpdatePassword(Request $request)
        {
            $validator = Validator::make($request->all(), [ 
                'mobile' => 'required|string', 
                'password' => 'required|string', 
            ]);

            if ($validator->fails()) { 
                $message=$validator->errors()->first();
                return response()->json(['status'=>'false',"message"=>$message,'mobile'=>$user->mobile], 401);          
            }


            $user = AppUser::where(['mobile'=>$request->mobile])->first();
            if ($user){
                $user->password=bcrypt($request->password);
                $user->otp='';
                $user->save();


                $messages="Your password has been successfully reset. For further issues Contact to support";

                $status= Helper::sendMsg($user->mobile,$messages);

                return response()->json(['status'=>'true','message' => "Password Changed Successfully"], $this-> successStatus); 
        
                }
                    return response()->json(['status'=>'false','message' => 'Details Not Found'], 401); 
        
                }


        



        function generateotp($len) {
            $result = '';
            for($i = 0; $i < $len; $i++) {
            $result .= mt_rand(0, 9);
            }
            return $result;
            }
            
        




    /**
     * Create token password reset
     *
     * @param  [string] email
     * @return [string] message
     */
    public function create(Request $request)
    {
        $request->validate([
            'email' => 'required|string|email',
        ]);
        $user = AppUser::where('email', $request->email)->first();
        if (!$user)
            return response()->json([ 'message' => 'We cant find a user with that e-mail address.'
            ], 404);
        $passwordReset = PasswordReset::updateOrCreate(
            ['email' => $user->email],
            [
                'email' => $user->email,
                'token' => str_random(60)
             ]
        );
        if ($user && $passwordReset)

        $subject="Reset Password";
        $blade="pass";

          $url= url('/api/password/find/'.$passwordReset->token);


           $status =Helper::sendMails($user->email,$subject,$user->name,$url,$blade);


           if($status==1){
            return response()->json(['success' => "We have e-mailed your password reset link!"], $this-> successStatus);
           }else{
            return response()->json(['error' => 'Something Went Wrong'], 401); 
           }
        
    }
    /**
     * Find token password reset
     *
     * @param  [string] $token
     * @return [string] message
     * @return [json] passwordReset object
     */
    public function find($token)
    {
        $passwordReset = PasswordReset::where('token', $token)
            ->first();
        if (!$passwordReset)
            return response()->json([
                'message' => 'This password reset token is invalid.'
            ], 404);
        if (Carbon::parse($passwordReset->updated_at)->addMinutes(720)->isPast()) {
            $passwordReset->delete();
            return response()->json([
                'message' => 'This password reset token is invalid.'
            ], 404);
        }
        $title="Reset Password";
        return view('auth.passwords.reset',compact('passwordReset','title'));

        
        //return response()->json($passwordReset);
    }
     /**
     * Reset password
     *
     * @param  [string] email
     * @param  [string] password
     * @param  [string] password_confirmation
     * @param  [string] token
     * @return [string] message
     * @return [json] user object
     */
    public function reset(Request $request)
    {

        
         $validator = Validator::make($request->all(), [ 
            'email' => 'required|string|email', 
            'password' => 'required|string', 
            'confirmed' => 'required|string|same:password', 
            'token' => 'required|string'
        ]);
        if ($validator->fails()) { 
            return view('auth.passwords.reset',$validator->errors());            
        }
        $passwordReset = PasswordReset::where([
            ['token', $request->token],
            ['email', $request->email]
        ])->first();
        if (!$passwordReset)
            return response()->json([
                'message' => 'This password reset token is invalid.'
            ], 404);
        $user = AppUser::where('email', $passwordReset->email)->first();
        if (!$user)
            return response()->json([
                'message' => 'We cant find a user with that e-mail address.'
            ], 404);
        $user->password = bcrypt($request->password);
        $user->save();
        $passwordReset->delete();
        $subject='Successfully Password Changed';
        $blade="pass_success";
        //$user->notify(new PasswordResetSuccess($passwordReset));
        $url='';
        $title="Success";
        $status =Helper::sendMails($user->email,$subject,$user->name,$url,$blade);
        return view('auth.success',compact('title'));
    }
	
	
	//secure api calls
	
	
	
	public function forgotpasswordSecure(Request $request){

      $mobile_email=base64_decode($request->mobile_email);

         $user = AppUser::where('mobile', $mobile_email)->first();
        if ($user){
        $otp= $this->generateotp(6);
        $user->otp=$otp;
        $user->save();

          if($user->package_name=="plugngo"){
            $app="PlugNgo";
            }else{
            $app="REIL";
            }
        $messages="One Time Password to change password of ".$app." User Account is ".$otp." Please use the Code to Reset password. Please do not share this with any one";

        $status= Helper::sendMsg($mobile_email,$messages);


    //   $template = \App\Template::whereCategory('otp_email')->first();

    //     $mail = array();
    //     if(!$template){
    //         // $body = 'Welcome Mail';
    //     } else {
    //         // $template = \App\Template::whereCategory('welcome_email')->first();
    //         $body = $template->body;
    //         $body = str_replace('[NAME]',$user->full_name,$body);
    //         $body = str_replace('[OTP]',$otp,$body);
    //         $mail['email'] = $user->email;
    //         $mail['subject'] = $template->subject;
    //         $blade="welcome_mail";
    //         $status =Helper::sendMails($template->name,$user->email,$mail['subject'],$blade,$body);
    //         return response()->json(['status'=>'true','message' => "Successfully Sended Otp",'mobile'=>$user->mobile], $this-> successStatus); 
    //     }    
        
        return response()->json(['status'=>'true','message' => "OTP Sent Successfully",'mobile'=>base64_encode($user->mobile)], $this-> successStatus); 


        }
            return response()->json(['status'=>'false','message' => 'Details Not Found'], 401); 

        }

        public function ConfirmOtpSecure(Request $request){

            if(empty($request->mobile)){
                return response()->json(['status'=>'false','message' => 'Mobile Required.', 'mobile'=>''], 404);
            }
            if(empty($request->otp)){
                return response()->json(['status'=>'false','message' => 'Otp Required.' , 'mobile'=>''], 404);
            }
            $user = AppUser::where(['mobile'=>base64_decode($request->mobile)])->get()->first();
            if(!$user){
                return response()->json(['status'=>'false','message' => 'Mobile Not Found.' , 'mobile'=>''], 404);
            }
    
           $user = AppUser::where(['mobile'=>base64_decode($request->mobile),'otp'=>base64_decode($request->otp)])->get()->first();
           if($user){
            return response()->json(['status'=>'true','message' =>'Successfully Verified','mobile'=>base64_encode($user->mobile)], 200);
           }else{
            return response()->json(['status'=>'false','message' => 'This OTP is invalid.','mobile'=>'' ], 404);
           }


        //    $url='';
        //    $title="Success";
        //    $status =Helper::sendMails($user->email,$subject,$user->name,$url,$blade);

        }

        public function UpdatePasswordSecure(Request $request)
        {
           
	
            $user = AppUser::where(['mobile'=>base64_decode($request->mobile)])->first();
            if ($user){
                $user->password=bcrypt(base64_decode($request->password));
                $user->otp='';
                $user->save();


                $messages="Your password has been successfully reset. For further issues Contact to support";

                $status= Helper::sendMsg($user->mobile,$messages);

                return response()->json(['status'=>'true','message' => "Password Changed Successfully",'mobile'=>''], $this-> successStatus); 
        
                }
                    return response()->json(['status'=>'false','message' => 'Details Not Found','mobile'=>''], 401); 
        
                }


        




    /**
     * Create token password reset
     *
     * @param  [string] email
     * @return [string] message
     */
    public function createSecure(Request $request)
    {
        $request->validate([
            'email' => 'required|string|email',
        ]);
        $user = AppUser::where('email', $request->email)->first();
        if (!$user)
            return response()->json([ 'message' => 'We cant find a user with that e-mail address.'
            ], 404);
        $passwordReset = PasswordReset::updateOrCreate(
            ['email' => $user->email],
            [
                'email' => $user->email,
                'token' => str_random(60)
             ]
        );
        if ($user && $passwordReset)

        $subject="Reset Password";
        $blade="pass";

          $url= url('/api/password/find/'.$passwordReset->token);


           $status =Helper::sendMails($user->email,$subject,$user->name,$url,$blade);


           if($status==1){
            return response()->json(['success' => "We have e-mailed your password reset link!"], $this-> successStatus);
           }else{
            return response()->json(['error' => 'Something Went Wrong'], 401); 
           }
        
    }
    /**
     * Find token password reset
     *
     * @param  [string] $token
     * @return [string] message
     * @return [json] passwordReset object
     */
    public function findSecure($token)
    {
        $passwordReset = PasswordReset::where('token', $token)
            ->first();
        if (!$passwordReset)
            return response()->json([
                'message' => 'This password reset token is invalid.'
            ], 404);
        if (Carbon::parse($passwordReset->updated_at)->addMinutes(720)->isPast()) {
            $passwordReset->delete();
            return response()->json([
                'message' => 'This password reset token is invalid.'
            ], 404);
        }
        $title="Reset Password";
        return view('auth.passwords.reset',compact('passwordReset','title'));

        
        //return response()->json($passwordReset);
    }
     /**
     * Reset password
     *
     * @param  [string] email
     * @param  [string] password
     * @param  [string] password_confirmation
     * @param  [string] token
     * @return [string] message
     * @return [json] user object
     */
    public function resetSecure(Request $request)
    {

        
         $validator = Validator::make($request->all(), [ 
            'email' => 'required|string|email', 
            'password' => 'required|string', 
            'confirmed' => 'required|string|same:password', 
            'token' => 'required|string'
        ]);
        if ($validator->fails()) { 
            return view('auth.passwords.reset',$validator->errors());            
        }
        $passwordReset = PasswordReset::where([
            ['token', $request->token],
            ['email', $request->email]
        ])->first();
        if (!$passwordReset)
            return response()->json([
                'message' => 'This password reset token is invalid.'
            ], 404);
        $user = AppUser::where('email', $passwordReset->email)->first();
        if (!$user)
            return response()->json([
                'message' => 'We cant find a user with that e-mail address.'
            ], 404);
        $user->password = bcrypt($request->password);
        $user->save();
        $passwordReset->delete();
        $subject='Successfully Password Changed';
        $blade="pass_success";
        //$user->notify(new PasswordResetSuccess($passwordReset));
        $url='';
        $title="Success";
        $status =Helper::sendMails($user->email,$subject,$user->name,$url,$blade);
        return view('auth.success',compact('title'));
    }

}




