<?php

namespace App\Http\Controllers\API;
use App\Http\Controllers\Controller;
use DB;
use Log;
use Auth;
use Mail;
use PDF;
use Illuminate\Http\Request;
use App\Classes\Helper;
use App\Transaction;

use App\AppUser;

class Payments extends Controller
{

	protected $workingKey;
	protected $accessCode;
	protected $merchantId;
	protected $redirectUrl;
	protected $cancelUrl;

    public function __construct()
    {
		$this->merchantId = env('MERCHANT_ID',"210129");
		$this->workingKey = "44376F0DF81B407A947EBB2E1DA7CB31";    	
		$this->accessCode = "AVZZ84GC11BN94ZZNB";    	
		$this->redirectUrl = env('REDIRECT_URL',"payment/success");
		$this->cancelUrl = env('CANCEL_URL',"payment/success");
    }

   

   

	public function paymentResponse()
	{
	
    	if(empty($_POST["encResp"]) or empty($_POST['orderNo']))
    	{
    		return "Oops. Payment Failed. Please try again";
    	}
    	
    	$encResponse=$_POST["encResp"];			//This is the response sent by the CCAvenue Server
	    $rcvdString=$this->decrypt($encResponse,$this->workingKey);	//Crypto Decryption used as per the specified working key.
		$order_status="";
		$decryptValues=explode('&', $rcvdString);
		$dataSize=sizeof($decryptValues);

		

		for($i = 0; $i < $dataSize; $i++) 
		{
			$information=explode('=',$decryptValues[$i]);
			if($i==3)	
				$order_status=$information[1];
			switch ($information[0]) {
				case "merchant_param1":
					$ocpp_id = explode("-", $information[1]);
					break;
				case "merchant_param2":
					$charger_id = explode("-", $information[1]);
					break;
				case "merchant_param3":
					$station_id = explode("-", $information[1]);
					break;
				case "merchant_param4":
					$app_user_id = explode("-", $information[1]);
					break;
				case "mer_amount":
					$mer_amount = explode("-", $information[1]);
					break;
				case "discount_value":
					$discount_value = explode("-", $information[1]);
					break;
				case "tracking_id":
					$tracking_id = explode("-", $information[1]);
					break;
				case "order_id":
					$order_id = explode("-", $information[1]);
					break;

				case "amount":
					$amount = explode("-", $information[1]);
					break;
				case "currency":
					$currency = explode("-", $information[1]);
					break;
				case "bank_ref_no":
					$bank_ref_no = explode("-", $information[1]);
					break;
				case "payment_mode":
					$payment_mode = explode("-", $information[1]);
					break;
				case "trans_date":
					$trans_date = explode("-", $information[1]);
					break;
				case "currency":
					$currency = explode("-", $information[1]);
					break;
						
					
					
					
			}
				}	
		if($order_status === "Success"){
			$transaction=new Transaction;
			$transaction->trans_id			=$tracking_id[0];
			$transaction->app_user_id		=$app_user_id[0];
			$transaction->order_id			=$order_id[0];
			$transaction->amount			=$amount[0];
			$transaction->currency			=$currency[0];
			$transaction->order_status		=$order_status;
			$transaction->ocpp_id			=$ocpp_id[0];
			$transaction->charger_id		=$charger_id[0];
			$transaction->station_id		=$station_id[0];
			$transaction->mer_amount		=$mer_amount[0];
			$transaction->discount_value	=$discount_value[0];
			$transaction->transaction_date=date('Y-m-d');
			$transaction->transaction_time=date('h:i:s');
			$transaction->currency			=$currency[0];
			
			$transaction->save();
		    $user=AppUser::find($app_user_id[0]);
			
			
		$payment_mode=$payment_mode[0];
		$bank_ref_no=$bank_ref_no[0];
		$order_id=$order_id[0];
		$amount=$amount[0];
		$station_id=$station_id[0];
		$ocpp_id=$ocpp_id[0];
		$app_user_id=$app_user_id[0];
		$charger_id=$charger_id[0];
		$tracking_id=$tracking_id[0];
		$order_status=$order_status;
			
		$pdf = PDF::loadView('emails.payment_status_pdf',compact('order_status','payment_mode','bank_ref_no','order_id','amount','tracking_id'));
		$mail = array();
		$mail['subject'] = 'Payment Status';

            $mail['email'] = "eharishwarreddy666@gmail.com";
	   	 	$mail['filename'] = 'charging_history_'.date('d-m-Y').'.pdf';

	   	 	\Mail::send('emails.payment_success',compact('station_id','ocpp_id','charger_id','app_user_id','order_status','payment_mode','bank_ref_no','order_id','amount','tracking_id'), function ($message) use($pdf,$mail) {
	   	 		$message->attachData($pdf->output(), $mail['filename']);
	   	 		$message->to($mail['email'])->subject($mail['subject']);
	  	 	});
	  	
		return view('emails.payment_success',compact('station_id','ocpp_id','charger_id','app_user_id','order_status','payment_mode','bank_ref_no','order_id','amount','tracking_id'));
		}
		else if($order_status==="Aborted")
		{
		echo "<br>Thank you for shopping with us.We will keep you posted regarding the status of your order through e-mail";
				
		$payment_mode=$payment_mode[0];
		$bank_ref_no=$bank_ref_no[0];
		$order_id=$order_id[0];
		$amount=$amount[0];
		$station_id=$station_id[0];
		$ocpp_id=$ocpp_id[0];
		$app_user_id=$app_user_id[0];
		$charger_id=$charger_id[0];
		$tracking_id=$tracking_id[0];
		$order_status=$order_status;
		
		return view('emails.payment_success',compact('station_id','ocpp_id','charger_id','app_user_id','order_status','payment_mode','bank_ref_no','order_id','amount','tracking_id'));

		}
		else if($order_status==="Failure")
		{
		echo "<br>Thank you for shopping with us.However,the transaction has been declined.";
		}
		else
		{
		echo "<br>Security Error. Illegal access detected";
		
		echo json_encode($decryptValues);
	
		}
					
			///return "something Went Wrong";
		
	}
	
	

function encrypt($plainText,$key)
    {
        $encryptionMethod = "AES-128-CBC";
        $secretKey =  $this->hextobin(md5($key));
        $initVector = pack("C*", 0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07, 0x08, 0x09, 0x0a, 0x0b, 0x0c, 0x0d, 0x0e, 0x0f);
        $encryptedText = openssl_encrypt($plainText, $encryptionMethod, $secretKey, OPENSSL_RAW_DATA, $initVector);
        return bin2hex($encryptedText);
    }

    function decrypt($encryptedText,$key)
    {
        $encryptionMethod     = "AES-128-CBC";
        $secretKey         =  $this->hextobin(md5($key));
        $initVector         =  pack("C*", 0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07, 0x08, 0x09, 0x0a, 0x0b, 0x0c, 0x0d, 0x0e, 0x0f);
        $encryptedText      =  $this->hextobin($encryptedText);
        $decryptedText         =  openssl_decrypt($encryptedText, $encryptionMethod, $secretKey, OPENSSL_RAW_DATA, $initVector);
        return $decryptedText;
    }

    function pkcs5_pad ($plainText, $blockSize)
    {
        $pad = $blockSize - (strlen($plainText) % $blockSize);
        return $plainText . str_repeat(chr($pad), $pad);
    }

    function hextobin($hexString) 
    { 
        $length = strlen($hexString); 
        $binString="";   
        $count=0; 
        while($count<$length) 
        {       
            $subString =substr($hexString,$count,2);           
            $packedString = pack("H*",$subString); 
            if ($count==0)
            {
                $binString=$packedString;
            }else 
            {
                $binString.=$packedString;
            }   
            $count+=2; 
        } 
        return $binString; 
    }
}
