<?php 
namespace App\Http\Controllers\API;

use Illuminate\Http\Request;
use App\Http\Controllers\API\BaseController as BaseController;
use App\AppUser;
use App\AppUserVehicles;
use App\AppUserProfile;
use Illuminate\Support\Facades\Auth;
use Validator;
use DB;
use URL;
use App\Countrys;
use App\States;
use App\Cities;
use App\Classes\Helper;
use App\Years;
use Wallet;
class SecureLogin extends BaseController

{
   public $successStatus=200;



   public function checkMobile(Request $request)
   {
        $mobile_email=$request->mobile_email;

         if ($this->match($mobile_email)==0) { 
              return response()->json(['status'=>'false',"message"=>"please Enter Valid Mobile Format"], 401);
          }     
        $users=AppUser::Where('mobile',$mobile_email)->first();
        if($users){ 
          return response()->json(['status'=>'false','message'=>"This Mobile Already Exist"], 401); 
          }
          return response()->json(['status'=>'true','message'=>"This Mobile Not Exist"], 200); 

    
  }

  public static function match($val)
  {
    return preg_match("/^([6-9]){1}[0-9]{9}$/", $val);
  }
  
  
  public function random_number($size = 4)
{
    $random_number='';
    $count=0;
    while ($count < $size ) 
        {
            $random_digit = mt_rand(0, 9);
            $random_number .= $random_digit;
            $count++;
        }
		 $users=AppUser::where('tag_id',$random_number)->count();
		 
		 if($users>0){
			$this->random_number();
		 }
		
    return $random_number;  
}
   

   public function login(Request $request){ 
   
   
	 
   

  $mobile_email = base64_decode($request->mobile_email); 
	
	
   $password     = base64_decode($request->password);
    $user='';

     $mobile= ['mobile' =>  trim($mobile_email), 'password'=>trim($password)]; 
    $email= ['email' =>  $mobile_email, 'password'=>$password]; 
 try {
   if (Auth::guard('admins')->attempt($mobile)||Auth::guard('admins')->attempt($email)) {
         
		$users=AppUser::where('mobile',$mobile_email)->orWhere('email',$mobile_email)->first();
      if($users){ 
         if(empty($users->email_verified_at)){
            return response()->json(['status'=>'false','message'=>trans('messages.invalid_details')], 401); 
          }
          if($users->status!='active'){
           
            return response()->json(['status'=>'false','message'=>trans('Status In-Active Please contact To support')], 401); 
          }

          $data=Helper::getUserDetails($users);
		  

          $users->login_status=1;
          $users->save();
         return response()->json(base64_encode(json_encode($data)), $this-> successStatus);
			}     
			}
			else{ 
				return response()->json(base64_encode(json_encode(['status'=>'false','message'=>trans('messages.invalid_details')])), 401); 
			} 
	 } catch (\Exception $e) {

            DB::rollBack();
            \Log::error("File:" . $e->getFile(). " Line:" . $e->getLine(). " Message:" . $e->getMessage().' id : '.$users->id.'  first_name : '.$users->first_name.
              '  last_name : '.$users->last_name.'  email : '.$users->email.'  mobile : '.$users->mobile);
            return response()->json(base64_encode(json_encode(['status'=>'false','message'=>'Something Went Wrong'])), 401); 
        }
  }

  public function register(Request $request) 
    { 


       
        $validator = Validator::make($request->all(), [ 
            // 'fname'            => 'required', 
            // 'lname'            =>'required',
           // 'email'            => 'required|unique:app_users,email', 
            // 'password'         => 'required', 
            //'mobile'           => 'required|unique:app_users,mobile', 
            // 'ev_manufacture'    => 'required',
            // 'image'             => 'required',
            // 'model'             => 'required',
            // 'model_variant'     => 'required',
            // 'manufacture_year'  => 'required',
            // 'registration_no'   => 'required',
            // // 'owner_ship'        => 'required',
        ]);



try{
       
        if ($validator->fails()) { 

           
         $message=$validator->errors()->first();
            return response()->json(['status'=>'false',"message"=>$message], 401);

        }
        $referral_by=0;

        $ref_code=$request->referral;
        if(!empty($ref_code)){
         $ref_by=AppUser::where('referral_code',$ref_code)->get()->first();
          if(!empty($ref_by)){
           $referral_by=$ref_by->id; 
          }

        }

        
	   
	    DB::beginTransaction();
		
        $user=new AppUser();
        $user->first_name     =   base64_decode($request->fname);
        $user->last_name      =   base64_decode($request->lname);  
        $user->email          =   base64_decode($request->email);
        $user->dob            =   date('Y-m-d',strtotime(base64_decode($request->dob)));
        $user->mobile         =   base64_decode($request->mobile);
        //$user->image          =   $imageName;
        $user->package_name   =   $request->package_name;
        $user->password       =   bcrypt(base64_decode($request->password));
        $user->token          =   str_random(60);
        $user->referral_code  =   referral_code(8);
		$user->tag_id		  =   $this->random_number();
        $user->referral_by    =   $referral_by;
        $user->save();

        $vehicles=new AppUserVehicles();
        $vehicles->app_user_id          =$user->id;
        $vehicles->ev_manufacture       = base64_decode($request->ev_manufacture);
        $vehicles->model                = base64_decode($request->model);
        $vehicles->model_variant        = base64_decode($request->model_variant);
        $vehicles->manufacture_year     = base64_decode($request->manufacture_year);
        $vehicles->registration_no      = base64_decode($request->registration_no);
        $vehicles->owner_ship           = base64_decode($request->owner_ship);
		$vehicles->capacity             = base64_decode($request->capacity);
		$vehicles->status               =1;
		

        $vehicles->save();
        $profile=new AppUserProfile();
        $profile->app_user_id   =   $user->id;
        $profile->country_id      =   1;
        $profile->address1      =    base64_decode($request->address1);
        $profile->address2      =    base64_decode($request->address2);
        $profile->state_id      =   $request->state_id;
        $profile->city_id       =   $request->city_id;
        $profile->save();
		
		
		//for uploading user images
        $path = "uploads/app_users/profile_images";
        if(!is_dir($path)) { mkdir($path, 0777, true); } 
        $c=0;$imagepath='';$sp=1;
        $image=$request->image;

       $image_data = base64_decode(preg_replace('#^data:image/\w+;base64,#i', '', $image));
       $tmpFilePath=sys_get_temp_dir().'/'.uniqid(); 
       file_put_contents($tmpFilePath, $image_data); 
       $f = finfo_open();
       $mime_type = finfo_buffer($f, $image_data, FILEINFO_MIME_TYPE);
       $imageName = str_replace(" ","_",$request->input('fname')).'_'.'profile'.'_'.time().'.jpg';
     
       $fp = fopen($path.'/'.$imageName, 'wb');
       fwrite($fp, $image_data);
       fclose($fp);
       //end uploading image
	   
	   
	    $user->image          =   'uploads/app_users/profile_images/'.$imageName;
		
		$user->save();

       $data= DB::insert('insert into wallets (app_user_id, balance) values (?, ?)', [$user->id,0]);

        if(!empty($referral_by)){
          $source='reffered to '.$user->full_name;
          $ref_by->deposit(10, 'credited', ["source"=>$source,'type'=>'referred']);
          
        }

		DB::commit();
	  return response()->json(['status'=>'true','message'=>trans('messages.registration_complete')], $this-> successStatus); 
			
	 } catch (\Exception $e) {

            DB::rollBack();
            \Log::error("File:" . $e->getFile(). " Line:" . $e->getLine(). " Message:" . $e->getMessage().' id : '.$users->id.'  first_name : '.$users->first_name.
              '  last_name : '.$users->last_name.'  email : '.$users->email.'  mobile : '.$users->mobile);
            return response()->json(['status'=>'false','message'=>'Something Went Wrong'], 401); 
        }
         return response()->json(['status'=>'true','message'=>trans('messages.registration_complete')], $this-> successStatus); 
    }


    public function getVehiclesModels()
    {
     $data=array();
      $manufacture=\App\VehicleManufacturer::get();
      $data['manufacture']=array();   
      $data['models']=array();   
      $data['varients']=array();   
      $data['years']=array();  
      $data['state']=array();  
      $data['city']=array();  
      
      $year=Years::select('year','id')->orderBy('id','DESC')->get();
      foreach( $manufacture as $manu){
        $da=array('id'=> strval($manu->id),'name'=>$manu->name); 
        array_push($data['manufacture'],$da);  
        $models=\App\VehicleModels::where('v_manufacture_id',$manu->id)->get();

        foreach($models as $mod){
        $da=array('id'=> strval($mod->id),'v_manufacture_id'=>strval($mod->v_manufacture_id),'name'=>$mod->name); 
        array_push($data['models'],$da); 
        $variants=\App\VehicleModelVariants::where(['v_model_id'=> $mod->id,'v_manufacture_id'=>$mod->v_manufacture_id])->get();
        
        foreach($variants as $var){
        $vari=array(
            'id'=> strval($var->id),
            'v_model_id'=>strval($var->v_model_id),
            //'v_manufacture_id'=>strval($var->v_manufacture_id),
            'name'=>$var->name
        ); 
        array_push($data['varients'],$vari); 
        }
        }
      }

      foreach($year as $ye){
        $va=array(
          'id'=> strval($ye->id),
          'year'=>strval($ye->year),
      ); 
      array_push($data['years'],$va); 
      }
      $states=States::get();
      foreach($states as $state){
        $va=array(
          'id'=> strval($state->state_id),
          'name'=>strval($state->state_name),
      ); 
      array_push($data['state'],$va); 

      }
      $cities=Cities::get();
      foreach($cities as $city){
        $va=array(
          'id'=> strval($city->city_id),
          'state_id'=> strval($city->state_id),
          'name'=>strval($city->city_name),
      ); 
      array_push($data['city'],$va); 

      }
 
      return $data;
    }




   public function logout(Request $request){

    $user_id=$request->user_id;
    $users=AppUser::find($user_id);
    $users->login_status=0;
    $users->save();
    return response()->json(['status'=>'true','message'=>"Logout Successfully"], $this-> successStatus); 

    }
	
	
	public function privacyPolicy(){
		
		
		return view('privacy_policy');
		
	}
  

}




