<?php

namespace App\Http\Controllers\API;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use App\StationNozzle;
use DB;


class StationsController extends Controller
{
    public function getNozzil(Request $request){
		
    $nozils=StationNozzle::where(['station_id'=>$request->station_id,'type'=>$request->type])->get()->first();
        if($nozils){
           $details=array(
        "id"              => $nozils->id,
        "nozzle_id"       => $nozils->nozzle_id,
        "station_id"      => $nozils->station_id,
        "type"            => $nozils->type,
        "price"           => $nozils->price.'/W',
        "capacity"        => $nozils->capacity,
        "nozzil_status"   => $nozils->status,
        "rating"          => $nozils->power_rating,
        'available'       => '1',
        'in_use'          => '1',
        'status'          => 'true'
        
       );

        return response()->json($details, 200);
    }else{
        return response()->json(['message'=>'No data Found','status'=>'true'], 200);

    }
    }
	
	
	public function markerDetails(Request $request){
		
    // $nozils=StationNozzle::where(['station_id'=>$request->station_id])->get();
    // $pointsTypes=DB::Select("SELECT * FROM charge_point_types p LEFT JOIN station_nozzles o ON o.type = p.id AND o.station_id='".$request->station_id."' join charger_types on charger_types.id=o.charger_code ORDER BY p.id");
    $pointsTypes=DB::Select("SELECT * FROM charge_point_types p   ORDER BY p.id");
    $details=array();
    


        if($pointsTypes){

        foreach ($pointsTypes as $key => $value) {
           
        $nozils=DB::select("SELECT SUM(CASE WHEN status = 'active' THEN 1 ELSE 0 END) AS active, SUM(CASE WHEN status = 'in_active' THEN 1 ELSE 0 END) AS in_use FROM station_nozzles WHERE station_id='".$request->station_id."' AND type='".$value->id."'");
          
            $active ='';
            $inuse  ='';
            if(count($nozils)>0){
                $active=$nozils['0']->active;
                if($nozils['0']->in_use==0){
                    $in_use=0;
                }else{
                    $in_use=$nozils['0']->in_use;
                }
            }

            $deta=array(    
        		"type"          => strval($value->id),      
                'available'     => $active.'',
                'in_use'        => $inuse.'',
                "image"         => url('/').'/'.config('constants.upload_path.connectorImg').strval($value->image),
                "name"          => strval($value->name),
               );
               array_push($details,$deta);
            }
			
        //    foreach($pointsTypes as $nozilss){
        //     $available='';
        //     $ocpp_id='';
        //     if($nozilss->id){
        //         $available=0;
        //         $ocpp_id=$nozilss->nozzle_id;
        //     }
        //        $deta=array(
        // 		// "rating"          => strval($nozilss->power_rating),      
        // 		"type"          => strval($nozilss->type),      
        //         'available'       => strval($nozilss->charger_id),
        //         'charger_code'    => strval($nozilss->charger_code),
        //         'in_use'          => $available,
        // 		// "price"           => strval($nozilss->price),
        //         "nozzil_status"   => strval($nozilss->status),
        //         "image"           => url('/').'/'.config('constants.upload_path.connectorImg').strval($nozilss->image),
        //         "name"            => strval($nozilss->name),
        //         // "ocpp_id"         => $ocpp_id,
        //        );
        //     //    $deta=array(
        // 	// 	"rating"          => strval($nozilss->power_rating),      
        //     //     'available'       => strval($nozilss->charger_id),
        //     //     'in_use'          => strval($nozilss->charger_id),
        // 	// 	   "price"           => strval($nozilss->price),
        //     //     "nozzil_status"   => strval($nozilss->status),
        //     //    );
        // 	  array_push($details,$deta);
            
            // }

	

        return response()->json($details, 200);
    }else{
        return response()->json(['message'=>'No data Found','status'=>'true'], 200);

    }
    }

    public function getchargersBasedOnType(Request $request){
    $nozils=StationNozzle::select('station_nozzles.power_rating','station_nozzles.price','station_nozzles.charger_id',
    'station_nozzles.charger_code',
    'station_nozzles.status',
    'station_nozzles.nozzle_id',
    'station_nozzles.station_id'
    )
    ->where(['station_id'=>$request->station_id,'type'=>$request->type])
    ->join('charger_types','charger_types.id','=','station_nozzles.charger_code')->orderBy('station_nozzles.nozzle_id')->get();
    $details=array();
    try{
    if(!$nozils){
        return response()->json(['message'=>'No data Found','status'=>'true'], 200);
    }
    foreach($nozils as $nozilss){

                    $deta=array(
                		"rating"          => strval($nozilss->power_rating),      
                		"price"           => strval($nozilss->price),
                		"connector_id"      => strval($nozilss->charger_id),
                		"charger_code"    => strval($nozilss->charger_code),
                        "nozzil_status"   => strval($nozilss->status),
                        "ocpp_id"         => strval($nozilss->nozzle_id),
                        "station_id"      => strval($nozilss->station_id),
                       );
                	  array_push($details,$deta);
            }
            return response()->json($details, 200);
        }catch(Exception $e){
            return response()->json(['message'=>'Something Went Wrong','status'=>'false'], 200);
        }
    }
}
