<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\AppUser;
use Illuminate\Support\Facades\Storage;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Facades\Validator;
use Illuminate\Support\Facades\Auth;
use DB;
use Illuminate\Support\Facades\Input;
use Session;
use Redirect;
use View;
use Crypt;
use Entrust;
use PDF;
use App\Classes\Helper;

class AppUsersController extends Controller
{
    use BasicController;
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {

        if(!Entrust::can('view_app_users'))
        return view('common.error',['message' => trans('messages.permission_denied')]);

        $roles = \App\Role::whereIsHidden(0)->get()->pluck('name','id')->all();

        $col_heads = array(
                trans('messages.first_name'),
                trans('messages.last_name'),
                trans('messages.email'),
                trans('messages.mobile'),
                trans('messages.status'),
                trans('messages.image'),
				trans('Charging History'),
                trans('messages.option'));
        $table_info = array(
            'source' => 'appusers',
            'title'  => 'Employee List',
            'id'     => 'usefdrs',
            'form'   => 'employee_filter_form'
        );
        $menu = ['appusers'];
    
        return view('admin.appusers.index',compact('col_heads','table_info','roles','menu'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {

        $packages = Helper::translateList(config('lists.packages'));
        $menu = ['appusers'];
        $appuser=AppUser::find($id);
        return view('admin.appusers.view',compact('appuser','menu','packages'));
    }
//display data into table using AJAX Request
    public function lists(Request $request){



        $columns = array( 
            0 =>'first_name',
            1=> 'last_name',
            2=> 'email',
            3=> 'mobile',
            4=> 'status',
            5=> 'image',
            6=> 'status',
			7=> 'status',
        );
    if(Entrust::hasRole('organisation'))
    $totalData = \App\AppUser::where('package_name',Auth::user()->package)->count();
    else
    $totalData = \App\AppUser::count();


    $totalFiltered = $totalData; 

    $limit = $request->input('length');
    $start = $request->input('start');
    $order = $columns[$request->input('order.0.column')];
    $dir = $request->input('order.0.dir');

    if(!empty($request->application) || !empty($request->state) || !empty($request->city)){

        if($request->application){
            $searchhh['package_name']=$request->application;
           }
           if($request->state){
            $searchhh['state_id']=$request->state;
           }
           if($request->city){
            $searchhh['city_id']=$request->city;
           }


      
        if($searchhh){
    $post =  \App\AppUser::where($searchhh)
            ->join('app_user_profiles','app_user_id','=','app_users.id')
            ->offset($start)
            ->limit($limit);

            if(Entrust::hasRole('organisation'))
            $post->where('package_name',Auth::user()->package);

            $post->orderBy($order,$dir);
            $posts=$post->get();

          $totalFiltered = count($posts);

        }
    }
    elseif(empty($request->input('search.value')))
    {            
    $post = \App\AppUser::offset($start)
            ->limit($limit);

            if(Entrust::hasRole('organisation'))
            $post->where('package_name',Auth::user()->package);

            $post->orderBy($order,$dir);
            $posts=$post->get();
    } else {
        $search = $request->input('search.value'); 

        $post =  \App\AppUser::where('mobile','LIKE',"%{$search}%")
                    ->orWhere('first_name', 'LIKE',"%{$search}%")
                    ->orWhere('last_name', 'LIKE',"%{$search}%")
                    ->orWhere('email', 'LIKE',"%{$search}%")
                    // ->orWhere('status', 'LIKE',"%{$search}%")
                    ->offset($start)
                    ->limit($limit);

        if(Entrust::hasRole('organisation'))
            $post->where('package_name',Auth::user()->package);
            $post->orderBy($order,$dir);
            $posts=$post->get();

            $totalFiltere = \App\AppUser::where('mobile','LIKE',"%{$search}%");

            if(Entrust::hasRole('organisation'))
             $totalFiltere->where('package_name',Auth::user()->package);

             $totalFiltere->orWhere('first_name', 'LIKE',"%{$search}%");
             $totalFiltere->orWhere('last_name', 'LIKE',"%{$search}%");
             $totalFiltere->orWhere('email', 'LIKE',"%{$search}%");
             $totalFiltere->orWhere('status', 'LIKE',"%{$search}%");
             $totalFiltered=$totalFiltere->count();
}
$rows=[];
    $data = array();
    $i=1;
    if(!empty($posts))
    {
        $i=1;
    foreach ($posts as $users){
        
        $rows[] = array(
         $users->first_name,
         $users->last_name,
         $users->email,
         $users->mobile,
         ($users->status == 'active' || $users->status == '') ? '<span class="label label-success">'.trans('messages.active').'</span>' : '<span class="label label-danger">'.Helper::toWord($users->status).'</span>'
          ,'<a href="#" class="pop">
          <img src="'.$users->image.'" class="wd-40 rounded-circle"  alt=""></a>'
         , '<div class="btn-group btn-group-xs">'.
          '<a href="/app-user/charging-history/'.Crypt::encrypt($users->id).'" class="btn btn-xs btn-default" ><i class="fa fa-plug" data-toggle="tooltip" title="View Charging History"></i> History</a> '.
          
          '</div>',
		  '<div class="btn-group btn-group-xs">'.
          '<a href="/appusers/'.$users->id.'" class="btn btn-xs btn-default" > <i class="fa fa-eye" data-toggle="tooltip" title="'.trans('messages.view').'"></i></a> '.
          ((!Entrust::can('change-app-user-status')) ? '<a href="#" data-href="/appusers/'.$users->id.'/change-status" class="btn btn-default btn-xs edit-form" data-toggle="modal" data-target="#mymodel"> <i class="fa fa-user" data-toggle="tooltip" title="'.trans('messages.change').' '.trans('messages.status').'"></i></a> ' : '').
          '</div>',);  
          $i++;
        }
}
$json_data = array(
    "draw"            => intval($request->input('draw')),  
    "recordsTotal"    => intval($totalData),  
    "recordsFiltered" => intval($totalFiltered), 
    "aaData"            => $rows   
    );
echo json_encode($json_data); 
        
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
       
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }




    public function changeStatus($id){

        $user = \App\AppUser::find($id);

        if(!$user || Entrust::can('change-app-user-status'))
        if(!Entrust::can('change_app_user_status'))
            return view('common.error',['message' => trans('messages.permission_denied')]);

      
        return view('admin.appusers.change_status',compact('user'));

    }
    public function postChangeStatus(Request $request, $id){

        $user = \App\AppUser::find($id);

        $validation = Validator::make($request->all(),[
            'status' => 'required'
        ]);

        if($validation->fails()){
        
            return redirect()->back()->withErrors($validation->messages()->first());
        }

        $user->status = $request->input('status');
        $user->save();


        $this->logActivity(['module' => 'app_user','unique_id'=>$id,'activity' => 'Status_changed']);
        return redirect('/appusers')->withSuccess(trans('messages.user').' '.trans('messages.status').' '.trans('messages.updated'));
    }






    public function getUsersBypkg(Request $request,$pkg){
        
        return $users=AppUser::select('id','first_name','last_name')->where('package_name',$pkg)->get();
    }
	
	public function chargingHistory(Request $request,$id){
		
		
        
        if(!Entrust::can('view_users_charging_report'))
        return view('common.error',['message' => trans('messages.permission_denied')]);
		
		try{
		$id=Crypt::decrypt($id);
		
		$message='';
		
       $stations           =\App\Station::join('charging_histories','charging_histories.station_id','=','stations.station_id')->whereAppUserId($id)->get()->pluck('station_name',"station_id")->all();
       $charging_points    =\App\StationNozzle::join('charging_histories','charging_histories.nozzle_id','=','station_nozzles.nozzle_id')->whereAppUserId($id)->get()->pluck('nozzle_id','nozzle_id')->all();
		
		$histo = \App\ChargingHistory::whereAppUserId($id)->orderBy('created_at','DESC');
		 if($request->search=='bydate'){
        $validation = Validator::make($request->all(),[
                'startDate' => 'required','endDate'   => 'required']);
        if($validation->fails()){ 
            return redirect()->back()->withInput()->withErrors($validation->messages());
        }
        $station        =   $request->station;
        $cps            =   $request->cps;
        $startDate      =   $request->startDate;
        $endDate        =   $request->endDate;
        $search=true;

		$histo->whereBetween('charging_histories.created_at', array(date('Y-m-d 00:00:00',strtotime($startDate)), date('Y-m-d 23:59:59',strtotime($endDate))));

		
		if($station){
			  $histo->where('charging_histories.station_id',$station);
            $message= "  Station :".$station;
         }
		  if(!empty($cps)){
            $histo->where('charging_histories.nozzle_id',$cps);
            $message= $message.' OCPP ID : '.$cps.'  ';
        }
        view()->share(compact('station','cps','startDate','endDate'));
        $active='bydate';
        $message=$message."   Date: ".$startDate .' To '. $endDate. ' ';
		 }
		 $user=\App\AppUser::find($id);
		 $fromdate       = '';
         $todate         =    date('D-m-Y');
		 
		 $history=$histo->get();
		 $message= $message.'  User : '.$user->first_name." ".$user->last_name;
		 $user_id=$id;
		
		return view('admin.appusers.charging_history',compact('history','stations','charging_points','todate','fromdate','message','user_id'));	

		}catch(Exception $e){
			abort(500, 'Something Wen Wrong');
		}
    }
    
    public function invoiceGenerate(Request $request,$id){

       $invoice=\App\ChargingHistory::select(
        'station_nozzles.nozzle_id',
        'station_nozzles.price',
        'charging_histories.*',
        'stations.station_name',
        'stations.address',
        'stations.location_name',
        'stations.application',
        'charging_histories.app_user_id',
        'app_users.first_name',
        'app_users.last_name',
        'app_users.email',
        'app_users.mobile',
        'transactions.order_status',
        'transactions.type',
        'transactions.transaction_date',
        'transactions.transaction_time'
        )
        ->join('app_users','app_users.id','=','charging_histories.app_user_id')
        ->join('stations','stations.station_id','=','charging_histories.station_id')
        ->join('station_nozzles','station_nozzles.nozzle_id','=','charging_histories.nozzle_id')
        ->join('transactions','transactions.trans_id','=','charging_histories.transaction_id')
        ->where('charging_histories.id',$id)
        ->get()->first();
        return view('reports.invoices.user_charging_invoice',compact('invoice'));
    }

    public function pdfGenerate(Request $request,$id){

     $invoice=\App\ChargingHistory::select(
            'station_nozzles.nozzle_id',
            'station_nozzles.price',
            'charging_histories.*',
            'stations.station_name',
            'stations.address',
            'stations.location_name',
            'stations.application',
            'charging_histories.app_user_id',
            'app_users.first_name',
            'app_users.last_name',
            'app_users.email',
            'app_users.mobile',
            'transactions.order_status',
            'transactions.type',
            'transactions.transaction_date',
            'transactions.transaction_time'
            )
            ->join('app_users','app_users.id','=','charging_histories.app_user_id')
            ->join('stations','stations.station_id','=','charging_histories.station_id')
            ->join('station_nozzles','station_nozzles.nozzle_id','=','charging_histories.nozzle_id')
            ->join('transactions','transactions.trans_id','=','charging_histories.transaction_id')
            ->where('charging_histories.id',$id)
            ->get()->first();


            $pdf = PDF::loadView('emails.charging_invoice_pdf',compact('invoice'));
         return   $pdf->download('download.pdf');
            // $mail = array();
            // $mail['subject'] = 'Payment Status';
    
            //     $mail['email'] = "eharishwarreddy666@gmail.com";
            //         $mail['filename'] = 'charging_history_'.date('d-m-Y').'.pdf';
    
            //         \Mail::send('emails.payment_success',compact('station_id','ocpp_id','charger_id','app_user_id','order_status','payment_mode','bank_ref_no','order_id','amount','tracking_id'), function ($message) use($pdf,$mail) {
            //             $message->attachData($pdf->output(), $mail['filename']);
            //             $message->to($mail['email'])->subject($mail['subject']);
            //        });
        
       // $pdf = PDF::loadView('reports.invoices.user_charging_invoice',compact('invoice'));
        //$pdf->download('download.pdf');
        
        //return $pdf->download('pdfview.pdf');

      
    }

    
}
