<?php

namespace App\Http\Controllers\Auth;
use App\PasswordReset;
use App\Http\Controllers\Controller;
use Illuminate\Foundation\Auth\SendsPasswordResetEmails;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Password;
use App\Franchise;
use Session;
use App\Classes\Helper;
use Illuminate\Support\Facades\Input;

class ForgotPasswordController extends Controller
{
    /*
    |--------------------------------------------------------------------------
    | Password Reset Controller
    |--------------------------------------------------------------------------
    |
    | This controller is responsible for handling password reset emails and
    | includes a trait which assists in sending these notifications from
    | your application to your users. Feel free to explore this trait.
    |
    */

    use SendsPasswordResetEmails;

    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct()
    {
        $this->middleware('guest');
    }


	 public function sendResetLinkEmail(Request $request)
     {
        $mail = array();
         $request->validate([
             'email' => 'required|string|email',
         ]);
      $user = Franchise::where('email', $request->email)->first();
         if (!$user)
             return response()->json([ 'message' => 'We cant find a user with that e-mail address.'
             ], 404);
         $passwordReset = PasswordReset::updateOrCreate(
             ['email' => $user->email],
             [
                 'email' => $user->email,
                 'token' => str_random(60)
              ]
         );
 
      $url= url('/password/reset/'.$passwordReset->token);
         if ($user && $passwordReset)
         $template = \App\Template::whereCategory('forgot_password')->first();
         $body = $template->body;
        //  $body = str_replace('[NAME]',$user->full_name,$body);
        //  $body = str_replace('[LINK]', $url,$body);
         $body=$user->full_name;
 
         $mail['email'] = $user->email;
         $mail['subject'] = $template->subject;
        $blade="forgot_password";
		
       
        try {
            \Mail::send('emails.pass', compact('body','url'), function ($message) use($mail) {
                //$message->attachData($pdf->output(), $mail['filename']);
                $message->to($mail['email'])->subject($mail['subject']);

            
            });
        } catch (\Exception $th) {
            return back()->with('th', trans('passwords.user'));
        }
        return back()->with('status', trans('passwords.sent'));
         
     }
     /**
      * Find token password reset
      *
      * @param  [string] $token
      * @return [string] message
      * @return [json] passwordReset object
      */
     public function find($token)
     {
         return $token;
          $passwordReset = PasswordReset::where('token', $token)
             ->first();
         if (!$passwordReset)
             return response()->json([
                 'message' => 'This password reset token is invalid.'
             ], 404);
         if (Carbon::parse($passwordReset->updated_at)->addMinutes(720)->isPast()) {
             $passwordReset->delete();
             return response()->json([
                 'message' => 'This password reset token is invalid.'
             ], 404);
         }
         $title="Reset Password";
         return view('auth.passwords.reset',compact('passwordReset','title'));
         
 
         
         //return response()->json($passwordReset);
     }
      /**
      * Reset password
      *
      * @param  [string] email
      * @param  [string] password
      * @param  [string] password_confirmation
      * @param  [string] token
      * @return [string] message
      * @return [json] user object
      */
     public function reset(Request $request)
     {
 
         
          $validator = Validator::make($request->all(), [ 
             'email' => 'required|string|email', 
             'password' => 'required|string', 
             'confirmed' => 'required|string|same:password', 
             'token' => 'required|string'
         ]);
         if ($validator->fails()) { 
             return view('auth.passwords.reset',$validator->errors());            
         }
         $passwordReset = PasswordReset::where([
             ['token', $request->token],
             ['email', $request->email]
         ])->first();
         if (!$passwordReset)
             return response()->json([
                 'message' => 'This password reset token is invalid.'
             ], 404);
         $user = User::where('email', $passwordReset->email)->first();
         if (!$user)
             return response()->json([
                 'message' => 'We cant find a user with that e-mail address.'
             ], 404);
         $user->password = bcrypt($request->password);
         $user->save();
         $passwordReset->delete();
         $subject='Successfully Password Changed';
         $blade="pass_success";
         //$user->notify(new PasswordResetSuccess($passwordReset));
         $url='';
         $title="Success";
         $status =Helper::sendMails($user->email,$subject,$user->name,$url,$blade);
         return view('auth.success',compact('title'));
     }
}
