<?php

namespace App\Http\Controllers\Auth;
use Carbon\Carbon;
use App\Http\Controllers\Controller;
use Illuminate\Foundation\Auth\ResetsPasswords;
use Illuminate\Http\Request;
use Validator;
use App\PasswordReset;
use Illuminate\Support\Facades\Input;
class ResetPasswordController extends Controller
{
    /*
    |--------------------------------------------------------------------------
    | Password Reset Controller
    |--------------------------------------------------------------------------
    |
    | This controller is responsible for handling password reset requests
    | and uses a simple trait to include this behavior. You're free to
    | explore this trait and override any methods you wish to tweak.
    |
    */

    use ResetsPasswords;

    /**
     * Where to redirect users after resetting their password.
     *
     * @var string
     */
    protected $redirectTo = '/home';

    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct()
    {
        $this->middleware('guest');
    }



    public function reset(Request $request)
     {
       
        $validator = Validator::make($request->all(), [ 
            'email' => 'required|string|email', 
            'password' => 'required|string', 
            'confirmed' => 'required|string|same:password', 
            'token' => 'required|string'
        ]);
        if ($validator->fails()) { 
            return redirect()->back()->withInput()->withErrors($validator->errors());            
        }
        $passwordReset = PasswordReset::where([
            ['token', $request->token],
            ['email', $request->email]
        ])->first();
        if (!$passwordReset)
            return redirect()->back()->withErrors('This password reset token is invalid.');
        $user = \App\Franchise::where('email', $passwordReset->email)->first();
        if (!$user)
            return response()->json([
                'message' => 'We cant find a user with that e-mail address.'
            ], 404);
        $title="password Successfully Changed";
        $user->password = bcrypt($request->password);
        $user->save();
        $passwordReset->delete();
        return view('auth.success',compact('title'));
 
         
         //return response()->json($passwordReset);
     }
}
