<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\ChargePointTypes;
use Entrust;
use Validator;
use Image;
use File;

class ChargePointTypeController extends Controller
{
    use BasicController;
   
    public function index()
    {

        $col_heads = array(
            trans('messages.name'),
            trans('Image'),
            // trans('messages.status'),
            trans('messages.option'));
    $table_info = array(
        'source' => 'pointtypes',
        'title'  => 'pointtypes List',
        'id'     => 'posts',
        'form'   => 'pointtypes_filter_form'
    );
        $menu['menu']="stations";
        return view('admin.chargetypes.index',compact('menu','table_info','col_heads'));
    }

    
    public function create()
    {
        //
    }

    public function store(ChargePointTypes $types, Request $request)
    {
        $validation = Validator::make($request->all(),[
            'name' => 'required|unique:charge_point_types,name',
            'image' =>'required'
        ]);
       $filename = uniqid();
                if($validation->fails()){
                   
                    return redirect()->back()->withInput()->withErrors($validation->messages());
                }


                   $extension = $request->file('image')->getClientOriginalExtension();
                   $file = $request->file('image')->move(config('constants.upload_path.connectorImg'), $filename.".".$extension);
                    $img = Image::make(config('constants.upload_path.connectorImg').$filename.".".$extension);
                    $img->resize(46, null, function ($constraint) {
                        $constraint->aspectRatio();
                    });
                   $img->save(config('constants.upload_path.connectorImg').$filename.".".$extension);
                    
                
            $data = $request->all();
            $types->fill($data);
            $types->image=$filename.".".$extension;
            $types->save();


            $this->logActivity(['module' => 'connection_types','activity' => 'activity_added']);
    
            return redirect()->back()->withSuccess(trans('Connection Types').' '.trans('messages.saved'));
            
    
    }

   
    public function show($id)
    {
        //
    }
    public function lists(Request $request){


        $columns = array( 
            0 =>'name',
            2=> 'status',
        );

    $totalData = \App\ChargePointTypes::count();

    $totalFiltered = $totalData; 

    $limit = $request->input('length');
    $start = $request->input('start');
    $order = $columns[$request->input('order.0.column')];
    $dir = $request->input('order.0.dir');

    if(empty($request->input('search.value')))
    {            
    $posts = \App\ChargePointTypes::offset($start)
            ->limit($limit)
            ->orderBy($order,$dir)
            ->get();
    }
else {
$search = $request->input('search.value'); 

$posts =  \App\ChargePointTypes::where('name','LIKE',"%{$search}%")
            
            ->offset($start)
            ->limit($limit)
            ->orderBy($order,$dir)
            ->get();

$totalFiltered = count($posts);
}
$rows=[];
    $data = array();
    $i=1;
    if(!empty($posts))
    {
        $i=1;
    foreach ($posts as $users){
        
        $rows[] = array(
         $users->name,
         '<img src="'.url('/').'/'.config('constants.upload_path.connectorImg').$users->image.'" alt="'. $users->name.'"/>',
        //  '<a href="#" data-href="/pointtypes/'.$users->id.'/change-status" class="btn btn-default btn-xs edit-form" data-toggle="modal" data-target="#mymodel"> <i class="fa fa-user" data-toggle="tooltip" title="'.trans('messages.change').' '.trans('messages.status').'"></i></a>',
          
         '<a href="#" data-href="/pointtypes/'.$users->id.'/edit" class="btn btn-xs btn-default edit-form" data-toggle="modal" data-target="#mymodel"> <i class="fa fa-edit" data-toggle="tooltip" title="'.trans('messages.edit').'"></i></a></div>');  
          $i++;
        }
}
$json_data = array(
    "draw"            => intval($request->input('draw')),  
    "recordsTotal"    => intval($totalData),  
    "recordsFiltered" => intval($totalFiltered), 
    "aaData"            => $rows   
    );
echo json_encode($json_data); 
 
	}
  



    
public function edit($id)
{
    $role=ChargePointTypes::find($id);
    return view('admin.chargetypes.edit',compact('role'));
}
       
        public function update(Request $request,$id)
        {

            $manufacturer=ChargePointTypes::find($id);
            $validation = Validator::make($request->all(),[
                'name' => 'required',
                'image'=> 'required',
            ]);
    
            if($validation->fails()){
            
                return redirect()->back()->withInput()->withErrors($validation->messages());
            }
            $filename = uniqid();
            if($request->hasfile('image')){
            $extension = $request->file('image')->getClientOriginalExtension();
            $file = $request->file('image')->move(config('constants.upload_path.connectorImg'), $filename.".".$extension);
             $img = Image::make(config('constants.upload_path.connectorImg').$filename.".".$extension);
             $img->resize(46, null, function ($constraint) {
                 $constraint->aspectRatio();
             });
            $img->save(config('constants.upload_path.connectorImg').$filename.".".$extension);

            if(File::exists(config('constants.upload_path.connectorImg').$manufacturer->image))
				File::delete(config('constants.upload_path.connectorImg').$manufacturer->image);
           

            $manufacturer->image=$filename.".".$extension;
            }

    
            $manufacturer->name = $request->input('name');
            $manufacturer->save();
    
            $this->logActivity(['module' => 'connection_types','activity' => 'activity_updated']);
    
         
            return redirect()->back()->withSuccess(trans('Connection Types').' '.trans('messages.updated'));
        
        }


}
