<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\ChargerType;
use App\ChargePointTypes;
use App\StationNozzle;
use Crypt;
use Entrust;
use Auth;
class ChargerController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $col_heads = array(
            // trans('Sl No'),
            trans('Cp Id'),
            trans('Station id'),
         //   trans('Charger Code'),
            trans('Charger Id'),
            trans('Power Rating'),
          
           // trans('Price'),
             trans('Status'), 
            
            trans('Station'),
			trans('QR COde'),
          );
            $table_info = array(
                'source' => 'chargertype',
                'title'  => 'charger Type List',
                'id'     => 'posts',
                'form'   => 'chargertype_filter_form'
            );
        $menu['menu']="stations";
        return view('admin.chargers.index',compact('menu','table_info','col_heads'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create(Request $request)
    {
        $connections=ChargePointTypes::get()->pluck('name','id')->all();
        $station=$request->station;
        $menu['menu']="stations";
        $chargers=ChargerType::get()->pluck('charger_code','id')->all();
        return view('admin.chargers.add_charger',compact('menu','chargers','station','connections'));
    }
    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        try {
            $id =\Crypt::decrypt($id);
        } catch (Illuminate\Contracts\Encryption\DecryptException $e) {
            return $e;
            
        }
        $editcharger=StationNozzle::find($id);
        $connections=ChargePointTypes::get()->pluck('name','id')->all();
        $menu['menu']="stations";
        $chargers=ChargerType::get()->pluck('charger_code','id')->all();
        return view('admin.chargers.edit_chargere',compact('menu','chargers','connections','editcharger'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        try {
            $id = \Crypt::decrypt($id);
        } catch (Illuminate\Contracts\Encryption\DecryptException $e) {
            return $e;
            
        }

        $chargers=StationNozzle::find($id);

       $validation = \Validator::make($request->all(),[
        'type'           => 'required',
        'station_id'     => 'required',
        'nozzle_id'      => 'required',
        'charger_code'   => 'required',
        'power_rating'   => 'required',
        'description'    => 'required',
        'simno'          => 'required',
    ], ['nozzle_id.required' => 'Ocpp Id required',
        'nozzle_id.unique' => 'Ocpp Id Already Exist']);
    if($validation->fails()){
        return redirect()->back()->withInput()->withErrors($validation->messages());
    }

    $chargers->type             =$request->type;
    $chargers->nozzle_id        =$request->nozzle_id;
    $chargers->charger_code     =$request->charger_code;
    $chargers->power_rating     =$request->power_rating;
    $chargers->description      =$request->description;
    $chargers->simno            =$request->simno;
    $chargers->save();

    $station=\App\Station::where('station_id', $request->station_id)->get()->first();
    


    
    $this->logActivity(['module' => 'stations_nozzil','activity' => 'activity_updated']);

    return redirect('/stations/'.\Crypt::encrypt($station->id))->withSuccess(trans('Charger').' '.trans('messages.updated'));
       

   

    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
       $chargers=StationNozzle::find($id);
       $chargers->delete();
       return redirect()->back()->withSuccess(trans('Charger').' '.trans('messages.deleted'));
    }


    public function chargerTypeDescription(Request $request){
        $chargertype=ChargerType::find($request->charger_id);

        return $chargertype->description;
    }

    	public function lists(Request $request){

		$columns = array( 
            0 =>'nozzle_id',
            1=> 'station_id',
            2=> 'charger_id',
            3=> 'power_rating',
           // 4=> 'price',
            4=> 'status',
          //  6=> 'status',
 
        );

    $totalData = \App\StationNozzle::count();

    if(Entrust::hasRole('organisation'))
    $totalData = \App\StationNozzle::select('station_nozzles.*','stations.id as st_id')
    ->leftjoin('stations','stations.station_id','=','station_nozzles.station_id')
    ->where('application',Auth::user()->package)->count();
    else
    $totalData = \App\StationNozzle::count();


    $totalFiltered = $totalData; 

    $limit = $request->input('length');
    $start = $request->input('start');
    $order = $columns[$request->input('order.0.column')];
    $dir = $request->input('order.0.dir');

    if(empty($request->input('search.value')))
    {            
     $templa = \App\StationNozzle::select('station_nozzles.*','stations.id as st_id')
     ->leftjoin('stations','stations.station_id','=','station_nozzles.station_id');
     if(Entrust::hasRole('organisation'))
     $templa ->where('application',Auth::user()->package);
     
     $template=$templa->offset($start)->limit($limit)->orderBy($order,$dir)->get();

    }else {

    $search = $request->input('search.value'); 

    $templa =  \App\StationNozzle::select('station_nozzles.*','stations.id as st_id')
            ->leftjoin('stations','stations.station_id','=','station_nozzles.station_id');
            if(Entrust::hasRole('organisation'))
    $templa ->where('application',Auth::user()->package);

    $template=$templa->where('station_nozzles.nozzle_id','LIKE',"%{$search}%")
			// ->orWhere('station_nozzles.station_id', 'LIKE',"%{$search}%")
			// ->orWhere('station_nozzles.charger_id', 'LIKE',"%{$search}%")
            ->offset($start)
            ->limit($limit)
            ->orderBy($order,$dir)
            ->get();

     $totalFiltered=count($template);
}
$rows=[];
    $data = array();
    $i=1;
    if(!empty($template))
    {
        $i=1;
    foreach ($template as $template){
        $rows[] = array(
			$template->nozzle_id,
			$template->station_id,
			//$template->charger_code,
			$template->charger_id,
            $template->power_rating,
            //$template->price,
            '<span class="label label-'.$template->status.'">'.\App\Classes\Helper::toWord($template->status).'</span>',
           
           (($template->status != 'in-active') ? '<a href="/stations/'.Crypt::encrypt($template->st_id).'" class="btn btn-default btn-xs edit-form" ><i class="fa fa-plug" data-toggle="tooltip" title="'.trans('View Chargers').'"></i></a> ' : '')
            ,'<a  href="#" data-tooltip="tooltip" title="Generate QR Code"  data-href="/qr-code/'.$template->nozzle_id.'/'.$template->charger_id.'/generate" data-toggle="modal" data-target="#mymodel" class="btn btn-default btn-xs edit-form" >
            <i class="fa fa-qrcode" style="font-size: 25px;"></i></a>',
                       
           
        
        
        );  
          $i++;
        }
}
$json_data = array(
    "draw"            => intval($request->input('draw')),  
    "recordsTotal"    => intval($totalData),  
    "recordsFiltered" => intval($totalFiltered), 
    "aaData"            => $rows   
    );
echo json_encode($json_data); 
        
	}

}
