<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Validator;
use App\ChargerType;


class ChargerTypeController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    use BasicController;
   
    public function index()
    {

        $col_heads = array(
            trans('Sl No'),
            trans('Charger Code'),
            trans('Description'),
            trans('Power Rating	'),
            trans('Create Date'),
            trans('messages.option'));
            $table_info = array(
                'source' => 'chargertype',
                'title'  => 'charger Type List',
                'id'     => 'posts',
                'form'   => 'chargertype_filter_form'
            );
        $menu['menu']="stations";
        return view('admin.chargetypes.chargerTypes',compact('menu','table_info','col_heads'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $menu['menu']="stations";
        return view('admin.chargetypes.add_charger_type',compact('menu'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(ChargerType $types,Request $request)
    {
      
        $validation=Validator::make($request->all(),[
            "charger_code"      =>  "required|unique:charger_types,charger_code",
            "oem_code"          =>  "required|unique:countrys,country_name",
            "description"       =>  "required",
            "power_rating"      =>  "required",
            "status"            =>  "required",
            "charger_rating"    =>  "required"
            
        ]);



    
        if($validation->fails()){
            return redirect()->back()->withInput()->withErrors($validation->messages());
            }

            $data = $request->all();
            $types->fill($data)->save();
        
            $this->logActivity(['module' => 'charger_type','activity' => 'activity_added']);

          
            return redirect('/chargertype')->withSuccess(('Station').' '.trans('messages.saved'));
        
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }
    public function lists(Request $request){


        $columns = array( 
            0 =>'charger_code',
            1=> 'oem_code',
            2=> 'description',
            3=> 'power_rating',
            4=> 'charger_rating',
            5=> 'created_at',
        );

    $totalData = \App\ChargerType::count();

    $totalFiltered = $totalData; 

    $limit = $request->input('length');
    $start = $request->input('start');
    $order = $columns[$request->input('order.0.column')];
    $dir = $request->input('order.0.dir');

    if(empty($request->input('search.value')))
    {            
    $posts = \App\ChargerType::offset($start)
            ->limit($limit)
            ->orderBy($order,$dir)
            ->get();
    }else {
$search = $request->input('search.value'); 

$posts =  \App\ChargerType::where('charger_code','LIKE',"%{$search}%")
            ->orwhere('oem_code','LIKE',"%{$search}%")          
            ->orwhere('description','LIKE',"%{$search}%")          
            ->orwhere('power_rating','LIKE',"%{$search}%")          
            ->orwhere('charger_rating','LIKE',"%{$search}%")          
            ->orwhere('created_at','LIKE',"%{$search}%")          
            ->offset($start)
            ->limit($limit)
            ->orderBy($order,$dir)
            ->get();

$totalFiltered = count($posts);
}
$rows=[];
    $data = array();
    $i=1;
    if(!empty($posts))
    {
        $i=1;
    foreach ($posts as $users){
        
         $rows[] = array(
         $i,
         $users->charger_code,
         $users->description,
         $users->power_rating,
         date("d-m-Y" ,strtotime($users->created_at))
         ,'<a href="#" data-href="/chargertype/'.$users->id.'/edit" class="btn btn-xs btn-default edit-form" data-toggle="modal" data-target="#mymodel"> <i class="fa fa-edit" data-toggle="tooltip" title="'.trans('messages.edit').'"></i></a></div>');  
          $i++;
        }
}
$json_data = array(
    "draw"            => intval($request->input('draw')),  
    "recordsTotal"    => intval($totalData),  
    "recordsFiltered" => intval($totalFiltered), 
    "aaData"            => $rows   
    );
echo json_encode($json_data); 
 
	}

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($chargertype)
    {
        return view('admin.chargetypes.edit_charger_type',compact('chargertype'));

    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $chargerTypes)
    {
        $validation=Validator::make($request->all(),[
            "charger_code"      =>  "required|unique:charger_types,charger_code,".$chargerTypes->id,
            "oem_code"          =>  "required|unique:charger_types,oem_code,".$chargerTypes->id,
            "description"       =>  "required",
            "power_rating"      =>  "required",
            "status"            =>  "required",
            "charger_rating"    =>  "required"
            
        ]);



    
        if($validation->fails()){
            return redirect()->back()->withInput()->withErrors($validation->messages());
            }

            $data = $request->all();
            $chargerTypes->fill($data)->save();
        
            $this->logActivity(['module' => 'charger_type','activity' => 'activity_updated']);

          
            return redirect('/chargertype')->withSuccess(('Station').' '.trans('messages.saved'));
        
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }
}
