<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Illuminate\Support\Facades\Input;
use Session;
use Redirect;
use View;
use App\Countrys;
use App\States;
use App\Cities;
use Validator;
use DB;
class CityController extends Controller
{
    /**
     * Create a new controller instance.
     *
     * @return void
     */
   
    protected function validator(array $data)
    {
        return Validator::make($data, [
            'name' => ['required', 'string', 'max:255']
          ]);
    }
    /**
     * Show the application dashboard.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        //return (\Auth::user());
        $menu=['masters'];
        $country='';
        $state='';
        $countrys = Countrys::get()->pluck('country_name','country_id')->all();
        $states = States::get()->pluck('state_name','state_id')->all();



           $citys = DB::table('cities')
            ->leftJoin('states', 'states.state_id', '=', 'cities.state_id')
            ->select('cities.*')
            ->orderBy('states.state_name','ASC')
            ->get();
      


      //  return view('superadmin/salutation/list',$salutations);
      return View::make('admin/city.list')
      ->with(['citys'=>$citys,'states'=>$states,'countrys'=>$countrys,'menu'=>$menu]);
    }
   
    public function store(Request $request)
    {
      $validation = Validator::make($request->all(),[
        'city_name' => 'required|unique:cities,city_name',
        'country_id' => 'required',
        'state_id' => 'required',
    ]);

    if($validation->fails()){
               return redirect()->back()->withInput()->withErrors($validation->messages());
    }
   

        $citys = new Cities;
        $citys->state_id         = Input::get('state_id');
        $citys->city_name        = Input::get('city_name');
        $citys->save();

        $citys->save();

        // redirect
        $this->logActivity(['module' => 'city','activity' => 'status_added']);
        Session::flash('success', 'Successfully created City!');
        return Redirect::to('citys');

    }
    public function edit($id)
  {
    // get the nerd
    $menu=['masters'];
     $countrys = Countrys::get()->pluck('country_name','country_id')->all();


     $editcitys=DB::table('cities')
                  ->select('cities.city_id', 'cities.city_name','states.state_id','states.country_id')
                  ->join('states','cities.state_id','=','states.state_id')
                  ->join('countrys','countrys.country_id','=','states.country_id')
                  ->where('city_id',$id)
                  ->get();

    $states = States::get()->pluck('state_name','state_id')->all();

      $citys = DB::table('cities')
      ->leftJoin('states', 'states.state_id', '=', 'cities.state_id')
      ->select('cities.*')
      ->orderBy('states.state_name','ASC')
      ->get();

    // show the edit form and pass the nerd
    return View::make('admin/city.list')
      ->with(['editcitys'=>$editcitys,'citys'=>$citys,'states'=>$states,'countrys'=>$countrys,'menu'=>$menu]);
  }
  public function update($id)
  {
   
        $citys = Cities::find($id);
        $citys->state_id         = Input::get('state_id');
        $citys->city_name        = Input::get('city_name');
        $citys->save();

        $this->logActivity(['module' => 'city','unique_id'=>$id,'activity' => 'Activity_updated']);
        Session::flash('success', 'Successfully updated City!');
        return Redirect::to('citys');
    
  }
   public function destroy($id)
  {
    // get the nerd
     $ss = Cities::find($id);
     $ss->delete();
     $this->logActivity(['module' => 'city','unique_id'=>$id,'activity' => 'activity_deleted']);

     Session::flash('success', 'Successfully Deleted!');

    // show the edit form and pass the nerd
     return Redirect::to('citys');
   
  }
    public function find(){
        
      $countrys = Country::get()->pluck('name','id')->all();
        $country=input::get('country_s');
        $state=input::get('states_s');
        if(!empty($state)){
            $citys = Citys::Where('state_id',$state)->get();
        }else{
             $citys = Citys::all();
        }
       
        $states = States::get()->pluck('name','id')->all();

      //  return view('superadmin/salutation/list',$salutations);
      return View::make('superadmin/city.list')
      ->with(['citys'=>$citys,'states'=>$states,'countrys'=>$countrys,'country'=>$country,'state'=>$state]);
        
    }
 
}
