<?php

namespace App\Http\Controllers;
use QrCode;
use Illuminate\Http\Request;
use App\SlotBooking;
use PDF;
use \App\AppUser;

class CommonController extends Controller
{
    public function qrCodeGenerate($id,$connector_id){

        $nozzil = \App\StationNozzle::where(['nozzle_id'=>$id,'charger_id'=>$connector_id])->get()->first();

         $station=\App\Station::where('station_id',$nozzil->station_id)->get()->first();
         $array=array(
             'ocpp_id'           =>$nozzil->nozzle_id,
             'station_id'        =>$station->station_id,
             'charging_station'  =>$station->location_name,
             'charger_id'        => $nozzil->charger_id,

         );

       $code=json_encode($array);
		
		$charger_id=$nozzil->charger_id;



         $str='data:image/png;base64,'. base64_encode(QrCode::format('png')
         ->merge(config('constants.upload_path.logo').($station->application.'.png'), 0.1, true)
         ->size(350)
         ->errorCorrection('H')
         ->generate($code));

         return view('admin.stations.qr_code',compact('str','id','charger_id'));

     }


     public function qrCodeGeneratePDF($id,$connector_id){
      // connector_id
      $nozzil = \App\StationNozzle::where('nozzle_id',$id)->get()->first();
      $nozzil = \App\StationNozzle::where(['nozzle_id'=>$id,'charger_id'=>$connector_id])->get()->first();

        $station=\App\Station::where('station_id',$nozzil->station_id)->get()->first();
        $array=array(
            'ocpp_id'           =>$nozzil->nozzle_id,
            'station_id'        =>$station->station_id,
            'charging_station'  =>$station->location_name,
            'charger_id'        => $nozzil->charger_id,

        );

      $code=json_encode($array);
   
   $charger_id=$nozzil->charger_id;



        $str='data:image/png;base64,'. base64_encode(QrCode::format('png')
        ->merge(config('constants.upload_path.logo').($station->application.'.png'), 0.1, true)
        ->size(350)
        ->errorCorrection('H')
        ->generate($code));

        // return view('admin.stations.qr_code',compact('str','id','charger_id'));
        $pdf = PDF::loadView('pdf.qr_code',compact('str','id','charger_id'));
        return   $pdf->download($id.'_'.$charger_id.'.pdf');

    }


     public function bookings(Request $request)
     {
      $from              = $request->from;
      $to                = $request->to;
      $utc_offset_from   = $request->utc_offset_from;
      $utc_offset_to     = $request->utc_offset_to;
      
     // return date($to);
       $booking=SlotBooking::select('ocpp_id','app_users.first_name','app_users.last_name','user_id','date','slot_bookings.status','timings','slot_bookings.id')
       ->join('slot_timings','slot_timings.id','=','slot_bookings.start_time')
       ->join('app_users','app_users.id','=','slot_bookings.user_id')
       ->orderBy('date','DESC')
       ->get();

      foreach ($booking as $key => $value) {
       // return $value->date;date('d-m-Y h:i:s',$start)
         $start = strtotime($value->date.$value->timings)*1000;
        $end =  strtotime($value->date.$value->timings)*1000;
          //  $status="event-warning";
           if($value->status==1){
            $status="event-important";
            }
            if($value->status==2){
              $status="event-special";
            }
           if($value->status==3){
              $status="event-warning";
            }
            if($value->status==4){
              $status="event-inverse";
            }
        $calendar[] = array(

            "id"=>  $value->id,
            "title"=> "User Name :<a href='/appusers/$value->user_id'> $value->first_name  $value->last_name </a>".date('h:i  A',strtotime($value->date.$value->timings)).' to '.date('h:i A',strtotime($value->timings)+1800),
            "url"=> "#",
            "class"=> "$status",
            "start"=> "$start",
            "end"=>   "$end"
          
          );
      }
   
        
         $calendarData = array(
        "success" => 1,
        "result"=>$calendar);
        return json_encode($calendarData);
     }
     public function GetUsers(Request $request)
     {
       $online=AppUser::where('login_status',1)->get();
       $offline=AppUser::where('login_status',0)->get();
      return view('common.users',compact('offline','online'));

     }


}
