<?php
namespace App\Http\Controllers;
use DB;
use File;
use Auth;
use Image;
use Entrust;
use App\Classes\Helper;
use Illuminate\Http\Request;
use App\Http\Requests\ConfigurationTimeRequest;
use Validator;
use Swift_SmtpTransport;
use Swift_TransportException;
use Services_Twilio;
use Services_Twilio_RestException;
use Swift_Mailer;
use App\StationNozzle;
use Swift_Message;
use App\SMTP;

Class ConfigController extends Controller{
    use BasicController;

	public function index(){

        $assets = ['timepicker','mail_config'];
		$languages = array();
		$pakages=DB::table('pakages')->get();
		$smtp=SMTP::get()->first();
        foreach(config('lang') as $key => $value)
        	$languages[$key] = $value['language'];

		return view('configuration.index',compact('assets','languages','designations','smtp','pakages'));
	}
	public function store(Request $request){
		 $input=$request->all();
		foreach($input as $key => $value){
		       	if(!in_array($key, config('constants.ignore_var'))){
        		$config = \App\Config::firstOrNew(['name' => $key]);
        		$config->value = $value;
        		$config->save();
        	}
		}
		
		$this->logActivity(['module' => 'configuration','activity' => 'activity_added']);
		return redirect()->back()->withSuccess(trans('messages.settings_updated'));	

	}



	public function mailStore(Request $request){

	

		$validation = Validator::make($request->all(),[
				'from_address' => 'required|email',
				'from_name' => 'required',
				'host' => 'required_if:driver,smtp',
				'port' => 'required_if:driver,smtp|numeric',
				'username' => 'required_if:driver,smtp',
				'password' => 'required_if:driver,smtp',
				'encryption' => 'in:ssl,tls|required_if:driver,smtp',
				]);

		if($validation->fails()){
	        if($request->has('ajax_submit')){
	            $response = ['message' => $validation->messages()->first(), 'status' => 'error']; 
	            return response()->json($response, 200, array('Access-Controll-Allow-Origin' => '*'));
			}
			
			return redirect()->back()->withInput()->withErrors($validation->messages());
		}
		

		if($request->input('driver') == 'smtp'){
			
			$transport = new Swift_SmtpTransport($request->input('host'), $request->input('port'));
			$transport->setUsername($request->input('username'));
			$transport->setPassword($request->input('password'));
			$mailer = new Swift_Mailer($transport);

			$input=$request->all();
			foreach($input as $key => $value){
					   if(!in_array($key, config('constants.ignore_var'))){
					$config = \App\Config::firstOrNew(['name' => $key]);
					$config->value = $value;
					$config->save();
				}
			}
	
			
		}		
		$this->logActivity(['module' => 'mail','activity' => 'activity_added']);
		
		return redirect('/settings/#'.$request->input('config_type'))->withSuccess(trans('messages.settings_updated'));			

	}

	public function logoStore(Request $request){

        $validation = Validator::make($request->all(),[
            'logo' => 'image'
        ]);

        if($validation->fails()){
        	
        	return redirect()->back()->withErrors($validation->messages()->first());
        }

	
		$filename = uniqid();
		$config = \App\Config::firstOrNew(['name' => 'logo']);

		if ($request->hasFile('logo') && $request->input('remove_logo') != 1){
			if(File::exists(config('constants.upload_path.logo').config('config.logo')))
				File::delete(config('constants.upload_path.logo').config('config.logo'));
           $extension = $request->file('logo')->getClientOriginalExtension();
           $file = $request->file('logo')->move(config('constants.upload_path.logo'), $filename.".".$extension);
            $img = Image::make(config('constants.upload_path.logo').$filename.".".$extension);
            $img->resize(200, null, function ($constraint) {
                $constraint->aspectRatio();
            });
            $img->save(config('constants.upload_path.logo').$filename.".".$extension);
            $config->value = $filename.".".$extension;
		} elseif($request->input('remove_logo') == 1){

			if(File::exists(config('constants.upload_path.logo').config('config.logo')))
				File::delete(config('constants.upload_path.logo').config('config.logo'));
			$config->value = null;
        }

        $config->save();

		$this->logActivity(['module' => 'logo','activity' => 'activity_updated']);

    	if($request->has('ajax_submit')){
	        $response = ['message' => trans('messages.configuration_updated'), 'status' => 'success']; 
	        return response()->json($response, 200, array('Access-Controll-Allow-Origin' => '*'));
	    }

		return redirect('/settings#'.$request->input('config_type'))->withSuccess(trans('messages.configuration_updated'));	
	}
	
	public function storePkg(Request $request)
	{
		
		$validation = Validator::make($request->all(),[
			'package' => 'required'
			]);

	if($validation->fails()){
		if($request->has('ajax_submit')){
			$response = ['message' => $validation->messages()->first(), 'status' => 'error']; 
			return response()->json($response, 200, array('Access-Controll-Allow-Origin' => '*'));
		}
		
		return redirect()->back()->withInput()->withErrors($validation->messages());
	}
	
					DB::table('pakages')->insert(['short_name' => $request->package, 'name' => ucfirst($request->package)]);
					return redirect('/settings#package')->withSuccess(trans('messages.configuration_updated'));	
	
	}


	public function packageEdit(Request $pakages,$id){

		$pakages=DB::table('pakages')->where('id',$id)->get()->first();
		return view('configuration.pkg_edit',compact('pakages'));
	}


	public function changePrices(Request $request)
	{
		$validation = Validator::make($request->all(),[
			'price_unit' => 'required',
			'price_time' => 'required',
			]);

	if($validation->fails()){
		//if($request->has('ajax_submit')){
			$response = ['message' => $validation->messages()->first(), 'status' => 'error']; 
			return response()->json($response, 200, array('Access-Controll-Allow-Origin' => '*'));
		//}
		
		//return redirect()->back()->withInput()->withErrors($validation->messages());
	}
	$input=$request->all();
	foreach($input as $key => $value){
			   if(!in_array($key, config('constants.ignore_var'))){
			$config = \App\Config::firstOrNew(['name' => $key]);
			$config->value = $value;
			$config->save();



			//price
		}
	}
	if($request->price_unit){

	}
	$affected = DB::table('station_nozzles')->where('status', '=', 'active')->update(array('price' =>$request->price_unit ));

	$this->logActivity(['module' => 'configuration','activity' => 'activity_added']);
	$response = ['message' =>"Updated Successfully", 'status' => 'success']; 
	return response()->json($response, 200, array('Access-Controll-Allow-Origin' => '*'));
	}

	public function packageUpdate(Request $request){
		$id=$request->package_id;
		$name=$request->name;
		$short_name=$request->short_name;
		$pakages=DB::table('pakages')->where('id',$id)->update(array('name' => $name,'short_name'=>$short_name));
		return redirect('/settings#package')->withSuccess(trans('messages.configuration_updated'));	
	}

}
?>