<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Illuminate\Support\Facades\Input;
use Session;
use Redirect;
use View;
use Validator;

use App\Countrys;
use App\State;
use App\States;

class CountryController extends Controller
{
    /**
     * Create a new controller instance.
     *
     * @return void
     */
    

    protected function validator(array $data)
    {
        return Validator::make($data, [
            'name' => ['required', 'string', 'max:255']
          ]);
    }
    /**
     * Show the application dashboard.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        //return (\Auth::user());
        $countrys = Countrys::all();
        $menu=['masters'];
      //  return view('superadmin/salutation/list',$salutations);
      return View::make('admin.country.list')
            ->with(['countrys'=> $countrys,'menu'=>$menu]);
    }
   
    public function store(Request $request)
    {
        $validation = Validator::make($request->all(),[
            'country_name' => 'required|unique:countrys,country_name'
        ]);

        if($validation->fails()){
           
            return redirect()->back()->withInput()->withErrors($validation->messages());
        }

        $countrys = new Countrys;
        $countrys->country_name       = Input::get('country_name');
        $countrys->save();

        // redirect
        $this->logActivity(['module' => 'country','activity' => 'activity_added']);
        Session::flash('success', 'Successfully created Country!');
        return Redirect::to('country');

    }
    public function edit($id)
  {
    // get the nerd
     $countrys = Countrys::all();
     $editcountry = Countrys::find($id);

    // show the edit form and pass the nerd
    return View::make('admin.country.list')
      ->with(['editcountry'=>$editcountry,'countrys'=>$countrys,'menu'=>$menu]);
  }
  public function update($id)
  {
   
     $countrys = Countrys::find($id);
        $countrys->country_name  = Input::get('country_name');
        $countrys->save();

        $this->logActivity(['module' => 'country','unique_id'=>$id,'activity' => 'activity_updated']);
        Session::flash('message', 'Successfully updated Country!');
        return Redirect::to('country');
    
  }
   public function destroy($id)
  {
    // get the nerd
    return $countrys = Countrys::find($id);
     $countrys->delete();
     $this->logActivity(['module' => 'country','unique_id'=>$id,'activity' => 'activity_deleted']);
Session::flash('success', 'Successfully Deleted Country!');
    // show the edit form and pass the nerd
     return Redirect::to('country');
   
  }


  public function getStates($id)
  {
      return States::where('country_id',$id)->get();
  }
  
}
