<?php

namespace App\Http\Controllers\Franchises;

use Illuminate\Http\Request;
use App\AppUser;
use Illuminate\Support\Facades\Storage;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Facades\Validator;
use Illuminate\Support\Facades\Auth;
use DB;
use Illuminate\Support\Facades\Input;
use Session;
use Redirect;
use View;
use Entrust;
use App\Classes\Helper;

class AppUsersController extends Controller
{
    use BasicController;
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $roles = \App\Role::whereIsHidden(0)->get()->pluck('name','id')->all();

        $col_heads = array(
                trans('messages.first_name'),
                trans('messages.last_name'),
                trans('messages.email'),
                trans('messages.mobile'),
                trans('messages.status'),
                trans('messages.image'),
                trans('messages.option'));
        $table_info = array(
            'source' => 'appusers',
            'title'  => 'Employee List',
            'id'     => 'usefdrs',
            'form'   => 'employee_filter_form'
        );
        $menu = ['appusers'];
        $packages = Helper::translateList(config('lists.packages'));
        $state=\App\States::get()->pluck('state_name','state_id')->all();
        

        
        return view('franchise.admin.appusers.index',compact('col_heads','table_info','roles','menu','packages','state'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {

        $packages = Helper::translateList(config('lists.packages'));
        $menu = ['appusers'];
        $appuser=AppUser::find($id);
        return view('franchise.admin.appusers.view',compact('appuser','menu','packages'));
    }
//display data into table using AJAX Request
    public function lists(Request $request){

        $columns = array( 
            0 =>'first_name',
            1=> 'last_name',
            2=> 'email',
            3=> 'mobile',
            4=> 'status',
            5=> 'image',
            6=> 'status',
        );

    $totalData = \App\AppUser::where('package_name',Auth::user()->organization)->count();

    $totalFiltered = $totalData; 

    $limit = $request->input('length');
    $start = $request->input('start');
    $order = $columns[$request->input('order.0.column')];
    $dir = $request->input('order.0.dir');

    if(!empty($request->application) || !empty($request->state) || !empty($request->city)){

        if($request->application){
            $searchhh['package_name']=$request->application;
           }
           if($request->state){
            $searchhh['state_id']=$request->state;
           }
           if($request->city){
            $searchhh['city_id']=$request->city;
           }
      
        if($searchhh){
    $posts =  \App\AppUser::where($searchhh)
            ->join('app_user_profiles','app_user_id','=','app_users.id')
            ->where('package_name',Auth::user()->organization)
            ->offset($start)
            ->limit($limit)
            ->orderBy($order,$dir)
            ->get();

        $totalFiltered = count($posts);

        }
    }
    elseif(empty($request->input('search.value')))
    {            
    $posts = \App\AppUser::offset($start)
    ->where('package_name',Auth::user()->organization)
            ->limit($limit)
            ->orderBy($order,$dir)
            ->get();
    } else {
$search = $request->input('search.value'); 

$posts =  \App\AppUser::where('mobile','LIKE',"%{$search}%")
            ->where('package_name',Auth::user()->organization)
            ->orWhere('first_name', 'LIKE',"%{$search}%")
            ->orWhere('last_name', 'LIKE',"%{$search}%")
            ->orWhere('email', 'LIKE',"%{$search}%")
            ->orWhere('status', 'LIKE',"%{$search}%")
            ->offset($start)
            ->limit($limit)
            ->orderBy($order,$dir)
            ->get();

$totalFiltered = \App\AppUser::where('mobile','LIKE',"%{$search}%")
             ->where('package_name',Auth::user()->organization)
             ->orWhere('first_name', 'LIKE',"%{$search}%")
             ->orWhere('last_name', 'LIKE',"%{$search}%")
             ->orWhere('email', 'LIKE',"%{$search}%")
             ->orWhere('status', 'LIKE',"%{$search}%")
             ->count();
}
$rows=[];
    $data = array();
    $i=1;
    if(!empty($posts))
    {
        $i=1;
    foreach ($posts as $users){
        
        $rows[] = array(
         $users->first_name,
         $users->last_name,
         $users->email,
         $users->mobile,
         ($users->status == 'active' || $users->status == '') ? '<span class="label label-success">'.trans('messages.active').'</span>' : '<span class="label label-danger">'.Helper::toWord($users->status).'</span>'
          ,'<a href="#" class="pop">
          <img src="/'.$users->image.'" class="wd-40 rounded-circle"  alt=""></a>'
         , '<div class="btn-group btn-group-xs">'.
          '<a href="/franchise/appusers/'.$users->id.'" class="btn btn-xs btn-default" > <i class="fa fa-eye" data-toggle="tooltip" title="'.trans('messages.view').'"></i></a> '.
          ((!Entrust::can('change-app-user-status')) ? '<a href="#" data-href="/franchise/appusers/'.$users->id.'/change-status" class="btn btn-default btn-xs edit-form" data-toggle="modal" data-target="#mymodel"> <i class="fa fa-user" data-toggle="tooltip" title="'.trans('messages.change').' '.trans('messages.status').'"></i></a> ' : '').
          '</div>',);  
          $i++;
        }
}
$json_data = array(
    "draw"            => intval($request->input('draw')),  
    "recordsTotal"    => intval($totalData),  
    "recordsFiltered" => intval($totalFiltered), 
    "aaData"            => $rows   
    );
echo json_encode($json_data); 
        
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
       
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }




    public function changeStatus($id){

        $user = \App\AppUser::find($id);

        if(!$user || Entrust::can('change-app-user-status'))
            return view('common.error',['message' => trans('messages.permission_denied')]);

      
        return view('franchise.admin.appusers.change_status',compact('user'));

    }
    public function postChangeStatus(Request $request, $id){

        $user = \App\AppUser::find($id);

        $validation = Validator::make($request->all(),[
            'status' => 'required'
        ]);

        if($validation->fails()){
        
            return redirect()->back()->withErrors($validation->messages()->first());
        }

        $user->status = $request->input('status');
        $user->save();


        $this->logActivity(['module' => 'app_user','unique_id'=>$id,'activity' => 'Status_changed']);
        return redirect('franchise/appusers')->withSuccess(trans('messages.user').' '.trans('messages.status').' '.trans('messages.updated'));
    }


    
}
