<?php

namespace App\Http\Controllers\Franchises;

use Illuminate\Http\Request;
use App\ChargerType;
use App\ChargePointTypes;
use App\StationNozzle;

class ChargerController extends Controller
{
    use BasicController;
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        //
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create(Request $request)
    {
        $connections=ChargePointTypes::get()->pluck('name','id')->all();
        $station=$request->station;
        $menu['menu']="stations";
        $chargers=ChargerType::get()->pluck('charger_code','id')->all();
        return view('franchise.chargers.add_charger',compact('menu','chargers','station','connections'));
    }
    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        try {
            $id =\Crypt::decrypt($id);
        } catch (Illuminate\Contracts\Encryption\DecryptException $e) {
            return $e;
            
        }
        $editcharger=StationNozzle::find($id);
        $connections=ChargePointTypes::get()->pluck('name','id')->all();
        $menu['menu']="stations";
        $chargers=ChargerType::get()->pluck('charger_code','id')->all();
        return view('franchise.chargers.edit_chargere',compact('menu','chargers','connections','editcharger'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        try {
            $id = \Crypt::decrypt($id);
        } catch (Illuminate\Contracts\Encryption\DecryptException $e) {
            return $e;
            
        }

        $chargers=StationNozzle::find($id);

       $validation = \Validator::make($request->all(),[
        'type'           => 'required',
        'station_id'     => 'required',
        'nozzle_id'      => 'required|unique:station_nozzles,nozzle_id,'.$chargers->id,
        'charger_code'   => 'required',
        'power_rating'   => 'required',
        'description'    => 'required',
        'simno'          => 'required||unique:station_nozzles,simno,'.$chargers->id,
    ], ['nozzle_id.required' => 'Ocpp Id required',
        'nozzle_id.unique' => 'Ocpp Id Already Exist']);
    if($validation->fails()){
        return redirect()->back()->withInput()->withErrors($validation->messages());
    }

    $chargers->type             =$request->type;
    $chargers->nozzle_id        =$request->nozzle_id;
    $chargers->charger_code     =$request->charger_code;
    $chargers->power_rating     =$request->power_rating;
    $chargers->description      =$request->description;
    $chargers->simno            =$request->simno;
    $chargers->save();

    $station=\App\Station::where('station_id', $request->station_id)->get()->first();
    


    
    $this->logActivity(['module' => 'stations_nozzil','activity' => 'activity_updated']);

    return redirect('franchise/stations/'.\Crypt::encrypt($station->id))->withSuccess(trans('Charger').' '.trans('messages.updated'));
       

   

    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }


    public function chargerTypeDescription(Request $request){
        $chargertype=ChargerType::find($request->charger_id);

        return $chargertype->description;
    }
}
