<?php

namespace App\Http\Controllers\Franchises;

use Illuminate\Http\Request;
use Illuminate\Support\Facades\Input;
use Session;
use Redirect;
use View;
use App\Countrys;
use Validator;;

use App\States;
use DB;
use App\Cities;

class StateController extends Controller
{
    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct()
    {
        $this->middleware('auth:franchise');
    }

    protected function validator(array $data)
    {
        return Validator::make($data, [
            'state_name' => ['required', 'string', 'max:255']
          ]);
    }
    /**
     * Show the application dashboard.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        //return (\Auth::user());
        
               

        $states = DB::table('countrys')
            ->join('states', 'countrys.country_id', '=', 'states.country_id')
            ->select('states.*', 'countrys.country_name as country')
            ->orderBy('states.state_name')
            ->get();
        $countrys = Countrys::all();
        //$citys = Citys::all();
     
      return View::make('franchise.state.list')
            ->with(['states'=>$states,'countrys'=>$countrys]);
    }
   
    public function store(Request $request)
    {

        $validation = Validator::make($request->all(),[
            'state_name' => 'required|unique:states,state_name',
            'country_id' => 'required',
        ]);

        if($validation->fails()){
          
            return redirect()->back()->withInput()->withErrors($validation->messages());
        }

        $states = new States;
        $states->state_name       = Input::get('state_name');
         $states->country_id       = Input::get('country_id');
        $states->save();

        // redirect
        Session::flash('success', 'Successfully created State!');
        return Redirect::to('states');

    }
    public function edit($id)
  {
    // get the nerd
    $states = DB::table('countrys')
    ->join('states', 'countrys.country_id', '=', 'states.country_id')
    ->select('states.*', 'countrys.country_name as country')
    ->orderBy('states.state_name')
    ->get();
    $countrys = Countrys::get()->pluck('country_name','country_id')->all();
     $editstates = States::find($id);

    // show the edit form and pass the nerd
    return View::make('admin/state.list')
      ->with(['editstates'=>$editstates,'states'=>$states,'countrys'=>$countrys]);
  }
  public function update(Request $request,$id)
  {
    $validation = Validator::make($request->all(),[
        'state_name' => 'required|unique:states,state_name,'.$id,
        'country_id' => 'required',
    ]);

    if($validation->fails()){
               return redirect()->back()->withInput()->withErrors($validation->messages());
    }
   
     $states = States::find($id);
       $states->country_id  = Input::get('country_id');
        $states->state_name  = Input::get('state_name');
        $states->save();

        Session::flash('success', 'Successfully updated State!');
        return Redirect::to('states');
    
  }
   public function destroy($id)
  {
    // get the nerd
     $states = States::find($id);
     $states->delete();

    // show the edit form and pass the nerd
    Session::flash('success', 'Successfully Deleted State!');
     return Redirect::to('states');
   
  }
  
    //  public function getCitys($state)
    // {
    //     return  $states = Citys::where('state_id',$state)->get();
    // }

     public function getCities($state)
    {
        return  $state = Cities::where('state_id',$state)->get();
    }
 
}
