<?php

namespace App\Http\Controllers\Franchises;

use Illuminate\Http\Request;
use App\Station;
use App\Classes\Helper;
use Entrust;
use Validator;
use App\States;
use App\Cities;
use DB;
use Auth;
use QrCode;
use Crypt;
use App\User;
use App\Franchise;
use App\StationNozzle;
use App\ChargePointTypes;

class StationsController extends Controller
{
    use BasicController;

    public function __construct()
    {
        $this->middleware('auth:franchise');
    }
   public function index(){

    
       $title='Stations';

       $menu['menu']="stations";

       $col_heads = array(
        		
        'station '.trans('messages.name'),
        trans('Station Id'),
        trans('location'),
        trans('latitude'),
        trans('longitude'),
        trans('messages.status'),
        trans('messages.option'),
        trans('Charger'),

        );
        $table_info = array(
			'source' => 'stations',
			'title' => 'stations  List',
			'id' => 'stations_table'
        );
        
       return view('franchise.admin.stations.index',compact(['title','col_heads','table_info']));
   }

   public function create(){

    $title='Add Stations';
    $servicetax=DB::table('service_taxs')->get();
    $packages=DB::table('pakages')->get()->pluck('name','short_name')->all();
    $state=States::get()->pluck('state_name','state_id')->all();
    return view('franchise.admin.stations.add',compact(['title','servicetax','state','packages']));
   }



   public function lists(Request $request){
	   
	   $stationss = new Station;
        //$stationss =$legonModel->setConnection('franchise');
        $columns = array( 

            0 =>'station_name',
            1=> 'station_id',
            2=> 'location_name',
            3=> 'status',
            4=> 'latitude',
            5=> 'longitude',
            6=> 'status',
            7=> 'status',

        );

               $totalData = $stationss->where('created_by_id',Auth::user()->franchaise_id)->count();

                $totalFiltered = $totalData; 

                $limit = $request->input('length');
                $start = $request->input('start');
                $order = $columns[$request->input('order.0.column')];
                $dir = $request->input('order.0.dir');

                if(empty($request->input('search.value')))
                {            
                $template = $stationss->offset($start)
                        ->where(['created_by'=>'franchise','created_by_id'=>Auth::user()->franchaise_id])
                        ->limit($limit)
                        ->orderBy($order,$dir)
                        ->get();
                }
                else {
                    $search = $request->input('search.value'); 

                    $template =  \App\Station::where('station_name','LIKE',"%{$search}%")
                            ->orWhere('station_id', 'LIKE',"%{$search}%")
                            ->orWhere('location', 'LIKE',"%{$search}%")
                            ->offset($start)
                            ->limit($limit)
                            ->orderBy($order,$dir)
                            ->get();
    
                    $totalFiltered = \App\Station::where('station_name','LIKE',"%{$search}%")
                            ->orWhere('station_id', 'LIKE',"%{$search}%")
                            ->orWhere('location', 'LIKE',"%{$search}%")
                            ->count();
                    }
                    $rows=[];
                    $data = array();
                    $i=1;
                    if(!empty($template))
                    {
                        $i=1;
                    foreach ($template as $template){
    
                        $rows[] = array(
                            $template->station_name,
                            Helper::toWord($template->station_id),
                            Helper::toWord($template->location_name),
                            $template->latitude,
                            $template->longitude,
      
                    '<span class="label label-'.$template->status.'">'.Helper::toWord($template->status).'</span>',
                    '<div class="btn-group btn-group-xs">'.
                    (($template->created_by=='franchise') ? '<a href="#" data-href="stations/'.Crypt::encrypt($template->id).'/change-status" class="btn btn-default btn-xs edit-form" data-toggle="modal" data-target="#mymodel"> <i class="fa fa-user" data-toggle="tooltip" title="'.trans('messages.change').' '.trans('messages.status').'"></i></a> ' : '').
                    (($template->created_by=='franchise') ? '<a href="stations/'.Crypt::encrypt($template->id).'/edit" class="btn btn-xs btn-default" > <i class="fa fa-edit" data-toggle="tooltip" title="'.trans('messages.edit').'"></i></a> ' : '').
                    // (!$template->is_default ? delete_form(['vehiclemanufacturer.destroy',$template->id],'template',1) : '').
                    '</div>',
                    (($template->status != 'in-active') ? '<a href="stations/'.Crypt::encrypt($template->id).'" class="btn btn-default btn-xs edit-form" ><i class="fa fa-plug" data-toggle="tooltip" title="'.trans('View Chargers').'"></i></a> ' : '')
                    ,

                    );  
                                 $i++;
                }
                }
                $json_data = array(
                "draw"            => intval($request->input('draw')),  
                "recordsTotal"    => intval($totalData),  
                "recordsFiltered" => intval($totalFiltered), 
                "aaData"            => $rows   
                );
                echo json_encode($json_data); 
        
        }

        public function edit(Station $stations,$id){
            $menu['menu']="stations";
            $id=Crypt::decrypt($id);
            $servicetax=DB::table('service_taxs')->get();
            $packages=DB::table('pakages')->get()->pluck('name','short_name')->all();

                    // if(!Entrust::can('edit-stations'))
                    //     return redirect('/stations')->withErrors(trans('messages.permission_denied'));

                        $station=Station::find($id);
                        $mapicon='';
                        $status='';
                        if($station->status=='active'){
                            $mapicon=url('assets/img/map/active.png');
                            $status='success';
                        }else{
                            $mapicon=url('assets/img/map/banned.png');
                            $status='danger';
                        }
                        $state=States::get()->pluck('state_name','state_id')->all();
                        $cities=Cities::get()->pluck('city_name','city_id')->all();
                    
                    
                   
            
            return view('franchise.admin.stations.edit',compact('menu','servicetax','packages','cities','state','station','mapicon','status'));
        }

        public function store(Station $stations,Request $request){


            	
			try{
		
                $validation = Validator::make($request->all(),[
                    'latitude' => 'required',
                    'longitude' => 'required',
                    'station_name' => 'required|unique:stations,station_name',
                    'location_name' => 'required',
                    'city_id'   =>'required',
                    'state_id' => 'required',
                    'address'   =>'required',
					'opening_time'  => 'required',
					'closing_time'  => 'required',


                    
                ]);
				
					
					
            
                if($validation->fails()){
                        return redirect()->back()->withInput()->withErrors($validation->messages());
                }
                $station_code = strtoupper(substr($request->location_name, 0, 4));

                $taxes=array();
                DB::beginTransaction();


                foreach ($request->tax as $key => $value) {
                 $tax_name=$servicetax=DB::table('service_taxs')->where('id',$key)->get()->first();

                 $tax=array(
                     'id'       =>  $key,
                     'name'     =>  $tax_name->name,
                     'value'    =>  $value,
                    );
                    \array_push($taxes, $tax);
                }

                $service_tax=  json_encode($taxes);

                $data = $request->all();
                $station_id="EVM".$station_code.randomString(5);
                $stations->station_id=str_replace(" ",'',$station_id);
                $stations->service_tax=$service_tax;
                $stations->created_by='franchise';
                $stations->created_by_id=Auth::user()->franchaise_id; 
                $stations->application  =Auth::user()->organization; 
                $stations->fill($data)->save();
            
                $this->logActivity(['module' => 'Stations','activity' => 'activity_added']);
				
				

              DB::commit();
                return redirect('franchise/stations')->withSuccess(('Station').' '.trans('messages.saved'));
				
				}catch(Exception $e){

                    DB::rollback();
					 return redirect('franchise/stations')->withErrors(('Station').' '.trans('Something Went Wrong'));
				
				}


        }
        public function show($id)
        {
            $id=Crypt::decrypt($id);
            $servicetax=DB::table('service_taxs')->get();

            $stations=Station::join('cities','cities.city_id','=','stations.city_id')->where('id',$id)->first();
            $connections=ChargePointTypes::get()->pluck('name','id')->all();
            $menu=['masters'];

            $connections=ChargePointTypes::get()->pluck('name','id')->all();
			// $legonModel = new Station;
            //$legonModel->setConnection('franchise');
            // $stations=$legonModel->find($id);
			$stations_id=$stations->station_id;
			
			$nozils = new StationNozzle;
           // $nozils->setConnection('franchise');
			
            $nozilss=$nozils->select('station_nozzles.*','db_ocpp.charge_point_types.name as connection_type')
            ->join('db_ocpp.charge_point_types','db_ocpp.charge_point_types.id','=','station_nozzles.type')
            ->where('station_id',$stations_id)->get();
            

            $created_by="";
            $mapicon='';
            $status='';
            if($stations->status=='active'){
                $mapicon=url('assets/img/map/active.png');
                $status='success';
            }else{
                $mapicon=url('assets/img/map/banned.png');
                $status='danger';
            }
            if($stations->created_by=='admin'){
            $user=User::find($stations->created_by_id);
                $created_by=$user->fullname;
            }else{
                $franchise=Franchise::where('franchaise_id',$stations->created_by_id)->get()->first();
                $created_by=$franchise->fullname;

            }

           
            
           return view('franchise.admin.stations.view',compact('servicetax','connections','stations','created_by','status','mapicon','nozilss'));
        }


        public function update(Request $request,$id){


            $validation = Validator::make($request->all(),[
                'latitude' => 'required',
                'longitude' => 'required',
                'station_name' => 'required|unique:stations,station_name,' .$id.',id',
                'location_name' => 'required',
                'city_id'   =>'required',
                'state_id' => 'required',
                'address'   =>'required',
                'application'   =>'required',
				'opening_time'  => 'required',
				'closing_time'  => 'required',
            ]);

            
            try{
    
                if($validation->fails()){
                    if($request->has('ajax_submit')){
                        $response = ['message' => $validation->messages()->first(), 'status' => 'error']; 
                        return response()->json($response, 200, array('Access-Controll-Allow-Origin' => '*'));
                    }
                    return redirect()->back()->withInput()->withErrors($validation->messages());
                }
               
            $taxes=array();
            DB::beginTransaction();


            foreach ($request->tax as $key => $value) {
             $tax_name=$servicetax=DB::table('service_taxs')->where('id',$key)->get()->first();

             $tax=array(
                 'id'       =>  $key,
                 'name'     =>  $tax_name->name,
                 'value'    =>  $value,
                );
                \array_push($taxes, $tax);
            }
            $service_tax=  json_encode($taxes);
			$stationss = new Station;
            //$stationss =$legonModel->setConnection('franchise');
            $stations = $stationss->find($id);
			// $stations->station_name =$request->station_name;
            // $stations->latitude     =$request->latitude;
            // $stations->longitude    =$request->longitude;
			// $stations->city_id      =$request->city_id;
            // $stations->state_id     =$request->state_id;
            // $stations->save();
			
			$station_id=$stations->station_id;
		    $super_stations=\App\Station::where('station_id',$station_id)->first();
			
		    $stations->station_name    = $request->station_name;
            $stations->location_name   = $request->location_name;
            $stations->latitude        = $request->latitude;
            $stations->longitude       = $request->longitude;
            $stations->city_id         = $request->city_id;
            $stations->state_id        = $request->state_id;
            $stations->address         = $request->address;
            $stations->service_tax     = $service_tax;
            $stations->application     = $request->application;
			$stations->opening_time    = $request->opening_time;
			$stations->closing_time    = $request->closing_time;
            $stations->save();

            $super_stations->save();


            $this->logActivity(['module' => 'stations','unique_id'=>$super_stations->id,'activity' => 'activity_updated']);
            DB::commit();
           return redirect('franchise/stations')->withSuccess(trans('Stations').' '.trans('messages.updated'));
       }catch(Exception $e){
           DB::rollback();
           return redirect('franchise/stations')->withErrors("Something Went Wrong");
       }
       }


        public function changeStatus($id){
			$id=Crypt::decrypt($id);
			$legonModel = new Station;
            // $stationss =$legonModel->setConnection('franchise');

                $stations = $legonModel->find($id);

                return view('franchise.admin.stations.change_status',compact('stations'));

        }
        public function postChangeStatus(Request $request, $id){
           //$id=Crypt::decrypt($id);
				$legonModel = new Station;
               // $stationss =$legonModel->setConnection('franchise');
                $stations = $legonModel->find($id);
				
				
				$station_id=$stations->station_id;
				$super_stations=\App\Station::where('station_id',$station_id)->first();

                $validation = Validator::make($request->all(),[
                    'status' => 'required'
                ]);

                if($validation->fails()){
                    if($request->has('ajax_submit')){
                        $response = ['message' => $validation->messages()->first(), 'status' => 'error']; 
                        return response()->json($response, 200, array('Access-Controll-Allow-Origin' => '*'));
                    }
                    return redirect()->back()->withErrors($validation->messages()->first());
                }

                // $stations->status = $request->input('status');
                // $stations->save();
				$super_stations->status = $request->input('status');
                $super_stations->save();
                $this->logActivity(['module' => 'station_status','unique_id'=>$super_stations->id,'activity' => 'status_updated']);

                if($request->has('ajax_submit')){
                    $response = ['message' => trans('messages.stations').' '.trans('messages.status').' '.trans('messages.updated'), 'status' => 'success']; 
                    return response()->json($response, 200, array('Access-Controll-Allow-Origin' => '*'));
                }
                return redirect('franchise/stations')->withSuccess(trans('messages.stations').' '.trans('messages.status').' '.trans('messages.updated'));
        }



    public function addNozzil(Request $request){

        $validation = Validator::make($request->all(),[
            'type'           => 'required',
            'station_id'     => 'required',
            'nozzle_id'      => 'required|unique:station_nozzles,nozzle_id',
            'charger_code'   => 'required',
            'power_rating'   => 'required',
            'description'    => 'required',
            'simno'          => 'required',
        ], ['nozzle_id.required' => 'Ocpp Id required',
            'nozzle_id.unique' => 'Ocpp Id Already Exist']);
        if($validation->fails()){
            return redirect()->back()->withInput()->withErrors($validation->messages());
        }


       
       try {
           $decrypted = Crypt::decrypt($request->station_id);
       } catch (Illuminate\Contracts\Encryption\DecryptException $e) {
           return $e;
           
       }

       $stations = Station::find($decrypted);

     $stations_id= $stations->station_id;
        
        $station_code = strtoupper(substr($stations->location_name, 0, 4));
        
        // $nozzle_id=Helper::nozzilCode($station_code);
        // return $request->all();

        $nozzil=new StationNozzle;
        $nozzil->type            =$request->type;
        $nozzil->station_id        =$stations_id;
        $nozzil->nozzle_id        =$request->nozzle_id;
        $nozzil->charger_code     =$request->charger_code;
        $nozzil->power_rating     =$request->power_rating;
        $nozzil->description      =$request->description;
        $nozzil->simno            =$request->simno;
        $nozzil->charger_id            =$request->charger_id;
        

        $nozzil->save();

        $this->logActivity(['module' => 'nozzil','unique_id'=>$nozzil->id,'activity' => 'nozzil_Added']);
		
        return redirect('franchise/stations/'.$request->station_id)->withSuccess(trans('Nozzil').' '.trans('messages.saved'));
       

    }


        public function changeNozzilStatus($id)
		
        {
            $id=Crypt::decrypt($id);
			$legonModel = new StationNozzle;
           // $stationss =$legonModel->setConnection('franchise');				
            $nozzil = $legonModel->find($id);

            return view('franchise.admin.stations.change_nozzil_status',compact('nozzil'));
        }


        public function postChangeNozzilStatus(Request $request, $id){
			//$id=Crypt::decrypt($id);
			$legonModel = new StationNozzle;
            // $stationss =$legonModel->setConnection('franchise');				
            $nozzil = $legonModel->find($id);
			
			$nozil_id=$nozzil->nozzle_id;
			
			$nozilss=StationNozzle::where('nozzle_id',$nozil_id)->get()->first();
			

            $validation = Validator::make($request->all(),[
                'status' => 'required'
            ]);

            if($validation->fails()){
                if($request->has('ajax_submit')){
                    $response = ['message' => $validation->messages()->first(), 'status' => 'error']; 
                    return response()->json($response, 200, array('Access-Controll-Allow-Origin' => '*'));
                }
                return redirect()->back()->withErrors($validation->messages()->first());
            }

            // $nozzil->status = $request->input('status');
            // $nozzil->save();
			
			$nozilss->status = $request->input('status');
            $nozilss->save();
            $this->logActivity(['module' => 'nozzil_status','unique_id'=>$nozzil->id,'activity' => 'type_updated']);

            if($request->has('ajax_submit')){
                $response = ['message' => trans('Nozzil').' '.trans('messages.status').' '.trans('messages.updated'), 'status' => 'success']; 
                return response()->json($response, 200, array('Access-Controll-Allow-Origin' => '*'));
            }
            return redirect()->back()->withSuccess(trans('messages.stations').' '.trans('messages.status').' '.trans('messages.updated'));
 
        }






        public function changeNozzilType($id)
        {
            $id=Crypt::decrypt($id);
			$legonModel = new StationNozzle;
            // $stationss =$legonModel->setConnection('franchise');
                //$stations = $stationss->find($id);
				
            $nozzil = $legonModel->find($id);
            $connections=ChargePointTypes::get()->pluck('name','id')->all();
			

            if(!$nozzil || Entrust::can('change-station-status') || $nozzil->status == 'in-active')
                return view('common.error',['message' => trans('messages.permission_denied')]);

            return view('franchise.admin.stations.change_nozzil_type',compact('connections','nozzil'));
        }


        public function postChangeNozzilType(Request $request, $id){
            //$id=Crypt::decrypt($id);
            $legonModel = new StationNozzle;
           // $stationss =$legonModel->setConnection('franchise');				
            $nozzil = $legonModel->find($id);
			$nozil_id=$nozzil->nozzle_id;
			
			$nozilss=StationNozzle::where('nozzle_id',$nozil_id)->get()->first();

            $validation = Validator::make($request->all(),[
                'type' => 'required'
            ]);

            if($validation->fails()){
               return redirect()->back()->withErrors($validation->messages()->first());
            }

            // $nozzil->type = $request->input('type');
            // $nozzil->save();
			$nozilss->type = $request->input('type');
            $nozilss->save();
            $this->logActivity(['module' => 'nozzil_type','unique_id'=>$nozzil->id,'activity' => 'type_updated']);

            return redirect()->back()->withSuccess(trans('messages.stations').' '.trans('messages.status').' '.trans('messages.updated'));
 
        }

        // $price=$request->price;
        // $capacity=$request->capacity;
        // $id=$request->id;
        // $charger_id=$request->charger_id;
        // if($price){
        //         $nozzil = \App\StationNozzle::where(['nozzle_id'=>$id,'charger_id'=>$charger_id])->get()->first();
        //         $nozzil->price=$price;
        //         $nozzil->save();
        // $this->logActivity(['module' => 'nozzil_price','unique_id'=>$nozzil->id,'activity' => 'type_updated']);
        //         $response = ['message' => trans('Updated Successfully'), 'status' => 'success']; 
        //         return response()->json($response, 200, array('Access-Controll-Allow-Origin' => '*'));
            
        // }
        // if($capacity){
        //         $nozzil = \App\StationNozzle::where('nozzle_id',$id)->get()->first();
        //         $nozzil->capacity=$capacity;
        //         $nozzil->save();
        // $this->logActivity(['module' => 'nozzil_capacity','unique_id'=>$nozzil->id,'activity' => 'type_updated']);
        //         $response = ['message' => trans('Updated Successfully'), 'status' => 'success']; 
        //         return response()->json($response, 200, array('Access-Controll-Allow-Origin' => '*'));
        // }
		
        public function changeNozzilPriceCapacity(Request $request){

            $price=$request->price;
            $capacity=$request->capacity;
            $id=$request->id;
            $charger_id=$request->charger_id;
            if($price){
                    $nozzil = \App\StationNozzle::where(['nozzle_id'=>$id,'charger_id'=>$charger_id])->get()->first();
                    $nozzil->price=$price;
                    $nozzil->save();
                   $this->logActivity(['module' => 'nozzil_price','unique_id'=>$nozzil->id,'activity' => 'type_updated']);
                    $response = ['message' => trans('Updated Successfully'), 'status' => 'success']; 
                    return response()->json($response, 200, array('Access-Controll-Allow-Origin' => '*'));
                
            }
            if($capacity){
                    $nozzil = \App\StationNozzle::where(['nozzle_id'=>$id,'charger_id'=>$charger_id])->get()->first();
                    $nozzil->capacity=$capacity;
                    $nozzil->save();
            $this->logActivity(['module' => 'nozzil_capacity','unique_id'=>$nozzil->id,'activity' => 'type_updated']);
                    $response = ['message' => trans('Updated Successfully'), 'status' => 'success']; 
                    return response()->json($response, 200, array('Access-Controll-Allow-Origin' => '*'));
            }

            $response = ['message' => trans('Failed'), 'status' => 'Error']; 
	        return response()->json($response, 200, array('Access-Controll-Allow-Origin' => '*'));


        }
		
		
		  public function qrCodeGenerate($id){

           $nozzil = \App\StationNozzle::where('nozzle_id',$id)->get()->first();

            $station=Station::where('station_id',$nozzil->station_id)->get()->first();
            $array=array(
                'ocpp_id'=>$station->station_id,
                'charging_station'=>$station->location_name,
                'charger_id'=> $nozzil->nozzle_id,

            );

            $code=json_encode( $array);



            $str='data:image/png;base64,'. base64_encode(QrCode::format('png')
            ->merge(config('constants.upload_path.logo').config('config.logo'), 0.2, true)
            ->size(350)
            ->errorCorrection('H')
            ->generate($code));

            return view('franchise.admin.stations.qr_code',compact('str','id'));

        }


        public function getChargersByStations($stations){
       
            return  $chargers = StationNozzle::where('station_id',$stations)->get();
       
    }
}
