<?php

namespace App\Http\Controllers\Franchises;
use DB;
use Illuminate\Http\Request;
use Validator;
use Auth;
use App\Classes\Helper;

class Transactions extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index(Request $request)
    {
        $packages           = Helper::translateList(config('lists.companys'));
        $stations           =\App\Station::where(['created_by'=>'franchise','created_by_id'=>Auth::user()->franchaise_id])->get()->pluck('station_name',"station_id")->all();
        $charging_points    =\App\StationNozzle::join('stations','stations.station_id','=','station_nozzles.station_id')->where(['stations.created_by'=>'franchise','stations.created_by_id'=>Auth::user()->franchaise_id])
        ->get()->pluck('nozzle_id','nozzle_id')->all();
        $todaydate         =    date('Y-m-d');
        $search='';
        $active='bydate';
        $transactions='';
        $message='';


        if($request->search){
            $transactions=\App\Transaction::
            select('transactions.station_id','transactions.trans_id','transactions.order_id','transaction_time','transaction_date',
            'stations.location_name','stations.station_name','amount','transactions.charger_id')
            ->join('stations','transactions.station_id','=','stations.station_id');
            
        // if($request->search=='today'){
        // $active='bydate';
        // $search=true;
        // $message="On ".date("d-m-Y") ;
        // $transactions->where('transactions.created_at', '>=', $todaydate.' 00:00:00');
        // }
      
        if($request->search=='bydate'){
        $validation = Validator::make($request->all(),[
                'startDate' => 'required','endDate'   => 'required']);
        if($validation->fails()){ 
            return redirect()->back()->withInput()->withErrors($validation->messages());
        }
        $application    =   $request->application;
        $station        =   $request->station;
        $cps            =   $request->cps;
        $startDate      =   $request->startDate;
        $endDate        =   $request->endDate;
        $search=true;

        view()->share(compact('application','station','cps'));
        $active='bydate';
        $message=$startDate .' To '. $endDate;


        if(!empty($cps)){
            $transactions->join('station_nozzles','station_nozzles.nozzle_id','=','transactions.ocpp_id');
            $transactions->where('transactions.ocpp_id',$cps);
            $message="Ocpp Id :".$cps." , ".$message;
        }
        
        if(!empty($station)){
            $transactions->where('stations.station_id',$station);
            $message=" Station : ".$station."  ".$message;
        }

            $message="Package :".ucfirst(Auth::user()->package)." , ".$message;

        
       

        $transactions->whereBetween('transactions.created_at', 
        array(date('Y-m-d 00:00:00',strtotime($startDate)),date('Y-m-d 23:59:59',strtotime($endDate))));
        }
        if($request->search=='bymonth'){
            
            
            $validation = Validator::make($request->all(),[
                'from_month' => 'required','to_month'   => 'required']);
        if($validation->fails()){ 
            return redirect()->back()->withInput()->withErrors($validation->messages());
        }
        
        $applications    =   $request->applications;
        $station        =   $request->stations;
        $cpss            =   $request->cpss;
        $startDate      =   $request->from_month;
        $endDate        =   $request->to_month;

        $from_month     =$startDate ;
        $to_month       =$endDate ;
        $search=true;

        view()->share(compact('applications','station','cpss','from_month' ,'to_month'));
        $active='bymonth';
        $message=" Date : ".$startDate .' To '. $endDate;


        if(!empty($cpss)){
             $transactions->join('station_nozzles','station_nozzles.nozzle_id','=','transactions.ocpp_id');
            $transactions->where('transactions.ocpp_id',$cpss);
             $message="Ocpp Id :".$cpss." , ".$message;
        }
        
        if(!empty($station)){
             $transactions->where('stations.station_id',$station);
             $message=" Station : ".$station."  ".$message;
        }
        if(!empty($applications)){
             $transactions->where('stations.application',$applications);
            $message="Package :".ucfirst($applications)." , ".$message;
        }

        // return  array(
        //     date('Y-m-d',strtotime('01-'.$startDate)),
        //     date('Y-m-d',strtotime('01-'.$endDate))
        // );
        $end    = date('Y-m-d',strtotime('01-'.$endDate));
        $strt   = date('Y-m-d',strtotime('01-'.$startDate));

        $transactions->raw("where `transactions`.`transaction_date` between '$strt' and '$end'");

       }
        
            $transactions=$transactions->get();
            $menu['menu']='reports';
            return view('franchise.admin.transactions.user_transactions',compact('charging_points','packages',"stations",'endDate','startDate','message','search','active','menu','transactions'));
        }

        $menu['menu']='reports';
        return view('franchise.admin.transactions.user_transactions',compact('charging_points','packages',"stations",'message','search','active','menu','transactions'));
   
    }






    public function chargingReport(Request $request)
    {
        
       $menu['menu']='reports';

       $fromdate       = '';
       $todate         =    date('D-m-Y');
       $startDate      =   '';
       $endDate        =   '';
       $searchdata     =   '';


       if($request->search){
        $validation = Validator::make($request->all(),[
            'startDate' => 'required',
            'endDate'   => 'required'
		]);
		

		// return $request;

        if($validation->fails()){
           
            return redirect()->back()->withInput()->withErrors($validation->messages());
        }

        $startDate      =   $request->startDate;
        $endDate        =   $request->endDate;
        $searchdata     =   $request->searchdata;

        $fromdate       =   $startDate;
        $todate         =   $endDate ;

         $users = \App\ChargingHistory::select('charging_histories.*','app_users.first_name','app_users.last_name')
        ->join('app_users','app_users.id','=','charging_histories.app_user_id')
        ->whereBetween('charging_histories.created_at', array(date('Y-m-d',strtotime($startDate)), date('Y-m-d 23:59:59',strtotime($endDate))))
        ->get();


        }else{
        $fromdate    = date('d-m-Y',strtotime(\Carbon\Carbon::today()->subDays(7)));
        $todate      = date('d-m-Y',strtotime(\Carbon\Carbon::today()));

        $date = \Carbon\Carbon::today()->subDays(7);
        $users = \App\ChargingHistory::select('charging_histories.*','app_users.first_name','app_users.last_name')
        ->join('app_users','app_users.id','=','charging_histories.app_user_id')
        ->where('charging_histories.created_at', '>=', $date)->get();
        //  return view('admin.transactions.charging_history',compact('menu','users','todate','fromdate'));

        }
        return view('franchise.admin.transactions.charging_history',compact('startDate','endDate','searchdata','menu','users','todate','fromdate'));
     
   
    }
    // $date = \Carbon\Carbon::today()->subDays(30);

    // $users = User::where('created_at', '>=', $date)->get();
    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
       // if($request->search=='bytime'){

        //     $active='bytime';
        //     $validation = Validator::make($request->all(),[
        //             'Date_time' => 'required','from_time'   => 'required','to_time'   => 'required']);
        //     if($validation->fails()){ 
        //         return redirect()->back()->withInput()->with( $active)->withErrors($validation->messages());
        //     }
        //     $startDate      =   $request->Date_time;
        //     $from_time      =   $request->from_time;
        //     $to_time        =   $request->to_time;

        //     if(strtotime($to_time)<strtotime($from_time)){
        //         return redirect()->back()->withInput()->withErrors("From to Should be more that from");
        //     }
        //     $search=true;
        //     view()->share(compact('from_time','to_time'));

        //     $message=$startDate .' and Time  '. $from_time. " To ".$to_time;
        //     $transactions->whereBetween('transactions.created_at', 
        //     array(
        //     date('Y-m-d '.$from_time.":00",strtotime($startDate)),
        //     date('Y-m-d '.$to_time.":00",strtotime($startDate))));
        //     }
    }
}
