<?php

namespace App\Http\Controllers\Franchises;

use Illuminate\Http\Request;

use Illuminate\Support\Facades\Storage;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Facades\Validator;
use Illuminate\Support\Facades\Auth;
use DB;
use Illuminate\Support\Facades\Input;
use Session;
use Redirect;
use View;
use App\User;
use App\Franchise;
use Entrust;
use App\Http\Requests\RegisterRequest;
use App\Http\Requests\UserRequest;
use App\Classes\Helper;
use Config;
use App\Profile;
use App\Countrys;
use App\States;
use App\Cities;

class UserController extends Controller
{

    protected $form = 'user-form';
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function __construct()
    {
        $this->middleware('auth:franchise');
    }
        
   
    public function index()
    {
        // $legonModel = new User;
        // $legonModel->setConnection('franchise');

        // $user = $legonModel->get();
          
           
       
       
        $roles = \App\Role::whereIsHidden(0)->get()->pluck('name','id')->all();

        $col_heads = array(
              
                trans('messages.first_name'),
                trans('messages.last_name'),
                trans('messages.username'),
                trans('messages.email'),
                trans('messages.role'),
                trans('messages.status'),
                trans('messages.option'));
        $table_info = array(
            'source' => 'users',
            'title' => 'Employee List',
            'id' => 'employee_table',
            'form' => 'employee_filter_form'
        );
        $menu = ['admin'];
        

        
        return view('franchise.admin.admin_list.index',compact('col_heads','table_info','roles','menu'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(RegisterRequest $request, User $user)
    {

        if(!Entrust::can('create-user')){
            return redirect('/dashboard')->withErrors(trans('messages.permission_denied'));
        }
    if(!preg_match('/^[a-zA-Z0-9_\.\-]*$/',$request->input('username'))){

            return redirect()->back()->withInput($request->input())
                    ->withErrors(trans('messages.username_allowed_characters'));
        }
              if($request->has('send_welcome_email')){
            $template = \App\Template::whereCategory('welcome_email')->first();
            if(!$template){
               
         return redirect()->back()->withInput($request->input())
                    ->withErrors(trans('messages.username_allowed_characters'));
            }
        }
        
        $user->fill($request->all());
        $user->password = bcrypt($request->input('password'));
        $user->status = 'active';
        $user->role=$request->input('role_id');
        $user->save();
        $user->attachRole($request->input('role_id'));
        if($request->has('send_welcome_email')){
            $template = \App\Template::whereCategory('welcome_email')->first();
            $body = $template->body;
            $body = str_replace('[NAME]',$user->full_name,$body);
            $body = str_replace('[PASSWORD]',$request->input('password'),$body);
            $body = str_replace('[USERNAME]',$user->username,$body);
            $body = str_replace('[EMAIL]',$user->email,$body);

            $mail['email'] = $user->email;
            $mail['subject'] = $template->subject;

            $blade="welcome_mail";
           
            $status =Helper::sendMails($request->email,$mail['subject'],$blade,$body);
        }
        return redirect()->back()->withSuccess(trans('messages.user').' '.trans('messages.added'));

    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit(User $user)
    {
        $user=Franchise::find(Auth::user()->id);


        $legonModel = new Profile;
        $legonModel->setConnection('franchise');
        $profile=$legonModel->where('user_id',Auth::user()->id)->get()->first();
		if(empty($profile)){

		$legonModel->user_id=Auth::user()->id;
		$legonModel->save();
		 $profile=$legonModel->where('user_id',Auth::user()->id)->get()->first();
		}
        $country=Countrys::get()->pluck('country_name','country_id')->all();
        $state=States::get()->pluck('state_name','state_id')->all();
        $city=Cities::get()->pluck('city_name','city_id')->all();

       $menu = ['admin'];

         $gender = Helper::translateList(config('lists.gender'));

        return view('franchise.admin.profile.edit',compact('user','gender','menu','profile','country','state','city'));
    }

    public function lists(Request $request){
        

        $legonModel = new User;
        $legonModel->setConnection('franchise');
        $user=$legonModel->get();

       
      foreach ($user as $users){
        foreach($users->roles as $role)
        $role_name = Helper::toWord($role->name);
           $rows[] = array(
           
            $users->first_name,
            $users->last_name,
            $users->username.' '.(($users->is_hidden) ? '<span class="label label-danger">'.trans('messages.default').'</span>' : ''),
            $users->email,
            $role_name,
            ($users->status == 'active' || $users->status == '') ? '<span class="label label-success">'.trans('messages.active').'</span>' : '<span class="label label-danger">'.Helper::toWord($users->status).'</span>'
             , '<div class="btn-group btn-group-xs">'.
             '<a href="/users/'.$users->id.'/edit" class="btn btn-xs btn-default" > <i class="fa fa-edit" data-toggle="tooltip" title="'.trans('messages.edit').'"></i></a> '.
             (($users->status != 'in-active') ? '<a href="#" data-href="/users/'.$users->id.'/change-status" class="btn btn-default btn-xs edit-form" data-toggle="modal" data-target="#mymodel"> <i class="fa fa-user" data-toggle="tooltip" title="'.trans('messages.change').' '.trans('messages.status').'"></i></a> ' : '').
             (Entrust::can('delete-user') ? delete_form(['users.destroy',$users->id],'users',1) : '').
             '</div>',);  
           }
        $list['aaData'] = $rows;
        return json_encode($list);
    }
    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, User $user,$id)
    {

        $validation = Validator::make($request->all(),[
            'first_name' => 'required',
            'last_name' => 'required',
        ]);

        if($validation->fails()){
           return redirect()->back()->withErrors($validation->messages()->first());
        }
        
        $user=Franchise::find($id);;

        
        if(!preg_match('/^[a-zA-Z0-9_\.\-]*$/',$request->input('username'))){
            
            return redirect('/dashboard')->withErrors(trans('messages.username_allowed_characters'));
        }

        $user->first_name = $request->input('first_name');
        $user->last_name = $request->input('last_name');
        $user->username = $request->input('username');
        $user->email = $request->input('email');
        $user->phone = $request->input('mobile');
        $user->save();


        $legonModel = new Profile;
        $legonModel->setConnection('franchise');
        $profile=$legonModel->where('user_id',Auth::user()->id)->get()->first();

        // $profile = $user->Profile ?: new Profile;
        $profile->gender        = $request->input('gender');
        $profile->address       = $request->input('address');
        $profile->city          = $request->input('city_id');
        $profile->state	        = $request->input('state_id');
        $profile->country	    = $request->input('country_id');
        $profile->save();

        return redirect('franchise/profile')->withSuccess(trans('messages.user').' '.trans('messages.updated'));

    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }

    public function changeStatus($id){

        $user = \App\User::find($id);

        if(!$user || Entrust::can('change-user-status') || $user->status == 'in-active')
            return view('common.error',['message' => trans('messages.permission_denied')]);

        return view('admin.admin_list.change_status',compact('user'));

    }
    public function postChangeStatus(Request $request, $id){

        $user = \App\User::find($id);

        $validation = Validator::make($request->all(),[
            'status' => 'required'
        ]);

        if($validation->fails()){
            if($request->has('ajax_submit')){
                $response = ['message' => $validation->messages()->first(), 'status' => 'error']; 
                return response()->json($response, 200, array('Access-Controll-Allow-Origin' => '*'));
            }
            return redirect()->back()->withErrors($validation->messages()->first());
        }

        $user->status = $request->input('status');
        $user->save();

        if($request->has('ajax_submit')){
            $response = ['message' => trans('messages.user').' '.trans('messages.status').' '.trans('messages.updated'), 'status' => 'success']; 
            return response()->json($response, 200, array('Access-Controll-Allow-Origin' => '*'));
        }
        return redirect('/users')->withSuccess(trans('messages.user').' '.trans('messages.status').' '.trans('messages.updated'));
    }

}
