<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Entrust;
use App\Franchise;
use Validator;
use Artisan;
use Illuminate\Support\Facades\Storage;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Facades\Auth;
use DB;
use Crypt;
use Illuminate\Support\Facades\Input;
use Session;
use Redirect;
use View;
use App\Http\Requests\FranchiseRequest;
use App\Classes\Helper;
use App\Countrys;
use App\States;
use App\Cities;

set_time_limit(0);

class FranchisesController extends Controller
{
    use BasicController;
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
  
        if(!Entrust::can('view_franchise'))
            return view('common.error',['message' => trans('messages.permission_denied')]);

        
        $col_heads = array(
            trans('messages.first_name'),
            trans('messages.last_name'),
            trans('messages.email'),
            // trans('messages.mobile'), 
            trans('Franchise Name'), 
            trans('Database Name'),
            trans('messages.status'),
           
            trans('messages.option'));
    $table_info = array(
        'source' => 'franchises',
        'title'  => 'Franchises List',
        'id'     => 'franchises',
        'form'   => 'franchises_form'
    );
    $menu = ['franchise'];

    return view('admin.franchises.index',compact('menu','col_heads','table_info'));
    
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {

        if(!Entrust::can('create_franchise'))
            return view('common.error',['message' => trans('messages.permission_denied')]);


        $menu = ['franchise'];
       // $packages=DB::table('pakages')->get()->pluck('name','short_name')->all();
       // $country=Countrys::get()->pluck('country_name','country_id')->all();
       // $state=States::get()->pluck('state_name','state_id')->all();
       // $city=Cities::get()->pluck('city_name','city_id')->all();
       return view('admin/franchises.create',compact('country','state','city','menu','packages'));
    }

   

    public function store(FranchiseRequest $request, Franchise $franchise){


    
        // return $request;
        if(!Entrust::can('create_franchise'))
        return view('common.error',['message' => trans('messages.permission_denied')]);
        $databases=$request->username;

try {
      
       DB::beginTransaction();
       $database=DB::connection('mysql')->statement("CREATE DATABASE IF NOT EXISTS $databases DEFAULT CHARACTER SET utf8;");
       if(!$database){
             return redirect()->back()->withError('username Already Exist.');
       }
       $hostname = 'localhost';
       $user_name =config('database.connections.mysql.username');
       $password = config('database.connections.mysql.password');

       $con=mysqli_connect($hostname,$user_name,$password,$databases); 
 
           
			if (!$con)
                     return redirect()->back()->withError('Connection could not be established.');
			else{
					
					$count_table_query = mysqli_query($con,"show tables");
					$count_table = mysqli_num_rows($count_table_query);

					if (!is_file('../database/db_ocpp.sql'))
						return redirect()->back()->withError('Database file not found.');
					elseif($count_table)
						return redirect()->back()->withError('Table already exists. Installation needs empty database.');
					else{
							$templine = '';
							$lines = file('../database/db_ocpp.sql');
							foreach ($lines as $line)
							{
								if (substr($line, 0, 2) == '--' || $line == '')
									continue;
								$templine .= $line;
								if (substr(trim($line), -1, 1) == ';')
								{
									mysqli_query($con,$templine) or print('Error performing query \'<strong>' . $templine . '\': ' . mysql_error() . '<br /><br />');
									$templine = '';
								}	
							}
							
                            $franchise->fill($request->all());
                            $franchise->password        = bcrypt($request->input('password'));
                            $franchise->status          = 'active';
                            $franchise->database_name   = $databases;
                            $franchise->franchaise_id   = "FRA_".randomstring(8);
                            $franchise->city            = $request->input('city_id');
                            $franchise->state	        = $request->input('state_id');
                            $franchise->country	        = $request->input('country_id');
                            $franchise->organization	= $request->input('organization');

                            

                            mysqli_query($con,"INSERT INTO profiles('user_id') VALUES ($franchise->id)");
                            
                            if($franchise->save()){
                                if($request->has('send_welcome_email')){
                                        $template = \App\Template::whereCategory('welcome_email')->first();
                                        $body = $template->body;
                                        $body = str_replace('[NAME]',$franchise->full_name,$body);
                                        $body = str_replace('[PASSWORD]',$request->input('password'),$body);
                                        $body = str_replace('[USERNAME]',$franchise->username,$body);
                                        $body = str_replace('[EMAIL]',$franchise->email,$body);
                            
                                        $mail['email'] = $franchise->email;
                                        $mail['subject'] = $template->subject;
                            
                                        $blade="welcome_mail";
                                       
                                        $status =Helper::sendMails($template->name,$request->email,$mail['subject'],$blade,$body);
                                    }
                                    DB::commit();
                                $this->logActivity(['module' => 'franchises','activity' => 'activity_added']);
                                return redirect('franchises')->withSuccess('Created successfully.');
                                
                            }else{
                                 DB::rollback();
                                 DB::connection('mysql')->statement("DROP DATABASE $database;");
                                 $franchise->delete();
                                return redirect()->back()->withError('Something Went Wrong Please Try Again Later.');
                            }
                            
							DB::rollback();
                            DB::connection('mysql')->statement("DROP DATABASE $database;");
                            $franchise->delete();
                           return redirect()->back()->withError('Something Went Wrong Please Try Again Later.');
				           
						
                    }

                }

   } catch (\Exception $th) {

        DB::rollback();
        DB::connection('mysql')->statement("DROP DATABASE $database;");
       return redirect()->back()->withError('Something Went Wrong Please Try Again Later.');
  }
                        
                    
                
            
        }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
       $menu = ['franchise'];
       $id=Crypt::decrypt($id);
       $franchise=Franchise::find($id);
       //$packages=DB::table('pakages')->get()->pluck('name','short_name')->all();
       //$country=Countrys::get()->pluck('country_name','country_id')->all();
       //$state=States::get()->pluck('state_name','state_id')->all();
      // $city=Cities::get()->pluck('city_name','city_id')->all();
       $connector_types=\App\ChargePointTypes::get()->pluck('name','id')->all();
       $charger_types=DB::table('charger_types')->get()->pluck('charger_code','id')->all();
       $title='Stations';

       $col_heads = array(
        		
        'station '.trans('messages.name'),
        trans('Station Id'),
        trans('location'),
        trans('latitude'),
        trans('longitude'),
        trans('pkg'),
        trans('messages.status'),
        // trans('messages.option'),
        trans('Charger'),

        );
        $table_info = array(
			// 'source' => 'stations',
			// 'title' => 'stations  List',
			// 'id' => 'stations_table'
        );
        return view('admin/franchises.view',compact('charger_types','connector_types','charger_types','title','col_heads','table_info','franchise','country','state','city','menu','packages'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
       $menu = ['franchise'];
       $id=Crypt::decrypt($id);
       $franchise=Franchise::find($id);

       //$packages=DB::table('pakages')->get()->pluck('name','short_name')->all();
       //$country=Countrys::get()->pluck('country_name','country_id')->all();
       //$state=States::get()->pluck('state_name','state_id')->all();
       $city=Cities::get()->pluck('city_name','city_id')->all();
      return view('admin/franchises.edit',compact('franchise','country','state','city','menu','packages'));
      
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        if(!preg_match('/^[a-zA-Z0-9_\.\-]*$/',$request->input('username'))){
          
            return redirect('/dashboard')->withErrors(trans('messages.username_allowed_characters'));
        }
       
         Franchise::where('id', $id)->update($request->except(['_method', '_token']));
        $this->logActivity(['module' => 'franchises','unique_id'=>$id,'activity' => 'franchises_updated']);
    
        return redirect('/franchises')->withSuccess(trans('Franchise').'  '.trans('messages.updated'));
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }

    
   public function franchisesLists(Request $request,$fr){


  

    $columns = array( 

        0 =>'station_name',
        1=> 'station_id',
        2=> 'location_name',
        3=> 'application',
        4=> 'status',
        5=> 'latitude',
        6=> 'longitude',
        7=> 'status',
        8=> 'status',

    );



$city=$request->input('city');
$franchise=$request->input('franchise');
$status=$request->input('status');
$application=$request->input('application');
$connectortypes=$request->input('connectortypes');
$chargertypes=$request->input('chargertypes');
$search=array();

if($city){

$search['city_id']=$city;

}
if($chargertypes){

$search['charger_code']=$chargertypes;

}
if($connectortypes){

$search['type']=$connectortypes;

}

if($status){
$search['stations.status']=$status;

}
if($application){
$search['application']=$application;

}



$totalData = \App\Station::where(['created_by_id'=>$fr,'created_by'=>'franchise'])->
// join('station_nozzles','station_nozzles.station_id','=','stations.station_id')
        get()->count();

$totalFiltered = $totalData; 

$limit = $request->input('length');
$start = $request->input('start');
$order = $columns[$request->input('order.0.column')];
$dir = $request->input('order.0.dir');



if($search){

   
    $template =  \App\Station::where(['created_by_id'=>$fr,'created_by'=>'franchise'])
    ->join('station_nozzles','station_nozzles.station_id','=','stations.station_id')
    ->where($search)
     ->offset($start)
    ->limit($limit)
    ->orderBy($order,$dir)
    ->get();

     $totalFiltered = \App\Station::where(['created_by_id'=>$fr,'created_by'=>'franchise'])
     ->join('station_nozzles','station_nozzles.station_id','=','stations.station_id')
     ->where($search)
    ->count();

}

if(empty($request->input('search.value')))
{            
$template = \App\Station::where(['created_by_id'=>$fr,'created_by'=>'franchise'])
->offset($start)
->limit($limit)
->orderBy($order,$dir)
->get();
}else {

   
$search = $request->input('search.value'); 
if($search){

$template =  \App\Station::where('station_name','LIKE',"%{$search}%")
        // ->orWhere('stations.station_id', 'LIKE',"%{$search}%")
        // ->orWhere('location_name', 'LIKE',"%{$search}%")
        // ->orWhere('application', 'LIKE',"%{$search}%")
        ->where('created_by_id',$fr)
        ->offset($start)
        ->limit($limit)
        ->orderBy($order,$dir)
        ->get();

$totalFiltered = \App\Station::where('station_name','LIKE',"%{$search}%")
        // ->orWhere('stations.station_id', 'LIKE',"%{$search}%")
        // ->orWhere('location_name', 'LIKE',"%{$search}%")
        // ->orWhere('application', 'LIKE',"%{$search}%")
        ->where('created_by_id',$fr)
        ->count();
}
}
$rows=[];
$data = array();
$i=1;
if(!empty($template))
{
    $i=1;
foreach ($template as $template){

    $rows[] = array(
        $template->station_name,
        Helper::toWord($template->station_id),
        Helper::toWord($template->location_name),
        $template->latitude,
        $template->longitude,
        trans('messages.'.$template->application),
        '<span class="label label-'.$template->status.'">'.Helper::toWord($template->status).'</span>',
        // '<div class="btn-group btn-group-xs">'.
        // (($template->created_by!='franchise') ? '<a href="#" data-href="/stations/'.Crypt::encrypt($template->id).'/change-status" class="btn btn-default btn-xs edit-form" data-toggle="modal" data-target="#mymodel"> <i class="fa fa-user" data-toggle="tooltip" title="'.trans('messages.change').' '.trans('messages.status').'"></i></a> ' : '').
        // (($template->created_by!='franchise') ? '<a href="/stations/'.Crypt::encrypt($template->id).'/edit" class="btn btn-xs btn-default" > <i class="fa fa-edit" data-toggle="tooltip" title="'.trans('messages.edit').'"></i></a> ' : '').
        // // (!$template->is_default ? delete_form(['vehiclemanufacturer.destroy',$template->id],'template',1) : '').
        // '</div>',
        (($template->status != 'in-active') ? '<a href="/stations/'.Crypt::encrypt($template->id).'" class="btn btn-default btn-xs edit-form" ><i class="fa fa-plug" data-toggle="tooltip" title="'.trans('View Chargers').'"></i></a> ' : '')
        ,

        );  
                     $i++;
    }
    }
    $json_data = array(
    "draw"            => intval($request->input('draw')),  
    "recordsTotal"    => intval($totalData),  
    "recordsFiltered" => intval($totalFiltered), 
    "aaData"            => $rows   
    );
    echo json_encode($json_data); 

}






    public function lists(Request $request){


        if(!Entrust::can('create_franchise')){
        $response = ['message' => trans('messages.permission_denied'), 'status' => 'error']; 
	    return response()->json($response, 200, array('Access-Controll-Allow-Origin' => '*'));
        }

   
        if(defaultRole())
         $query = \App\Franchise::whereNotNull('id');
        
        else if(Entrust::hasRole('organisation'))
        $query = \App\Franchise::where('organization',Auth::user()->package);

        else
        $query = Franchise::whereNull('id');

        
      if($request->has('role_id'))
          $query->whereHas('roles',function($q) use ($request){
              $q->where('role_id','=',$request->input('role_id'));
          });

   $totalDatass = $query->get();


        $columns = array( 
            0 =>'first_name',
            1=> 'last_name',
            2=> 'email',
            3=> 'phone',
            4=> 'franchise_name',
            5=> 'database_name',
            6=> 'status',
            // 7=> 'status',
        );
        if(Entrust::hasRole('organisation'))
        $totalData = \App\Franchise::where('organization',Auth::user()->package)->count();
        else
        $totalData = \App\Franchise::count();


    $totalFiltered = $totalData; 

    $limit = $request->input('length');
    $start = $request->input('start');
    $order = $columns[$request->input('order.0.column')];
    $dir = $request->input('order.0.dir');

    if(empty($request->input('search.value')))
    {            
    $post = \App\Franchise::offset($start);
    $post->limit($limit);

    if(Entrust::hasRole('organisation'))
    $post->where('organization',Auth::user()->package);
   
    $post->orderBy($order,$dir);
    $posts=$post->get();


    }else {
    $search = $request->input('search.value'); 

    $post =  \App\Franchise:: Where('franchise_name', 'LIKE',"%{$search}%")
             //where('phone','LIKE',"%{$search}%")
            //->orWhere('first_name', 'LIKE',"%{$search}%")
            //->orWhere('last_name', 'LIKE',"%{$search}%")
           
            ->orWhere('email', 'LIKE',"%{$search}%");
           
           // ->orWhere('database_name', 'LIKE',"%{$search}%")
            //->orWhere('status', 'LIKE',"%{$search}%")
            

    if(Entrust::hasRole('organisation'))
            $post->where('organization',Auth::user()->package);

    $posts=$post->offset($start)->limit($limit)->orderBy($order,$dir)->get();

$totalFiltered = \App\Franchise::where('phone','LIKE',"%{$search}%")
             ->orWhere('first_name', 'LIKE',"%{$search}%")
             ->orWhere('last_name', 'LIKE',"%{$search}%")
             ->orWhere('email', 'LIKE',"%{$search}%")
             ->orWhere('status', 'LIKE',"%{$search}%")
             ->orWhere('franchise_name', 'LIKE',"%{$search}%")
             ->orWhere('database_name', 'LIKE',"%{$search}%")
             ->count();
}
$rows=[];
    $data = array();
    $i=1;
    if(!empty($posts))
    {
        $i=1;
    foreach ($posts as $users){
        
        $rows[] = array(
         $users->first_name,
         $users->last_name,
         $users->email,
        //  $users->phone,
         $users->franchise_name,
         $users->database_name,
         ($users->status == 'active' || $users->status == '') ? '<span class="label label-success">'.trans('messages.active').'</span>' : '<span class="label label-danger">'.Helper::toWord($users->status).'</span>'
         , '<div class="btn-group btn-group-xs">'.
         '<a href="/franchises/'.Crypt::encrypt($users->id).'" class="btn btn-xs btn-default" > <i class="fa fa-eye" data-toggle="tooltip" title="'.trans('messages.view').'"></i></a> '.
         '<a href="/franchises/'.Crypt::encrypt($users->id).'/edit" class="btn btn-xs btn-default" > <i class="fa fa-edit" data-toggle="tooltip" title="'.trans('Edit franchises').'"></i></a> '.
          ((!Entrust::can('change-franchise-status')) ? '<a href="#" data-href="/franchises/'.$users->id.'/change-status" class="btn btn-default btn-xs edit-form" data-toggle="modal" data-target="#mymodel"> <i class="fa fa-user" data-toggle="tooltip" title="'.trans('messages.change').' '.trans('messages.status').'"></i></a> ' : '').
          '</div>',);  
          $i++;
        }
}
$json_data = array(
    "draw"            => intval($request->input('draw')),  
    "recordsTotal"    => intval($totalData),  
    "recordsFiltered" => intval($totalFiltered), 
    "aaData"            => $rows   
    );
echo json_encode($json_data); 
        
    }

    
    public function changeStatus($id){

        $franchise = \App\Franchise::find($id);

        if(!$franchise || Entrust::can('change-franchise-status'))
            return view('common.error',['message' => trans('messages.permission_denied')]);

        return view('admin.franchises.change_status',compact('franchise'));

    }
    public function postChangeStatus(Request $request, $id){

        $franchise = \App\Franchise::find($id);
        $validation = Validator::make($request->all(),[
            'status' => 'required'
        ]);
        if($validation->fails()){
           return redirect()->back()->withErrors($validation->messages()->first());
        }
        $franchise->status = $request->input('status');
        $franchise->save();

        $this->logActivity(['module' => 'franchises','unique_id'=>$id,'activity' => 'settings_updated']);
    
        return redirect('/franchises')->withSuccess(trans('Franchise').' '.trans('messages.status').' '.trans('messages.updated'));
    }



    public function locations()
    {
        $locations=Franchise::get();
        $menu = ['franchise_locations'];
       return view('admin.franchises.locations',compact('locations','menu'));
    }


}
