<?php
namespace App\Http\Controllers;
use DB;
use App\Classes\Helper;
use Auth;
use App\Message;
use Entrust;
use File;
use Illuminate\Http\Request;
use App\Http\Requests\MessageRequest;

Class MessageController extends Controller{
    use BasicController;

	
	public function view($id,$token){

	    if(!Helper::verifyCsrf($token))
	      return redirect()->back()->withErrors(trans('messages.invalid_token'));

		$message = Message::whereId($id)->where(function($query){
			$query->where('from_user_id','=',\Auth::user()->id)
				->orWhere('to_user_id','=',\Auth::user()->id);
		})->first();

		if(!$message)
			return redirect()->back()->withErrors(trans('messages.invalid_link'));

		$query = \App\AppUser::whereNotNull('id');
		if($message->from_user_id == Auth::user()->id){
			$message_type = 'sent';
			$query->where('id','=',$message->to_user_id);
		}
		elseif($message->to_user_id == Auth::user()->id){
			$message_type = 'inbox';
			$message->is_read = 1;
			$query->where('id','=',$message->from_user_id);
		}
		else
			return redirect('/message')->withErrors(trans('messages.invalid_link'));


    	$user = $query->first();

        $count_inbox = Message::whereToUserId(Auth::user()->id)
			->whereDeleteReceiver('0')
        	->count();
        $count_sent = Message::whereFromUserId(Auth::user()->id)
			->whereDeleteSender('0')
        	->count();

		$message->save();
		$menu = ['message'];
		

		return $message;

		//return view('message.view',compact('message','user','count_inbox','count_sent','menu'));
	}

}
?>