<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Illuminate\Support\Facades\Input;
use Session;
use Redirect;
use View;

use App\Permission;
use App\Role;
use App\PermissionRole;
use DB;

class PermissionsController extends Controller
{
    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct()
    {
        $this->middleware('auth');
    }

    protected function validator(array $data)
    {
        return Validator::make($data, [
            'name' => ['required', 'string', 'max:255']
          ]);
    }
    /**
     * Show the application dashboard.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
         $permissions = Permission::orderBy('category')->get();

         $permission_role = DB::table('permission_role')
         ->select(DB::raw('CONCAT(role_id,"-",permission_id) AS detail,id'))
         ->pluck('detail','id')
         ->toArray();
	 

         $roles = Role::all();
          $category = null;

    
         return View::make('admin/permissions.list')->with(['roles'=>$roles,'permissions'=> $permissions,'category'=>$category,'permission_role'=>$permission_role]);
    }
	public function show($id)
    {
		$selectedroleId = $id;
        $permissions = Permission::orderBy('category')->get();

    $permission_role = DB::table('permission_role')->select(DB::raw('CONCAT(role_id,"-",permission_id) AS detail,id'))
        ->pluck('detail','id')->toArray();
	 

         $roles = Role::all();
          $category = null;

    
         return View::make('admin/permissions.list')->with(['roles'=>$roles,'permissions'=> $permissions,'category'=>$category,'permission_role'=>$permission_role,'selectedroleId'=>$selectedroleId]);
    }
     public function store(Request $request)
    {
        
        $input = $request->all();
        $permissions = ($request->input('permission')) ? : [];

        foreach($permissions as $key => $permission)
        if($key!=1){
            foreach($permission as $k => $perm)
                $insert[] = array('permission_id' => $k,'role_id' => $key);
        }

        $permissions = DB::table('permissions')->get();
        DB::table('permission_role')->truncate();
        foreach($permissions as $permission)
            $insert[] = array('permission_id' => $permission->id,'role_id' => 1);
        DB::table('permission_role')->insert($insert);

        $this->logActivity(['module' => 'permissions','activity' => 'activity_updated']);
        Session::flash('success', 'Successfully updated!');

        return redirect('/permissions')->withSuccess('permissions updated');
       
    }
   
 
}
