<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Classes\Helper;
use DB;
use Entrust;
use Validator;
use App\AppUser;
use Auth;
class ReportsController extends Controller
{
    


    public function userReports(Request $request){

        if(!Entrust::can('view_users_report'))
        return view('common.error',['message' => trans('messages.permission_denied')]);



      
        $todaydate         =    date('Y-m-d');
        
        $message='All Users';
        $search=true;
        $menu['menu']='reports';
        
        if(Entrust::hasRole('organisation'))
        $user = \App\AppUser::select('app_users.*')->where('package_name',Auth::user()->package);
        else
        $user = \App\AppUser::select('app_users.*');

        if($request->search){
            if(Entrust::hasRole('organisation'))
            $message='Organisation   : '.Auth::user()->package;
            else
            $message='User lists';
            $application=$request->application;

            if(!empty($application)){
                $message=$message." Application : ".$application;
                $user->where('package_name',$application);
                view()->share(compact('application'));
            }
            if(!empty($request->startDate) || !empty($request->endDate)){
            $validation = Validator::make(
                $request->all(),
                ['startDate' => 'required','endDate'   => 'required']);
            if($validation->fails()){
                return redirect()->back()->withInput()->withErrors($validation->messages());
            }

            $from_time=$request->startDate;
            $to_time=$request->endDate;
            if(strtotime($to_time)<strtotime($from_time)){
                        return redirect()->back()->withInput()->withErrors("From Date  Should be more that todate");
             }
             $message=$message." From : ".$from_time. " To " .$to_time;

             $user->whereBetween('app_users.created_at', 
             array(date('Y-m-d 00:00:00',strtotime($from_time)),
             date('Y-m-d 23:59:59',strtotime($to_time))));
             $user->orderBy('created_at',"ASC");
             view()->share(compact('application','from_time','to_time'));
             }
             if(!empty($request->status)){
                $status=$request->status;
                $message=$message." Status Mode : ".$status;
                $user->where('status',$status);
                view()->share(compact('status'));
             }
            
        }
        $users=$user->get();


        return view('reports.user_reports',compact('menu','users','message','search','packages','stations','charging_points','todaydate'));
    }


    ///chargePointsReports
    public function chargeStationsReports(Request $request)
    {
        if(!Entrust::can('view_station_report'))
        return view('common.error',['message' => trans('messages.permission_denied')]);


        $stations           =\App\Station::get()->pluck('station_name',"station_id")->all();
        
        $charging_points    =\App\StationNozzle::get()->pluck('nozzle_id','nozzle_id')->all();
        $todaydate         =    date('Y-m-d');
        $message='Stations ';
        $search=false;
        $menu['menu']='reports';
        if($request->search=='filter'){

            $application    =   $request->application;
            $startDate      =   $request->startDate;
            $endDate        =   $request->endDate;
            $status         =   $request->status;
            $search=true;

            $report=\App\Station::select('stations.*'); 
            $report->where('application',$application);
            $report->whereBetween('stations.created_at', 
            array(date('Y-m-d 00:00:00',strtotime($startDate)),
            date('Y-m-d 23:59:59',strtotime($endDate))));
            $report->orderBy('created_at',"ASC");
            $message=$message."Package :  ". $application." From : ".$startDate. " To " .$endDate;

            if($status){
                $report->where('status',$status);
                $message=$message."   Status  : ". $status;

            }
           
          
           $reports= $report->get();


            view()->share(compact('reports','application','startDate','endDate','status'));

        }
        return view('reports.charge_point_reports',compact('menu','report','message','search','packages','stations','charging_points','todaydate'));

    }


    public function organizationsWiseStationsReports(Request $request){
        if(!Entrust::can('view_organization_reports'))
        return view('common.error',['message' => trans('messages.permission_denied')]);



        if(Entrust::hasRole('organisation')){
        $stations = \App\Station::where('application',Auth::user()->package)->get()->pluck('station_name',"station_id")->all();
        $cities   = \App\Station::where('application',Auth::user()->package)->join('cities','stations.city_id','=','cities.city_id')->get()->pluck('city_name','city_id')->all();
        
    } else{
        $stations =\App\Station::get()->pluck('station_name',"station_id")->all();
        $cities=\App\Station::join('cities','stations.city_id','=','cities.city_id')->get()->pluck('city_name','city_id')->all();
        }

        $charging_points    =\App\StationNozzle::get()->pluck('nozzle_id','nozzle_id')->all();

       


        $connector_types=\App\ChargePointTypes::get()->pluck('name','id')->all();
        $charger_types=DB::table('charger_types')->get()->pluck('charger_code','id')->all();


        $todaydate         =    date('Y-m-d');
        $message='Station reports ';
        $search=false;
        $menu['menu']='reports';
        if($request->search=='filter'){
            $search=true;
            $report=\App\Station::select('stations.*'); 
            $application    =   $request->application;
            $station        =   $request->station;
            $city           =   $request->city_id;
            $franchise_id   =   $request->franchise_id;
            $connectortypes =   $request->connector_type;
            $chargertypes   =   $request->charger_code;
            $status         =   $request->status;
    

            if($city){
                 $report->where('stations.city_id',$city);
                 $citys=DB::table('cities')->where('city_id',$city)->get()->first();
                $message=$message."City  Name  : ". $citys->city_name.'  ';
            }


            if($chargertypes || $connectortypes){
                $report->join('station_nozzles','station_nozzles.station_id','=','stations.station_id');
            }
          
            if($chargertypes){
               
                $report->where(['charger_code'=>$chargertypes]);
            }
            if($connectortypes){
                
                $report->where(['type'=>$connectortypes]);
            }
            if($franchise_id){
                $report->where(['created_by_id'=>$franchise_id,'created_by'=>'franchise']);
            }
            if($status){
                $report->where('stations.status',$status);
                $message=$message."& Active  Status  : ". $status .'  ';

            }

            if(Entrust::hasRole('organisation')){
                $message=$message." & Organization Name :  ". Auth::user()->package.'  ';
                $report->where('stations.application',Auth::user()->package);

            }else{
            if($application){
                    $message=$message." & Organization Name :  ". $application.'  ';
                    $report->where('application',$application);
            }
            }




            if($station){
                $report->where('stations.station_id',$station);
            }

            $report->orderBy('created_at',"ASC");
            $reports= $report->get();


            view()->share(compact('reports','chargertypes','connectortypes','franchise_id','city','station','application','startDate','endDate','status'));

        }
        return view('reports.organaization_wise_stations_reports',compact('charger_types','connector_types','franchise','cities','charger_types','connector_types','charger_types','menu','report','message','search','packages','stations','charging_points','todaydate'));


    }

    public function getChargersByStationReport($station_id)
    {
        $message='Chargers Under Station '.$station_id;
        $search=true;
        $reports=  $charging_points    =\App\StationNozzle::select('charge_point_types.name as type_name','station_nozzles.status','station_nozzles.price','station_nozzles.power_rating','station_nozzles.created_at','nozzle_id','station_nozzles.charger_id','charger_types.charger_code')->where('station_id',$station_id)
        ->join('charger_types','station_nozzles.charger_code','=','charger_types.id')
        ->join('charge_point_types','station_nozzles.type','=','charge_point_types.id')
        ->get();
        return view('reports.chargers_by_stations',compact('reports','search','message'));
    }
}
