<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Station;
use App\Classes\Helper;
use Entrust;
use Validator;
use Auth;
use App\States;
use App\Cities;
use DB;
use QrCode;
use Crypt;
use App\User;
use App\Franchise;
use App\StationNozzle;
use App\ChargePointTypes;
class StationsController extends Controller
{
    use BasicController;
   public function index(){

    $cities=Station::join('cities','stations.city_id','=','cities.city_id')->get()->pluck('city_name','city_id')->all();

   $connector_types=ChargePointTypes::get()->pluck('name','id')->all();
   $charger_types=DB::table('charger_types')->get()->pluck('charger_code','id')->all();
       $title='Stations';
       $menu['menu']="stations";

       $col_heads = array(
        		
        'station '.trans('messages.name'),
        trans('Station Id'),
        trans('location'),
        // trans('latitude'),
        // trans('longitude'),
        trans('pkg'),
        trans('messages.status'),
        trans('messages.option'),
        trans('Charger'),

        );
        $table_info = array(
			// 'source' => 'stations',
			// 'title' => 'stations  List',
			// 'id' => 'stations_table'
        );
        
       return view('admin.stations.index',compact(['charger_types','connector_types','charger_types','cities','title','col_heads','table_info','menu']));
   }

   public function create(){
    $title='Add Stations';
    $menu['menu']="stations";
	
	$servicetax=DB::table('service_taxs')->get();
    
    return view('admin.stations.add',compact(['title','menu','state','servicetax']));
   }



   public function lists(Request $request){


  

                    $columns = array( 

                        0 =>'station_name',
                        1=> 'station_id',
                        2=> 'location_name',
                        3=> 'application',
                        4=> 'status',
                        // 5=> 'latitude',
                        // 6=> 'longitude',
                        5=> 'status',
                        6=> 'status',

                    );



               $city=$request->input('city');
               $franchise=$request->input('franchise');
               $status=$request->input('status');
               $application=$request->input('application');
               $connectortypes=$request->input('connectortypes');
               $chargertypes=$request->input('chargertypes');
               $search=array();

               if($city){

                $search['city_id']=$city;

               }
               if($chargertypes){

                $search['charger_code']=$chargertypes;

               }
               if($connectortypes){

                $search['type']=$connectortypes;

               }
               if($franchise){
                $search['created_by_id']=$franchise;
                $search['created_by']='franchise';
               

               }
               if($status){
                $search['stations.status']=$status;

               }
               if($application){
                $search['application']=$application;

               }

              
               if(Entrust::hasRole('organisation'))
               $totalData = \App\Station::where('application',Auth::user()->package)->get()->count();
               else
               $totalData = \App\Station::
                // join('station_nozzles','station_nozzles.station_id','=','stations.station_id')
                get()->count();

                $totalFiltered = $totalData; 

                $limit = $request->input('length');
                $start = $request->input('start');
                $order = $columns[$request->input('order.0.column')];
                $dir = $request->input('order.0.dir');


              
                if($search){

                   
                    $templa =  \App\Station::select('stations.id','station_name','location_name',
                    'stations.station_id','application','latitude','longitude','stations.status','created_by');

                    if(Entrust::hasRole('organisation'))
                    $templa->where('application',Auth::user()->package);
                    
                    $template =$templa->join('station_nozzles','station_nozzles.station_id','=','stations.station_id')
                    ->where($search)
                     ->offset($start)
                    ->limit($limit)
                    ->orderBy($order,$dir)
                    ->get();

                     $totalFiltered = count($template);

                }

                elseif(empty($request->input('search.value')))
                {            
                $templa = \App\Station::offset($start);
                        
                if(Entrust::hasRole('organisation'))
                    $templa->where('application',Auth::user()->package);

                $template=$templa->limit($limit)->orderBy($order,$dir)->get();
                }else {

                   
                $search = $request->input('search.value'); 

               $template =  \App\Station::where('station_name','LIKE',"%{$search}%")
                    ->where('application',Auth::user()->package)
                       // ->orWhere('stations.station_id', 'LIKE',"%{$search}%")
                        // ->orWhere('location_name', 'LIKE',"%{$search}%")
                        //->orWhere('application', 'LIKE',"%{$search}%")
                        ->offset($start)
                        ->limit($limit)
                        ->orderBy($order,$dir)
                        ->get();

                $totalFiltered = \App\Station::where('station_name','LIKE',"%{$search}%")
                        ->where('application',Auth::user()->package)
                       // ->orWhere('stations.station_id', 'LIKE',"%{$search}%")
                    //    ->orWhere('location_name', 'LIKE',"%{$search}%")
                       // ->orWhere('application', 'LIKE',"%{$search}%")
                        ->count();
                }
                $rows=[];
                $data = array();
                $i=1;
                if(!empty($template))
                {
                    $i=1;
                foreach ($template as $template){

                    $rows[] = array(
                        $template->station_name,
                        Helper::toWord($template->station_id),
                        Helper::toWord($template->location_name),
                        // $template->latitude,
                        // $template->longitude,
                        trans('messages.'.$template->application),
                        '<span class="label label-'.$template->status.'">'.Helper::toWord($template->status).'</span>',
                        '<div class="btn-group btn-group-xs">'.
                        ((1==1) ? '<a href="#" data-href="/stations/'.Crypt::encrypt($template->id).'/change-status" class="btn btn-default btn-xs edit-form" data-toggle="modal" data-target="#mymodel"> <i class="fa fa-user" data-toggle="tooltip" title="'.trans('messages.change').' '.trans('messages.status').'"></i></a> ' : '').
                        ((1==1) ? '<a href="/stations/'.Crypt::encrypt($template->id).'/edit" class="btn btn-xs btn-default" > <i class="fa fa-edit" data-toggle="tooltip" title="'.trans('messages.edit').'"></i></a> ' : '').
                        // (!$template->is_default ? delete_form(['vehiclemanufacturer.destroy',$template->id],'template',1) : '').
                        '</div>',
                        (($template->status = 'in-active') ? '<a href="/stations/'.Crypt::encrypt($template->id).'" class="btn btn-default btn-xs edit-form" ><i class="fa fa-plug" data-toggle="tooltip" title="'.trans('View Chargers').'"></i></a> ' : '')
                        ,

                        );  
                                     $i++;
                    }
                    }
                    $json_data = array(
                    "draw"            => intval($request->input('draw')),  
                    "recordsTotal"    => intval($totalData),  
                    "recordsFiltered" => intval($totalFiltered), 
                    "aaData"            => $rows   
                    );
                    echo json_encode($json_data); 
        
        }

        public function edit(Station $stations,$id){

            $menu['menu']="stations";
            $id=Crypt::decrypt($id);
            $servicetax=DB::table('service_taxs')->get();
           
                    if(!Entrust::can('edit-stations'))
                        return redirect('/stations')->withErrors(trans('messages.permission_denied'));

                        $station=Station::find($id);
                        $mapicon='';
                        $status='';
                        if($station->status=='active'){
                            $mapicon=url('assets/img/map/active.png');
                            $status='success';
                        }else{
                            $mapicon=url('assets/img/map/banned.png');
                            $status='danger';
                        }

            return view('admin.stations.edit',compact('menu','servicetax','station','mapicon','status'));
        }

        public function store(Station $stations,Request $request){
			
			try{
		
                $validation = Validator::make($request->all(),[
                    'latitude' => 'required',
                    'longitude' => 'required',
                    'station_name' => 'required|unique:stations,station_name',
                    'location_name' => 'required',
                    'city_id'   =>'required',
                    'state_id' => 'required',
                    'address'   =>'required',
                    'application'   => 'required',
					'opening_time'  => 'required',
					'closing_time'  => 'required',
                ]);
				

                if($validation->fails()){
                        return redirect()->back()->withInput()->withErrors($validation->messages());
                }
                $station_code = strtoupper(substr($request->location_name, 0, 4));

                $taxes=array();
                DB::beginTransaction();


                foreach ($request->tax as $key => $value) {
                 $tax_name=$servicetax=DB::table('service_taxs')->where('id',$key)->get()->first();

                 $tax=array(
                     'id'       =>  $key,
                     'name'     =>  $tax_name->name,
                     'value'    =>  $value,
                    );
                    \array_push($taxes, $tax);
                }

                $service_tax=  json_encode($taxes);

                $data = $request->all();
                $station_id="EVM".$station_code.randomString(5);
                $stations->station_id=str_replace(" ",'',$station_id);
                $stations->created_by='admin';
                $stations->service_tax=$service_tax;
                $stations->created_by_id=Auth::user()->id;
                $stations->fill($data)->save();
            
                $this->logActivity(['module' => 'Stations','activity' => 'activity_added']);
				
				

              DB::commit();
                return redirect('/stations')->withSuccess(('Station').' '.trans('messages.saved'));
				
				}catch(Exception $e){

                    DB::rollback();
					 return redirect('/stations')->withErrors(('Station').' '.trans('Something Went Wrong'));
				
				}


        }
        public function show($id)
        {
             $id=Crypt::decrypt($id);

            $servicetax=DB::table('service_taxs')->get();

            $stations=Station::join('cities','cities.city_id','=','stations.city_id')->where('id',$id)->first();
            $connections=ChargePointTypes::get()->pluck('name','id')->all();
            $menu['menu']="stations";

            $stations_id=$stations->station_id;



            $nozils=StationNozzle::select('station_nozzles.*','charge_point_types.name as connection_type','charger_types.charger_code as code')
             ->join('charge_point_types','charge_point_types.id','=','station_nozzles.type')
             ->join('charger_types','charger_types.id','=','station_nozzles.charger_code')
             ->orderBy('charger_id','ASC')
             ->where('station_id',$stations_id)->get();

            $created_by="";
            $mapicon='';
            $status='';
            if($stations->status=='active'){
                $mapicon=url('assets/img/map/active.png');
                $status='success';
            }else{
                $mapicon=url('assets/img/map/banned.png');
                $status='danger';
            }
            if($stations->created_by=='admin'){
            $user=User::find($stations->created_by_id);
                $created_by=$user->fullname;
                $visible='';
            }else{
                $franchise=Franchise::where('franchaise_id',$stations->created_by_id)->get()->first();
                $created_by=$franchise->fullname;
                $visible='readonly';

            }
       

           
            
           return view('admin.stations.view',compact('visible','servicetax','connections','menu','stations','created_by','status','mapicon','nozils'));
        }





        public function update(Request $request,$id){


            $validation = Validator::make($request->all(),[
                'latitude' => 'required',
                'longitude' => 'required',
                'station_name' => 'required|unique:stations,station_name,' .$id.',id',
                'location_name' => 'required',
                'city_id'   =>'required',
                'state_id' => 'required',
                'address'   =>'required',
                'application'   =>'required',
				'opening_time'  => 'required',
				'closing_time'  => 'required',
            ]);

            try{
    
            if($validation->fails()){
                if($request->has('ajax_submit')){
                    $response = ['message' => $validation->messages()->first(), 'status' => 'error']; 
                    return response()->json($response, 200, array('Access-Controll-Allow-Origin' => '*'));
                }
                return redirect()->back()->withInput()->withErrors($validation->messages());
            }

            $taxes=array();
            DB::beginTransaction();


            foreach ($request->tax as $key => $value) {
             $tax_name=$servicetax=DB::table('service_taxs')->where('id',$key)->get()->first();

             $tax=array(
                 'id'       =>  $key,
                 'name'     =>  $tax_name->name,
                 'value'    =>  $value,
                );
                \array_push($taxes, $tax);
            }
            $service_tax=  json_encode($taxes);
            $stations=Station::find($id);
            $stations->station_name    = $request->station_name;
            $stations->location_name   = $request->location_name;
            $stations->latitude        = $request->latitude;
            $stations->longitude       = $request->longitude;
            $stations->city_id         = $request->city_id;
            $stations->state_id        = $request->state_id;
            $stations->address         = $request->address;
            $stations->service_tax     = $service_tax;
            $stations->application     = $request->application;
			$stations->opening_time    = $request->opening_time;
			$stations->closing_time    = $request->closing_time;
          

            if($request->franchise_id){
                $stations->created_by_id=$request->franchise_id;
                $stations->created_by="franchise";
            }

            $stations->save();
           

            $this->logActivity(['module' => 'stations','unique_id'=>$id,'activity' => 'status_updated']);
             DB::commit();
            return redirect('/stations')->withSuccess(trans('Stations').' '.trans('messages.updated'));
        }catch(Exception $e){
            DB::rollback();
            return redirect('/stations')->withErrors("Something Went Wrong");
        }
        }


        public function changeStatus($id){

            $id=Crypt::decrypt($id);
                $stations = \App\Station::find($id);

                if(!$stations || Entrust::can('change-station-status') || $stations->status == 'in-active')
                    return view('common.error',['message' => trans('messages.permission_denied')]);

                return view('admin.stations.change_status',compact('stations'));

        }
        public function postChangeStatus(Request $request, $id){

                $stations = \App\Station::find($id);

                $validation = Validator::make($request->all(),[
                    'status' => 'required'
                ]);

                if($validation->fails()){
                  
                    return redirect()->back()->withErrors($validation->messages()->first());
                }

                $stations->status = $request->input('status');
                $stations->save();

                $this->logActivity(['module' => 'stations','unique_id'=>$id,'activity' => 'status_updated']);
                return redirect('/stations')->withSuccess(trans('messages.stations').' '.trans('messages.status').' '.trans('messages.updated'));
        }








        



    public function addNozzil(StationNozzle $StationNozzle,Request $request){


      

        $validation = Validator::make($request->all(),[
            'type'           => 'required',
            'station_id'     => 'required',
            'nozzle_id'      => 'required',
            'charger_code'   => 'required',
            'power_rating'   => 'required',
            'description'    => 'required',
            'simno'          => 'required',
            'charger_id'     => 'required',
                ], 
        ['nozzle_id.required' => 'Ocpp Id required',
            'nozzle_id.unique' => 'Ocpp Id Already Exist']);
        if($validation->fails()){
            return redirect()->back()->withInput()->withErrors($validation->messages());
        }


       
       try {
           $decrypted = Crypt::decrypt($request->station_id);
       } catch (Illuminate\Contracts\Encryption\DecryptException $e) {
           return $e;
           
       }

       $stations = Station::find($decrypted);

        $stations_id= $stations->station_id;

       $chargers_count=StationNozzle::where('station_id',$stations_id)->get()->count();
        
        $station_code = strtoupper(substr($stations->location_name, 0, 4));
        
        // $nozzle_id=Helper::nozzilCode($station_code);

        $nozzil=new StationNozzle;
        $nozzil->type            =  $request->type;
        $nozzil->station_id      =  $stations_id;
        $nozzil->nozzle_id       =  $request->nozzle_id;
        $nozzil->charger_id      =  $request->charger_id;
        $nozzil->charger_code    =  $request->charger_code;
        $nozzil->power_rating    =  $request->power_rating;
        $nozzil->description     =  $request->description;
        $nozzil->simno           =  $request->simno;

        $nozzil->save();

        
        $this->logActivity(['module' => 'stations_nozzil','activity' => 'activity_added']);
        return redirect('/stations/'.$request->station_id)->withSuccess(trans('Nozzil').' '.trans('messages.saved'));
       

    }


        public function changeNozzilStatus($id)
        {
            $nozzil = \App\StationNozzle::find($id);
           

            if(!$nozzil || Entrust::can('change-station-status') || $nozzil->status == 'in-active')
                return view('common.error',['message' => trans('messages.permission_denied')]);
                //$this->logActivity(['module' => 'stations','unique_id'=>$id,'activity' => 'status_updated']);
            return view('admin.stations.change_nozzil_status',compact('nozzil'));
        }


        public function postChangeNozzilStatus(Request $request, $id){
            $nozzil = \App\StationNozzle::find($id);

            $validation = Validator::make($request->all(),[
                'status' => 'required'
            ]);

            if($validation->fails()){
               
                return redirect()->back()->withErrors($validation->messages()->first());
            }

            $nozzil->status = $request->input('status');
            $nozzil->save();

            $this->logActivity(['module' => 'stations_nozzil','unique_id'=>$id,'activity' => 'status_updated']);
            return redirect()->back()->withSuccess(trans('messages.stations').' '.trans('messages.status').' '.trans('messages.updated'));
 
        }






        public function changeNozzilType($id)
        {
            $nozzil = \App\StationNozzle::find($id);
            $connections=ChargePointTypes::get()->pluck('name','id')->all();
            if(!$nozzil || Entrust::can('change-station-status') || $nozzil->status == 'in-active')
                return view('common.error',['message' => trans('messages.permission_denied')]);

            return view('admin.stations.change_nozzil_type',compact('nozzil','connections'));
        }


        public function postChangeNozzilType(Request $request, $id){
            $nozzil = \App\StationNozzle::find($id);

            $validation = Validator::make($request->all(),[
                'type' => 'required'
            ]);

            if($validation->fails()){
               return redirect()->back()->withErrors($validation->messages()->first());
            }

            $nozzil->type = $request->input('type');
            $nozzil->save();
            $this->logActivity(['module' => 'stations_nozzil','unique_id'=>$id,'activity' => 'type_updated']);


            return redirect()->back()->withSuccess(trans('messages.stations').' '.trans('messages.status').' '.trans('messages.updated'));
 
        }


        public function changeNozzilPriceCapacity(Request $request){

            $price=$request->price;
            $capacity=$request->capacity;
            $id=$request->id;
            $charger_id=$request->charger_id;
            if($price){
                    $nozzil = \App\StationNozzle::where(['nozzle_id'=>$id,'charger_id'=>$charger_id])->get()->first();
                    $nozzil->price=$price;
                    $nozzil->save();
            $this->logActivity(['module' => 'nozzil_price','unique_id'=>$nozzil->id,'activity' => 'type_updated']);
                    $response = ['message' => trans('Updated Successfully'), 'status' => 'success']; 
                    return response()->json($response, 200, array('Access-Controll-Allow-Origin' => '*'));
                
            }
            if($capacity){
                    $nozzil = \App\StationNozzle::where('nozzle_id',$id)->get()->first();
                    $nozzil->capacity=$capacity;
                    $nozzil->save();
            $this->logActivity(['module' => 'nozzil_capacity','unique_id'=>$nozzil->id,'activity' => 'type_updated']);
                    $response = ['message' => trans('Updated Successfully'), 'status' => 'success']; 
                    return response()->json($response, 200, array('Access-Controll-Allow-Origin' => '*'));
            }

            $response = ['message' => trans('Failed'), 'status' => 'Error']; 
	        return response()->json($response, 200, array('Access-Controll-Allow-Origin' => '*'));


        }


       


        
    function locations(){
        $menu['menu']="stations";
        //$packages = Helper::translateList(config('lists.companys'));

        $cities=\App\Station::join('cities','stations.city_id','=','cities.city_id')->select('city_name','cities.city_id')->distinct()->get();;
        
        $usage = Helper::translateList(config('lists.usage'));
        $connections=\App\ChargePointTypes::get()->all();
        return view('admin.stations.stations_map',compact('packages','connections','cities','usage','menu'));
    }


    function points(Request $request){
        $data=array();
      
        if($request->has('lat') && $request->has('lng')){
        

        $latitude= $request->lat;
        $longitude= $request->lng;
        $range=$request->range;

    $da=DB::table("stations")
    ->select("stations.id",'address','location_name',"latitude","longitude",'station_name','status'
        ,DB::raw("6367 * acos(cos(radians(" . $latitude . ")) 
        * cos(radians(stations.latitude)) 
        * cos(radians(stations.longitude) - radians(" . $longitude . ")) 
        + sin(radians(" .$latitude. ")) 
        * sin(radians(stations.latitude))) AS distance "));
        
    if(Entrust::hasRole('organisation'))
   $da->where('application',Auth::user()->package);

   $data= $da->having('distance', '<', $range)
        ->orderBy('distance')
        ->get();

        return $data;
        }else{
            
               $city        =$request->state;
               $connections = $request->connector_type;
               $usages      = $request->usage_type;
               $application = $request->application;

               $data=DB::table('stations')->select("address",'location_name',"stations.station_id","latitude","longitude",'station_name','stations.status')
               ->leftjoin('station_nozzles','station_nozzles.station_id','=','stations.station_id');
               if($application){
                $data->wherein('application',$application);
               }
               if(Entrust::hasRole('organisation'))
               $data->where('application',Auth::user()->package);

               if($city){
                $data->wherein('city_id',$city);
               }
               if($usages){
                $data->wherein('stations.status',$usages);
               }
               if($connections){
                $data->wherein('station_nozzles.type',$connections);
               }
              return  $data->distinct('stations.station_id')->get();

               
        }
    }



    public function getStationsByApplication($application){
       
            return  $application = Station::where('application',$application)->get();
       
    }
    public function getChargersByStations($stations){
       
        return  $chargers = StationNozzle::where('station_id',$stations)->get();
   
}

    

    
}
