<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\VehicleManufacturer;
use App\Classes\Helper;
use Validator;
use App\VehicleModels;

class VehicleManufacturers extends Controller
{
    use BasicController;
  public function index(){
    $menu=['masters'];
    $col_heads = array(
        		
        trans('messages.name'),
        trans('About'),
        trans('messages.option'),
        );
        $table_info = array(
			'source' => 'vehiclemanufacturer',
			'title' => 'Vehicles Manufacturer List',
			'id' => 'vehicles_manufacturer_table'
		);

    return view('admin.vehicle_masters.index',compact('menu','col_heads','table_info'));
  }

  public function lists(Request $request){

    $columns = array( 
        0 =>'name',
        1=> 'about',
        2=> 'about',

    );

$totalData = \App\VehicleManufacturer::count();

$totalFiltered = $totalData; 

$limit = $request->input('length');
$start = $request->input('start');
$order = $columns[$request->input('order.0.column')];
$dir = $request->input('order.0.dir');

if(empty($request->input('search.value')))
{            
$template = \App\VehicleManufacturer::offset($start)
        ->limit($limit)
        ->orderBy($order,$dir)
        ->get();
}
else {
$search = $request->input('search.value'); 

$template =  \App\VehicleManufacturer::where('name','LIKE',"%{$search}%")
        ->orWhere('about', 'LIKE',"%{$search}%")
        ->offset($start)
        ->limit($limit)
        ->orderBy($order,$dir)
        ->get();

$totalFiltered = \App\VehicleManufacturer::where('name','LIKE',"%{$search}%")
         ->orWhere('about', 'LIKE',"%{$search}%")
         ->count();
}
$rows=[];
$data = array();
$i=1;
if(!empty($template))
{
    $i=1;
foreach ($template as $template){
    $rows[] = array(
        $template->name,
        Helper::toWord($template->about),
        '<div class="btn-group btn-group-xs">'.
        '<a href="#" data-href="/vehiclemanufacturer/'.$template->id.'/edit" class="btn btn-xs btn-default edit-form" data-toggle="modal" data-target="#mymodel"> <i class="fa fa-edit" data-toggle="tooltip" title="'.trans('messages.edit').'"></i></a> '.
        // (!$template->is_default ? delete_form(['vehiclemanufacturer.destroy',$template->id],'template',1) : '').
        '</div>',
        );  
      $i++;
    }
}
$json_data = array(
"draw"            => intval($request->input('draw')),  
"recordsTotal"    => intval($totalData),  
"recordsFiltered" => intval($totalFiltered), 
"aaData"            => $rows   
);
echo json_encode($json_data); 
    
}

public function store(VehicleManufacturer $manufacturer,Request $request)
{

    $validation = Validator::make($request->all(),[
        'name' => 'required|unique:vehicle_manufacturers,name',
    ]);

            if($validation->fails()){
                if($request->has('ajax_submit')){
                    $response = ['message' => $validation->messages()->first(), 'status' => 'error']; 
                    return response()->json($response, 200, array('Access-Controll-Allow-Origin' => '*'));
                }
                return redirect()->back()->withInput()->withErrors($validation->messages());
            }
        $data = $request->all();
        $manufacturer->fill($data)->save();
        $this->logActivity(['module' => 'VehicleManufacturer','activity' => 'activity_added']);
       
    
        return redirect()->back()->withSuccess(trans('VehicleManufacturer').' '.trans('messages.saved'));
        
}


public function edit($id)
{
    $manufacturer=VehicleManufacturer::find($id);
    return view('admin.vehicle_masters.edit_manufacturer',compact('manufacturer'));
}
        public function destroy ($id)
        {
            # code...
        }




        public function update(Request $request,$id)
        {

            $manufacturer=VehicleManufacturer::find($id);
            $validation = Validator::make($request->all(),[
                'name' => 'required',
            ]);
    
            if($validation->fails()){
                if($request->has('ajax_submit')){
                    $response = ['message' => $validation->messages()->first(), 'status' => 'error']; 
                    return response()->json($response, 200, array('Access-Controll-Allow-Origin' => '*'));
                }
                return redirect()->back()->withInput()->withErrors($validation->messages());
            }
    
            $manufacturer->name = $request->input('name');
            $manufacturer->about = $request->input('about');
            $manufacturer->save();
    
            $this->logActivity(['module' => 'VehicleManufacturer','activity' => 'activity_updated']);
    
            if($request->has('ajax_submit')){
                $response = ['message' => trans('Manufacturer').' '.trans('messages.saved'), 'status' => 'success']; 
                return response()->json($response, 200, array('Access-Controll-Allow-Origin' => '*'));
            }
            return redirect()->back()->withSuccess(trans('VehicleManufacturer').' '.trans('messages.updated'));
        
        }



        public function findModels(Request $request){

            return $data= VehicleModels::where('v_manufacture_id',$request->id)->get();
           
        }
}
