<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\VehicleModelVariants;
use App\VehicleManufacturer;

use App\Classes\Helper;
use Validator;
use App\VehicleModels;

class VehicleModelVariant extends Controller
{
    use BasicController;
  public function index(){
    $menu=['masters'];
    $col_heads = array(
        		
        trans('messages.name'),
        trans('Manufactures'),
        trans('Model'),
        trans('messages.option'),
        );
        $table_info = array(
			'source' => 'modelvarients',
			'title' => 'Vehicles Model Variants List',
			'id' => 'model_variants_table'
        );
        $manufactures=VehicleManufacturer::get()->pluck('name','id')->all();
        $models=VehicleModels::get()->pluck('name','id')->all();
        

    return view('admin.vehicle_masters.modalvarients',compact('menu','col_heads','table_info','manufactures','models'));
  }

  public function lists(Request $request){

    $columns = array( 
        0 =>'name',
        1=> 'm_name',
        2=> 'm_model',
        3=> 'name',

    );

$totalData = \App\VehicleModelVariants::count();

$totalFiltered = $totalData; 

$limit = $request->input('length');
$start = $request->input('start');
$order = $columns[$request->input('order.0.column')];
$dir = $request->input('order.0.dir');

if(empty($request->input('search.value')))
{            
$template = \App\VehicleModelVariants::select('vehicle_model_variants.id','vehicle_model_variants.name','vehicle_manufacturers.name as m_name','vehicle_models.name as m_model')
        ->join('vehicle_manufacturers','vehicle_manufacturers.id','=','vehicle_model_variants.v_manufacture_id')
        ->join('vehicle_models','vehicle_models.id','=','vehicle_model_variants.v_model_id')
        ->offset($start)
        ->limit($limit)
        ->orderBy($order,$dir)
        ->get();
}
else {
$search = $request->input('search.value'); 

$template =  \App\VehicleModelVariants::select('vehicle_model_variants.id','vehicle_model_variants.name','vehicle_manufacturers.name as m_name','vehicle_models.name as m_model')
        ->join('vehicle_manufacturers','vehicle_manufacturers.id','=','vehicle_model_variants.v_manufacture_id')
        ->join('vehicle_models','vehicle_models.id','=','vehicle_model_variants.v_model_id')
        ->where('vehicle_model_variants.name','LIKE',"%{$search}%")
        ->orwhere('vehicle_manufacturers.name','LIKE',"%{$search}%")
        ->orwhere('vehicle_models.name','LIKE',"%{$search}%")
        ->offset($start)
        ->limit($limit)
        ->orderBy($order,$dir)
        ->get();

$totalFiltered = \App\VehicleModelVariants::select('vehicle_model_variants.id','vehicle_model_variants.name','vehicle_manufacturers.name as m_name','vehicle_models.name as m_model')
        ->join('vehicle_manufacturers','vehicle_manufacturers.id','=','vehicle_model_variants.v_manufacture_id')
        ->join('vehicle_models','vehicle_models.id','=','vehicle_model_variants.v_model_id')
        ->where('vehicle_model_variants.name','LIKE',"%{$search}%")
        ->orwhere('vehicle_manufacturers.name','LIKE',"%{$search}%")
        ->orwhere('vehicle_models.name','LIKE',"%{$search}%")
        ->count();
}
$rows=[];
$data = array();
$i=1;
if(!empty($template))
{
    $i=1;
foreach ($template as $template){
    $rows[] = array(
        $template->name,
        $template->m_name,
        Helper::toWord($template->m_model),
        '<div class="btn-group btn-group-xs">'.
        '<a href="/modelvarients/'.$template->id.'/edit" class="btn btn-xs btn-default edit-form"> <i class="fa fa-edit" data-toggle="tooltip" title="'.trans('messages.edit').'"></i></a> '.
        // (!$template->is_default ? delete_form(['vehiclemanufacturer.destroy',$template->id],'template',1) : '').
        '</div>',
        );  
      $i++;
    }
}
$json_data = array(
"draw"            => intval($request->input('draw')),  
"recordsTotal"    => intval($totalData),  
"recordsFiltered" => intval($totalFiltered), 
"aaData"            => $rows   
);
echo json_encode($json_data); 
    
}

public function store(VehicleModelVariants $manufacturer,Request $request)

{

    $validation = Validator::make($request->all(),[
        'name' => 'required|unique:vehicle_model_variants,name',
        'v_model_id' => 'required',
        'v_manufacture_id' => 'required',
    ]);

            if($validation->fails()){
               
                return redirect()->back()->withInput()->withErrors($validation->messages());
            }
        $data = $request->all();
        $manufacturer->fill($data)->save();
        $this->logActivity(['module' => 'VehicleModelVariants','activity' => 'activity_added']);
        return redirect()->back()->withSuccess(trans('VehicleModelVariants').' '.trans('messages.saved'));
        
}
public function edit($id)
{
    $variants=VehicleModelVariants::find($id);
    $manufacturer=VehicleManufacturer::get()->pluck('name','id')->all();
    $model=VehicleModels::get()->pluck('name','id')->all();
    return view('admin.vehicle_masters.edit_variants',compact('manufacturer','variants','model'));
}
        public function destroy ($id)
        {
            # code...
        }




        public function update(Request $request,$id)
        {

            $manufacturer=VehicleModelVariants::find($id);
            $validation = Validator::make($request->all(),[
                'name' => 'required',
            ]);
    
            if($validation->fails()){
                if($request->has('ajax_submit')){
                    $response = ['message' => $validation->messages()->first(), 'status' => 'error']; 
                    return response()->json($response, 200, array('Access-Controll-Allow-Origin' => '*'));
                }
                return redirect()->back()->withInput()->withErrors($validation->messages());
            }
    
            $manufacturer->name = $request->input('name');
            $manufacturer->about = $request->input('about');
            $manufacturer->v_manufacture_id = $request->input('v_manufacture_id');
            $manufacturer->v_model_id = $request->input('v_model_id');
            $manufacturer->save();
    
            $this->logActivity(['module' => 'VehicleModelVariants','activity' => 'activity_updated']);
    
          
            return redirect('modelvarients')->withSuccess(trans('VehicleModelVariants').' '.trans('messages.updated'));
        
        }
}
