<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\VehicleModels;
use App\VehicleManufacturer;
use App\Classes\Helper;
use Validator;

class VehiclesModel extends Controller
{
    use BasicController;
  public function index(){
    $menu=['masters'];

    $col_heads = array(
        		
        trans('messages.name'),
        trans('Models'),
        trans('messages.option'),
        );
        $table_info = array(
			'source' => 'vehiclemodel',
			'title' => 'Vehicles Model List',
			'id' => 'vehicle_model_table'
        );
        $manufactures=VehicleManufacturer::get()->pluck('name','id')->all();

    return view('admin.vehicle_masters.modals',compact('menu','col_heads','table_info','manufactures'));
  }

  public function lists(Request $request){

    $columns = array( 
        0 =>'name',
        1=> 'm_name',
        2=> 'm_name',

    );

$totalData = \App\VehicleModels::count();

$totalFiltered = $totalData; 

$limit = $request->input('length');
$start = $request->input('start');
$order = $columns[$request->input('order.0.column')];
$dir = $request->input('order.0.dir');

if(empty($request->input('search.value')))
{            
// return $template = \App\VehicleModels::offset($start)
//         ->limit($limit)
//         ->orderBy($order,$dir)
//         ->get();

  $template = \App\VehicleModels::select('vehicle_models.about','vehicle_models.id','vehicle_models.name','v_manufacture_id','vehicle_manufacturers.name as m_name')
        ->join('vehicle_manufacturers','vehicle_manufacturers.id','=','vehicle_models.v_manufacture_id')
        ->offset($start)
        ->limit($limit)
        ->orderBy($order,$dir)
        ->get();
}
else {
$search = $request->input('search.value'); 

$template =  \App\VehicleModels::select('vehicle_models.about','vehicle_models.id','vehicle_models.name','v_manufacture_id','vehicle_manufacturers.name as m_name')
->join('vehicle_manufacturers','vehicle_manufacturers.id','=','vehicle_models.v_manufacture_id')
        ->where('vehicle_models.name','LIKE',"%{$search}%")
        ->orWhere('vehicle_manufacturers.name', 'LIKE',"%{$search}%")
        ->offset($start)
        ->limit($limit)
        ->orderBy($order,$dir)
        ->get();

$totalFiltered = \App\VehicleModels::select('vehicle_models.about','vehicle_models.id','vehicle_models.name','v_manufacture_id','vehicle_manufacturers.name as m_name')
         ->join('vehicle_manufacturers','vehicle_manufacturers.id','=','vehicle_models.v_manufacture_id')
         ->where('vehicle_models.name','LIKE',"%{$search}%")
         ->orWhere('vehicle_manufacturers.name', 'LIKE',"%{$search}%")
         ->count();
}
$rows=[];
$data = array();
$i=1;
if(!empty($template))
{
    $i=1;
foreach ($template as $template){
    $rows[] = array(
        $template->name,
        Helper::toWord($template->m_name),
        '<div class="btn-group btn-group-xs">'.
        '<a href="#" data-href="/vehiclemodel/'.$template->id.'/edit" class="btn btn-xs btn-default edit-form" data-toggle="modal" data-target="#mymodel"> <i class="fa fa-edit" data-toggle="tooltip" title="'.trans('messages.edit').'"></i></a> '.
        // (!$template->is_default ? delete_form(['vehiclemanufacturer.destroy',$template->id],'template',1) : '').
        '</div>',
        );  
      $i++;
    }
}
$json_data = array(
"draw"            => intval($request->input('draw')),  
"recordsTotal"    => intval($totalData),  
"recordsFiltered" => intval($totalFiltered), 
"aaData"            => $rows   
);
echo json_encode($json_data); 
    
}

public function store(VehicleModels $vehiclemodel,Request $request)
{

    // return $request;
    $validation = Validator::make($request->all(),[
        'name' => 'required|unique:vehicle_models,name',
        'v_manufacture_id' => 'required',
    ]);

            if($validation->fails()){
              
                return redirect()->back()->withInput()->withErrors($validation->messages());
            }
        $data = $request->all();
        $vehiclemodel->fill($data)->save();
        $this->logActivity(['module' => 'vehiclemodel','activity' => 'activity_added']);
        return redirect()->back()->withSuccess(trans('VehicleModels').' '.trans('messages.saved'));
        
}
public function edit($id)
{
    $vehiclemodel=VehicleModels::find($id);
    $manufactures=VehicleManufacturer::get()->pluck('name','id')->all();
    return view('admin.vehicle_masters.edit_models',compact('vehiclemodel','manufactures'));
}
        public function destroy ($id)
        {
            # code...
        }




        public function update(Request $request,$id)
        {

            $vehiclemodel=VehicleModels::find($id);
            $validation = Validator::make($request->all(),[
                'name' => 'required',
            ]);
    
            if($validation->fails()){
                if($request->has('ajax_submit')){
                    $response = ['message' => $validation->messages()->first(), 'status' => 'error']; 
                    return response()->json($response, 200, array('Access-Controll-Allow-Origin' => '*'));
                }
                return redirect()->back()->withInput()->withErrors($validation->messages());
            }
    
            $vehiclemodel->name = $request->input('name');
            $vehiclemodel->v_manufacture_id = $request->input('v_manufacture_id');
            $vehiclemodel->about = $request->input('about');
            $vehiclemodel->save();
    
            $this->logActivity(['module' => 'vehiclemodel','unique_id'=>$id,'activity' => 'activity_updated']);
    
           
            return redirect()->back()->withSuccess(trans('vehiclemodel').' '.trans('messages.updated'));
        
        }
}
