<?php
namespace App\Http\Middleware;
use Closure;
use Auth;
use Illuminate\Support\Facades\Input;
class AccountValid
{
    /**
     * Handle an incoming request.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \Closure  $next
     * @return mixed
     */
    public function handle($request, Closure $next)
    {
 
        $user = Auth::user();


        if($user->status == 'in-active')
            $response = ['message' => 'Your account is inactive, You cannot login.','type' => 'error'];
        elseif($user->status == 'pending_activation')
            $response = ['message' => 'Your email is not verified, Please check your email & click on the activation link.','type' => 'error'];
        elseif($user->status == 'pending_approval')
            $response = ['message' => 'Your account is not approved, Please contact system administrator.','type' => 'error'];
        elseif($user->status == 'pending_approval')
            $response = ['message' => 'Your account is not approved, Please contact system administrator.','type' => 'error'];
        elseif($user->status == 'banned')
            $response = ['message' => 'Your account is banned, Please contact system administrator.','type' => 'error'];
        else
            $response = ['type' => 'success'];



           // dd($response);

        if($response['type'] == 'error'){
            Auth::logout();
            return redirect()->back()->withInput()->withErrors($response['message']);
        }

        return $next($request);
    }
}
