<?php

namespace App\Http\Requests;

use App\Http\Requests\Request;

class FranchiseRequest extends Request
{
    /**
     * Determine if the user is authorized to make this request.
     *
     * @return bool
     */
    public function authorize()
    {
        return true;
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array
     */
    public function rules()
    {
        return [
                    'first_name' => 'required',
                    'last_name' => 'required',
                    'franchise_name' => 'required',
                    'latitude' => 'required',
                    'longitude' => 'required',                    
                    'password' => 'required|confirmed|min:6',
                    'email' => 'required|email|max:255|unique:franchises',
                    'username' => 'required|min:4|max:255|unique:franchises',
                    'password_confirmation' => 'required|same:password',
                    'organization' => 'required',
                ];
    }

    // public function attributes()
    // {
    //     return[
    //         'role_id' => 'role',
    //     ];

    // }
}
