<?php

namespace App\Http\Requests;

use App\Http\Requests\Request;
use App\Role;

class RoleRequest extends Request
{
 
    public function authorize()
    {
        return true;
    }
    /**
     * Get the validation rules that apply to the request.
     *
     * @return array
     */
        public function rules()
        {
            $role = $this->route('role');
            switch($this->method())
            {
                case 'GET':
                case 'DELETE':
                {
                    return [];
                }
                case 'POST':
                {
                    return [
                        'name' => 'required|unique:roles,name',
                    ];
                }
                case 'PUT':
                case 'PATCH':
                {
                    return [
                        'name' => 'required|unique:roles,name,'.$role->id
                    ];
                }
                default:break;
            }
        }
    

}
