<?php

namespace App\Http\Requests;
use App\Http\Requests\Request;

class UserRequest extends Request
{
    /**
     * Determine if the user is authorized to make this request.
     *
     * @return bool
     */
    public function authorize()
    {
        return true;
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array
     */
    public function rules()
    {
        $user = $this->route('user');
        return [
                    'first_name'    => 'required',
                    'last_name'     => 'required',
                    'role_id'       => 'sometimes|required',
                    'username'      => 'required|min:4|max:255|unique:users,username,'.$user->id,
                    'email'         => 'required|unique:users,email,'.$user->id,
                    'gender'        => 'required',
                    'mobile'        => 'required|unique:users,mobile,'.$user->id,
                
                ];
    }

    public function attributes()
    {
        return[
            'role_id' => 'role',
        ];

    }
}
