@extends('layouts.master')

@section('title', 'Edit Franchises')

@section('links')
<style>          
          #map { 
            height: 300px;    
            width: 500px;            
          }     
          #description {
        font-family: Roboto;
        font-size: 15px;
        font-weight: 300;
      }

      #infowindow-content .title {
        font-weight: bold;
      }

      #infowindow-content {
        display: none;
      }

      #map #infowindow-content {
        display: inline;
      }

      .pac-card {
        margin: 10px 10px 0 0;
        border-radius: 2px 0 0 2px;
        box-sizing: border-box;
        -moz-box-sizing: border-box;
        outline: none;
        box-shadow: 0 2px 6px rgba(0, 0, 0, 0.3);
        background-color: #fff;
        font-family: Roboto;
      }

      #pac-container {
        padding-bottom: 12px;
        margin-right: 12px;
      }

      .pac-controls {
        display: inline-block;
        padding: 5px 11px;
      }

      .pac-controls label {
        font-family: Roboto;
        font-size: 13px;
        font-weight: 300;
      }

      #pac-input {
        background-color: #fff;
        font-family: Roboto;
        font-size: 15px;
        font-weight: 300;
        margin-left: 12px;
        padding: 0 11px 0 13px;
        text-overflow: ellipsis;
        width: 400px;
      }

      #pac-input:focus {
        border-color: #4d90fe;
      }

      #title {
        color: #fff;
        background-color: #4d90fe;
        font-size: 25px;
        font-weight: 500;
        padding: 6px 12px;
      }
      #target {
        width: 345px;
      }     
        </style> 
@endsection



@section('content')

<div class="br-mainpanel">

<div class="br-pageheader pd-y-15 pd-l-20">
        <nav class="breadcrumb pd-0 mg-0 tx-12">
          <a class="breadcrumb-item" href="{{ URL::to('/') }}">{{ config('config.site_name')}}</a>
          <a class="breadcrumb-item" href="#">Franchises</a>
          <span class="breadcrumb-item active">Edit</span>
        </nav>
      </div><!-- br-pageheader -->
   

   
<div class="br-pagebody">
        <div class="br-section-wrapper">
       


     

@if(Entrust::can('create_franchise'))
<div class="col-sm-12" id="box-detail">
				<div class="box-info">
        <h2><strong>{!! trans('messages.edit') !!}</strong> Franchises
				</h2>

				   {!! Form::model($franchise,['method' => 'PATCH','route' => ['franchises.update',$franchise ] ,'class' => 'user-form ']) !!}
                    <div class="col-md-12">
						<div class="row">
							<div class="col-md-3">
								<div class="form-group">
								    {!! Form::label('first_name',trans('messages.first_name'),['class' => 'control-label'])!!}
									{!! Form::input('text','first_name',isset($franchise->first_name) ?  $franchise->first_name : old('first_name'),['class'=>'form-control','placeholder'=>trans('messages.first_name')])!!}
								</div>
							</div>
							<div class="col-md-3">
								<div class="form-group">
								    {!! Form::label('last_name',trans('messages.last_name'),['class' => 'control-label'])!!}
									{!! Form::input('text','last_name',isset($franchise->last_name) ?  $franchise->last_name : old('last_name'),['class'=>'form-control','placeholder'=>trans('messages.last_name')])!!}
								</div>
							</div>
              
              <div class="col-md-3">
						<div class="form-group">
						    {!! Form::label('username',trans('messages.username'),['class' => 'control-label'])!!}
							{!! Form::input('text','username',isset($franchise->username) ?  $franchise->username : old('username'),['class'=>'form-control','placeholder'=>trans('messages.username')])!!}
						</div>
            </div>
						</div>	
           		
					</div>
          
			<div class="col-md-12">
					   <div class="row">
					<div class="col-md-3">
            <div class="form-group">
						    {!! Form::label('email',trans('messages.email'),['class' => 'control-label'])!!}
							{!! Form::input('text','email',isset($franchise->email) ?  $franchise->email : old('email'),['class'=>'form-control','placeholder'=>trans('messages.email')])!!}
                        </div>
                        
            </div>
            <div class="col-md-3">
                <div class="form-group">
                                {!! Form::label('phone',trans('messages.phone'),['class' => 'control-label'])!!}
                                {!! Form::input('text','phone',isset($franchise->phone) ?  $franchise->phone : old('phone'),['class'=>'form-control','placeholder'=>trans('messages.phone')])!!}
                            </div>
                            
                </div>
							{{-- <div class="col-md-3">
								<div class="form-group">
								    {!! Form::label('password',trans('messages.password'),['class' => 'control-label'])!!}
									{!! Form::input('password','password','',['class'=>'form-control','placeholder'=>trans('messages.password')])!!}
								</div>
							</div>
							<div class="col-md-3">
								<div class="form-group">
								    {!! Form::label('password_confirmation',trans('messages.confirm_password'),['class' => 'control-label'])!!}
									{!! Form::input('password','password_confirmation','',['class'=>'form-control','placeholder'=>trans('messages.confirm_password')])!!}
								</div>
							</div> --}}
              {{-- <div class="col-md-3">
              <div class="form-group">
							<div class="radio">
								<label>
									{!! Form::checkbox('send_welcome_email', '1', '').' '.trans('messages.send_welcome_email') !!}
								</label>

							</div>
						</div>
            </div> --}}
            </div>
			</div>
                <div id="latmoved"  style="display:none;"></div>
								<div id="longmoved" style="display:none;"></div>
            <div class="col-md-12">
        <div class="row">
        <div class="col-md-6">
					
								<div class="form-group">
								    {!! Form::label('latitude',trans('Latitude'),['class' => 'control-label'])!!}
										{!! Form::input('latitude','latitude',isset($franchise->latitude) ?  $franchise->latitude : old('latitude'),['readonly'=>'readonly','class'=>'form-control','id'=>'latclicked','placeholder'=>trans('Latitude')])!!}
								</div>
                <div class="form-group">
								    {!! Form::label('latitude',trans('Latitude'),['class' => 'control-label'])!!}
									  {!! Form::input('longitude','longitude',isset($franchise->longitude) ?  $franchise->longitude : old('longitude'),['readonly'=>'readonly','class'=>'form-control','id'=>'longclicked','placeholder'=>trans('longitude')])!!}
								</div>
          <div class="form-group">
								    {!! Form::label('franchise_name',trans('Franchises Name'),['class' => 'control-label'])!!}
									  {!! Form::input('franchise_name','franchise_name',isset($franchise->franchise_name) ?  $franchise->franchise_name : old('franchise_name'),['class'=>'form-control','placeholder'=>trans('Franchise Name')])!!}
          </div>
          <div class="form-group">
            {!! Form::label('organization',trans('organization'),['class' => 'control-label'])!!}
          {!! Form::select('organization', [null => 'Select organization'] + $packages, isset($franchise->organization) ?  $franchise->organization : old('organization_id'),['class'=>'form-control input-xlarge select2me'])!!}

          </div>
										<div class="form-group">
									    {!! Form::label('Country',trans('Country'),['class' => 'control-label'])!!}
										{!! Form::select('country', [null => 'Select Country'] + $country,isset($franchise->country) ?  $franchise->country : old('country_id'),['class'=>'form-control input-xlarge select2me'])!!}

									  </div>
									  
										<div class="form-group">
									    {!! Form::label('State',trans('State'),['class' => 'control-label'])!!}
										{!! Form::select('state',  [null => 'Select State'] +$state,isset($franchise->state) ?  $franchise->state : old('state_id'),['class'=>'form-control input-xlarge select2me','placeholder'=>trans('messages.select_one')])!!}
									  </div>
									  
										<div class="form-group">
									    {!! Form::label('City',trans('City'),['class' => 'control-label'])!!}
										{!! Form::select('city',  [null => 'Select City'] +$city, isset($franchise->city) ?  $franchise->city : old('city_id'),['class'=>'form-control input-xlarge select2me','placeholder'=>trans('messages.select_one')])!!}
									  
									</div>
							
								
								
          </div>

          <div class="col-md-6">
				
				
							<div class="col-md-12">
								<div class="form-group">
								   
								<!-- <input type="text" id="pac-input" class="controls form-control" placeholder="Search  Location" style="border-radius:25px;height: 35px; width: 290px;" > -->
								
							 <div id="map"></div>
							 </div>
							</div>
          </div>


				  </div>
          
				</div>
         
					{!! Form::submit(isset($buttonText) ? $buttonText : trans('messages.update'),['class' => 'btn btn-primary pull-right']) !!}
					{!! Form::close() !!}
          <div class="col-sm-4">
                      
     

						
				</div>
			</div>
			@endif

        </div><!-- br-section-wrapper -->
      </div><!-- br-pagebody -->
    
 
@endsection
 

@section('scripts')

@section('scripts')

        <script>
        var geocoder;
        var map;
        var marker;

        function initialize() {
            var latitude =  {{ $franchise->latitude }}; // YOUR LATITUDE VALUE
            var longitude = {{ $franchise->longitude }}; // YOUR LONGITUDE VALUE
            
            var myLatLng = {lat: latitude, lng: longitude};
            
            map = new google.maps.Map(document.getElementById('map'), {
              center: myLatLng,
              zoom: 14,
              title: '{{ $franchise->username }}',
              disableDoubleClickZoom: true, // disable the default map zoom on double click
            });

            var marker = new google.maps.Marker({
              position: myLatLng,
              map: map,
              icon:"{{ url('assets/img/map/active.png') }}",
              draggable: true,
              animation: google.maps.Animation.DROP,
           
            });
            google.maps.event.addListener(map, "click", function(e) {

                latLng = e.latLng;
                longval = e.latLng.lat();
                latval = e.latLng.lng();


                //                var longClass = document.getElementsByClassName('long').html // longClass.val = longval

                // console.log("Marker");
                // if marker exists and has a .setMap method, hide it
                if (marker && marker.setMap) {
                    marker.setMap(null);

                }
                marker = new google.maps.Marker({

                    position: latLng,
                    map: map
                });
             

              document.getElementById('latclicked').value = longval.toFixed(6);
              document.getElementById('longclicked').value =  latval.toFixed(6);
                //document.getElementsByClassName('lat').html(longval);
                /**/
                /* alert(longval);*/


            });
        }
        google.maps.event.addDomListener(window, "load", initialize);
    </script>


@endsection










