@extends('layouts.master')

@section('title', 'Dashboard')

@section('links')
@endsection



@section('content')

<div class="br-mainpanel">

<div class="br-pageheader pd-y-15 pd-l-20">
        <nav class="breadcrumb pd-0 mg-0 tx-12">
            <a class="breadcrumb-item" href="{{ URL::to('/') }}">{{ config('config.site_name')}}</a>
          <a class="breadcrumb-item" href="#">Franchise</a>
          <span class="breadcrumb-item active">Locations</span>
        </nav>
      </div><!-- br-pageheader -->

   
<div class="br-pagebody">
        <div class="br-section-wrapper">
       

        <div id="map1" class="ht-100v  bd bg-gray-100">
                </div>
       <!-- Here Code -->

        </div><!-- br-section-wrapper -->
      </div><!-- br-pagebody -->
    
 
@endsection
 

@section('scripts')
<script>

initialize();
function initialize() {
    var map;
    var bounds = new google.maps.LatLngBounds();
    var mapOptions = {
        mapTypeId: 'roadmap'
    };
                    
    // Display a map on the page
    map = new google.maps.Map(document.getElementById("map1"), mapOptions);
    map.setTilt(45);

    // Display multiple markers on a map
    var infoWindow = new google.maps.InfoWindow(), marker, i;
    
    // Loop through our array of markers & place each one on the map  
@foreach($locations as $location)
        var position = new google.maps.LatLng({{ $location->latitude }}, {{ $location->longitude}});
        bounds.extend(position);
        marker = new google.maps.Marker({
            position: position,
            map: map,
            title: '{{ $location->franchise_name }}'
        });
        
        // Allow each marker to have an info window    
        google.maps.event.addListener(marker, 'click', (function(marker, i) {
            return function() {
                infoWindow.setContent('<div class="info_content">' +
        '<h4>{{ $location->franchise_name }}</h4>' +
        '<span class="label @if($location->status=="active") label-success @else label-danger @endif"> {{ App\Classes\Helper::toWord($location->status) }}</span>'+
        '<p><b>User Name</b> {{ $location->username}}</p>' +
        '<p><b>Name</b> {{ $location->first_name}} {{ $location->last_name }}</p>' +
        '</div>');
                infoWindow.open(map, marker);
            }
        })(marker, i));

        // Automatically center the map fitting all markers on the screen
        map.fitBounds(bounds);
    @endforeach

    // Override our map zoom level once our fitBounds function runs (Make sure it only runs once)
    var boundsListener = google.maps.event.addListener((map), 'bounds_changed', function(event) {
        this.setZoom(14);
        google.maps.event.removeListener(boundsListener);
    });
    
}
    </script>

@endsection
