@extends('layouts.app')
@section('title', 'Reset Password')
<style>
.full-content-center{
    width: 100%;
    max-width: 500px;
    margin: 5% auto;
    text-align: center;
}
.login-wrap .login-input {
    position: relative;
}
.login-wrap .login-input i.overlay {
    position: absolute;
    left: 10px;
    top: 10px;
    color: #aaa;
}
.login-wrap .login-input .text-input {
    padding-left: 30px;
}</style>

    @section('content')
        <div class="full-content-center animated fadeInDownBig">
            <a href="/"><img src="/{{ config('constants.upload_path.logo').config('config.logo')}}" class="" alt="Logo"></a>

            <div class="login-wrap">
                <div class="box-info">
                <h2 class="text-center"><strong>{!! trans('Reset Password') !!}</strong> </h2>
                    
                    <form role="form" action="{!! URL::to('password/reset') !!}" method="post" class="reset-password-form" id="reset-password-form" data-submit="noAjax">
                        <input type="hidden" name="token" value="{{ $token }}">
                        {!! csrf_field() !!}
                        <div class="form-group login-input">
                        <i class="fa fa-envelope overlay"></i>
                        <input type="email" name="email" id="email" value="" class="form-control text-input" placeholder="{!! trans('messages.email') !!}">
                        </div>
                        <div class="form-group login-input">
                        <i class="fa fa-key overlay"></i>
                        <input type="password" name="password" id="password" class="form-control text-input" placeholder="{!! trans('New Password') !!}">
                        </div>
                        <div class="form-group login-input">
                        <i class="fa fa-key overlay"></i>
                        <input type="password" name="confirmed" id="confirmed" class="form-control text-input" placeholder="{!! trans('New Confirm Password') !!}">
                        </div>
                        
                        <div class="row">
                            <div class="col-sm-12">
                            <button type="submit" class="btn btn-success btn-block"><i class="fa fa-unlock"></i> {!! trans('Reset Password') !!}</button>
                            </div>
                        </div>
                    </form>
                    <p class="text-center"><a href="{!! URL::to('/franchise') !!}"><i class="fa fa-lock"></i> {!! trans('Back To Login') !!}</a></p>
                </div>
            </div>
        </div>
    @stop