<html>
<head>
    <meta charset="utf-8">
    <title> {!! config('config.company_name') !!}</title>
    
    <style>
    .invoice-box {
        max-width: 800px;
        margin: auto;
        padding: 30px;
        border: 1px solid #eee;
        box-shadow: 0 0 10px rgba(0, 0, 0, .15);
        font-size: 16px;
        line-height: 24px;
        font-family: 'Helvetica Neue', 'Helvetica', Helvetica, Arial, sans-serif;
        color: #555;
    }
    
    .invoice-box table {
        width: 100%;
        line-height: inherit;
        text-align: left;
    }
    
    .invoice-box table td {
        padding: 5px;
        vertical-align: top;
    }
    
    .invoice-box table tr td:nth-child(2) {
        text-align: right;
    }
    
    .invoice-box table tr.top table td {
        padding-bottom: 20px;
    }
    
    .invoice-box table tr.top table td.title {
        font-size: 45px;
        line-height: 45px;
        color: #333;
    }
    
    .invoice-box table tr.information table td {
        padding-bottom: 40px;
    }
    
    .invoice-box table tr.heading td {
        background: #eee;
        border-bottom: 1px solid #ddd;
        font-weight: bold;
    }
    
    .invoice-box table tr.details td {
        padding-bottom: 20px;
    }
    
    .invoice-box table tr.item td{
        border-bottom: 1px solid #eee;
    }
    
    .invoice-box table tr.item.last td {
        border-bottom: none;
    }
    
    .invoice-box table tr.total td:nth-child(2) {
        border-top: 2px solid #eee;
        font-weight: bold;
    }
    
    @media only screen and (max-width: 600px) {
        .invoice-box table tr.top table td {
            width: 100%;
            display: block;
            text-align: center;
        }
        
        .invoice-box table tr.information table td {
            width: 100%;
            display: block;
            text-align: center;
        }
    }
    
    /** RTL **/
    .rtl {
        direction: rtl;
        font-family: Tahoma, 'Helvetica Neue', 'Helvetica', Helvetica, Arial, sans-serif;
    }
    
    .rtl table {
        text-align: right;
    }
    
    .rtl table tr td:nth-child(2) {
        text-align: left;
    }
    </style>
</head>

<body>
    <div class="invoice-box">
        <table cellpadding="0" cellspacing="0">
            <tr class="top">
                <td colspan="2">
                    <table>
                        <tr>
                            <td class="title">
                                 @if(File::exists(config('constants.upload_path.logo').config('config.logo')))
                                <img src="{{url(config('constants.upload_path.logo').config('config.logo'))}}">
								  @endif
                            </td>
                            
                            <td>
                                 {!! config('config.company_name') !!}<br>
                                 {!! trans('messages.email') !!} :  {!! config('config.email') !!}<br>
                                 {!! trans('messages.phone') !!} :  {!! config('config.phone') !!}
                            </td>
                        </tr>
                    </table>
                </td>
            </tr>
            
            
            <tr class="heading">
               
               <td><em>Order Status</em></h4></td>
               <td>{{ $order_status }}</td>
            
            </tr>
           <tr class="heading">
                <td><em>Order Id</em></h4></td>
                <td>{{ $order_id }}</td>
           </tr>
			   <tr class="heading">
                <td><em>Tracking Id</em></h4></td>
		                            <td>{{ $tracking_id }}</td>
            </tr>
           <tr class="heading">
                            <td><em>Bank_ref_no</em></h4></td>
							
                            <td>{{ $bank_ref_no }}</td>
           </tr>

           <tr class="heading">
                               <td><em>Amount</em></h4></td>
							
                            <td>{{ $amount }}</td>
        </tr>
		<tr class="heading">
                               <td><em>Payment Mode</em></h4></td>
							
                            <td>{{ $payment_mode }}</td>
        </tr>
		<tr class="heading">
                               <td><em>Station Id</em></h4></td>
							
                            <td>{{ $station_id }}</td>
        </tr>
		<tr class="heading">
                               <td><em>Ocpp Id</em></h4></td>
							
                            <td>{{ $ocpp_id }}</td>
        </tr>
		<tr class="heading">
                               <td><em>Charger Id</em></h4></td>
							
                            <td>{{ $charger_id }}</td>
        </tr>
		<tr class="heading">
                               <td><em>User Id</em></h4></td>
							
                            <td>{{ $app_user_id }}</td>
        </tr>

        </table>
    </div>
</body>
</html>