<!DOCTYPE html>
<html lang="{{ app()->getLocale() }}">
<head>
	<meta charset="utf-8">
	<meta http-equiv="X-UA-Compatible" content="IE=edge">

    <title>@yield('title') - {{ config('config.site_name')}}</title> 

	<!-- Meta Informations -->
	<meta content="width=device-width, initial-scale=1, maximum-scale=1, user-scalable=no" name="viewport">
    <meta name="_token" content="{{ csrf_token() }}">
	<meta property="og:site_name" content="{{ config('app.name', 'OCPP') }}" />
	<meta property="og:locale" content="en_US" />
	<meta property="og:type" content="website" />
	<meta property="og:url" content="{{ url('/') }}" /><meta charset="utf-8" />
       

	<!-- Favicon -->
	<!--  -->
	
    <!-- Fonts -->
    <link href="https://fonts.googleapis.com/css?family=Raleway:100,600" rel="stylesheet" type="text/css">
	
	@include('layouts.partials.links')
	
	@yield('links')
    <link rel="stylesheet" href="http://cdn.bootcss.com/toastr.js/latest/css/toastr.min.css">
</head>
<body >
@if ($errors->any())
    <div class="alert alert-danger">
        <ul>
            <!-- @foreach ($errors->all() as $error)
                <li>{{ $error }}</li>
            @endforeach -->

            <script>
                       window.onload = function() {
                        var title="Error";
                        var type="error";
                        var msg="{{ $errors->first() }}";

                        if(type=="error"){
                            Command: toastr["error"](msg,title);
                        }
            };
            </script>
        </ul>
    </div>
@endif

         @if(Session::has('success'))
             <script>
                       window.onload = function() {
                        var title="Success";
                        var type="success";
                        var msg="{{ Session::get('success') }}";

                        if(type=="success"){
                            Command: toastr["success"](msg,title);
                        }
                    };
                    </script>
					 @elseif(Session::has('error'))
                            <script>
                       window.onload = function() {
                        var title="Error";
                        var type="error";
                        var msg="{{ Session::get('error') }}";

                        if(type=="error"){
                            Command: toastr["error"](msg,title);
                        }
                    };
                    </script>
                        @endif
                    
 <!-- ########## START: LEFT PANEL ########## -->
		@include('franchise.layouts.partials.sidebar')
<!-- ########## END: LEFT PANEL ########## -->

           <!-- ########## START: HEAD PANEL ########## -->
           @include('franchise.layouts.partials.header')
             <!-- ########## END: HEAD PANEL ########## -->


        @include('franchise.layouts.partials.right_sidebar')

 <!-- ########## START: MAIN PANEL ########## -->
			@yield('content')

		
            
		@include('layouts.partials.footer')
		
        </div><!-- br-mainpanel -->
          <!-- ########## END: MAIN PANEL ########## -->
	

	@include('layouts.partials.scripts')
    
        <script src="http://cdn.bootcss.com/toastr.js/latest/js/toastr.min.js"></script>
        <script type="text/javascript">
	$(".success").click(function(){
		toastr.success('We do have the Kapua suite available.', 'Success Alert', {timeOut: 5000})
	});

</script>
	<script>

toastr.options = {
  "closeButton": true,
  "debug": false,
  "newestOnTop": true,
  "progressBar": false,
  "positionClass": "toast-top-right",
  "preventDuplicates": false,
  "onclick": null,
  "showDuration": 300,
  "hideDuration": 1000,
  "timeOut": 5000,
  "extendedTimeOut": 1000,
  "showEasing": "swing",
  "hideEasing": "linear",
  "showMethod": "fadeIn",
  "hideMethod": "fadeOut"
}
</script>

	@yield('scripts')
	
</body>
</html>