<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/





Route::get('/cache', function(){

    $exitCode = Artisan::call('cache:clear');
     $exitCode = Artisan::call('config:clear');
     $exitCode = Artisan::call('view:clear');
     $exitCode = Artisan::call('config:cache');
   
 
      
         return Redirect::to('http://192.168.100.171:81');
 });
Auth::routes();
Route::group(['middleware' => ['auth','account_valid']], function() {

Route::get('/', 'HomeController@index');
Route::get('/home', 'HomeController@index');
Route::get('/dashboard', 'HomeController@dashboard')->name('dashboard');
Route::get('/recentregistred', 'HomeController@recentRegisteredUsers')->name('recentregistred');


Route::post('/recent-activity','HomeController@recentActivity');




Route::resource('permissions','PermissionsController');


Route::group(['middleware' => ['permission:manage_users']], function () {
Route::model('users','\App\UserController');
Route::post('/users/lists','UserController@lists');
Route::resource('users','UserController');
Route::get('/users/{id}/change-status','UserController@changeStatus');
Route::post('/users/{id}/change-status',array('as' => 'users.change-status','uses' => 'UserController@postChangeStatus'));
});

Route::model('roles','\App\Role');
Route::get('/roles/lists','RoleController@lists');
Route::resource('/roles', 'RoleController'); 


Route::group(['middleware' => ['permission:manage_template']], function () {
Route::model('templates','\App\Template');
Route::post('/templates/lists','TemplateController@lists');
Route::resource('/templates', 'TemplateController'); 


    
});
Route::get('/roles/{id}/delete',array('uses' => 'RoleController@delete'));






Route::group(['middleware' => ['permission:manage_app_users']], function () {
    Route::model('appusers','\App\AppUsersController');
    Route::post('/appusers/lists','AppUsersController@lists');
    Route::resource('appusers','AppUsersController');
    Route::get('/appusers/{id}/change-status','AppUsersController@changeStatus');
    Route::post('/appusers/{id}/change-status',array('as' => 'appusers.change-status','uses' => 'AppUsersController@postChangeStatus'));
    Route::get('appusers/{id}/filter',array('as' => 'appusers.filter','uses' => 'AppUsersController@filter'));
    Route::post('/appusers/users','AppUsersController@sampleTable');
	Route::get('/app-user/charging-history/{id}','AppUsersController@chargingHistory');
    Route::get('/charging-invoice/{id}/generate','AppUsersController@invoiceGenerate');
    Route::get('/download/pdf/{id}','AppUsersController@pdfGenerate');

    

	
});

Route::group(['middleware' => ['permission:settings']], function () {
    Route::resource('settings','ConfigController');
    Route::post('/mail-store', array('as' => 'settings.mail-store','uses' => 'ConfigController@mailStore'));
    Route::post('/logo-store', array('as' => 'settings.logo-store','uses' => 'ConfigController@logoStore'));
	
	Route::get('/package/{id}/edit', array('as' => 'settings.package.edit','uses' => 'ConfigController@packageEdit'));
	Route::post('/package/update', array('as' => 'settings.package.update','uses' => 'ConfigController@packageUpdate'));
    
    
    Route::post('/pkg-store', array('as' => 'settings.pkg-store','uses' => 'ConfigController@storePkg'));
    Route::post('/change_prices', array('as' => 'settings.change_prices','uses' => 'ConfigController@changePrices'));

    

});



Route::resource('vehiclemanufacturer','VehicleManufacturers');
Route::post('/vehiclemanufacturer/lists','VehicleManufacturers@lists');


Route::resource('vehiclemodel','VehiclesModel');
Route::post('/vehiclemodel/lists','VehiclesModel@lists');

Route::get('/vehiclemodel/{id}/getmanufacturers', 'VehicleManufacturers@findModels');


Route::resource('modelvarients','VehicleModelVariant');
Route::post('/modelvarients/lists','VehicleModelVariant@lists');

Route::resource('country','CountryController');
Route::get('country/{country}/states', 'CountryController@getStates');
Route::resource('states','StateController');
Route::resource('citys','CityController');
Route::get('state/{country}/city', 'StateController@getCities');


Route::model('stations','\App\Station');
Route::resource('stations','StationsController'); 
Route::post('/stations/lists','StationsController@lists');
Route::get('/stations/{id}/change-status','StationsController@changeStatus');
Route::post('/stations/{id}/change-status',array('as' => 'stations.change-status','uses' => 'StationsController@postChangeStatus'));
//change nozzile status
Route::post('stations/add_nozil',array('as' => 'stations.add_nozil','uses' => 'StationsController@addNozzil'));
Route::get('/stations/{id}/change-nozzil-status','StationsController@changeNozzilStatus');
Route::post('/stations/{id}/change-nozzil-status',array('as' => 'stations.change-nozzil-status','uses' => 'StationsController@postChangeNozzilStatus'));
//change nozzil types
Route::get('/stations/{id}/change-nozzil-type','StationsController@changeNozzilType');
Route::post('/stations/{id}/change-nozzil-type',array('as' => 'stations.change-nozzil-type','uses' => 'StationsController@postChangeNozzilType'));

Route::post('/stations/change_nozzil_price_capacity','StationsController@changeNozzilPriceCapacity');


Route::get('stationlocations','StationsController@locations');

Route::post('points','StationsController@points');





//Qr Code View/////

//Chargint Point Types
Route::model('pointtypes','\App\ChargePointTypes');
Route::resource('pointtypes','ChargePointTypeController'); 
Route::post('/pointtypes/lists','ChargePointTypeController@lists');




//FranchisesController Controling
Route::group(['middleware' => ['permission:manage_franchise']], function () {
Route::model('franchises','\App\Franchise');
Route::resource('franchises','FranchisesController');


Route::post('/franchises/lists','FranchisesController@lists');

Route::post('/franchase/stations/lists/{id}','FranchisesController@franchisesLists');


Route::get('/franchise-locations',array('as'=>'franchise-locations', 'uses'=>'FranchisesController@locations'));
Route::get('/franchises/{id}/change-status','FranchisesController@changeStatus');
Route::post('/franchises/{id}/change-status',array('as' => 'franchises.change-status','uses' => 'FranchisesController@postChangeStatus'));





});

Route::resource('transactions','Transactions');
Route::model('transactions','App\Transaction');

Route::match(['get', 'post'], 'chargingreport',array('as'=>'charging_report','uses'=>'Transactions@chargingReport'));


Route::get('application/{country}/stations', 'StationsController@getStationsByApplication');
Route::get('station/{country}/cps', 'StationsController@getChargersByStations');



//get users by Application
Route::get('application/{application}/users', 'AppUsersController@getUsersBypkg');




Route::model('chargertype', 'App\ChargerType');
Route::resource('chargertype', 'ChargerTypeController');
Route::post('/chargertype/lists','ChargerTypeController@lists');


Route::model('chargers', 'App\StationNozzle');
Route::resource('chargers', 'ChargerController');
Route::post('/chargers/lists','ChargerController@lists');

});

Route::group(['prefix' => 'franchise'], function() {
Route::group(['middleware' => ['auth']], function() { 

});
});

Route::get('database_count','HomeController@databases_count');

//Messages controlling//
Route::get('/message/view/{id}/{token}', array('as' => 'message.view', 'uses' => 'MessageController@view'));
//


Route::post('/chargers/getCodeDescription','ChargerController@chargerTypeDescription');







#################// Starting     franchise Functionsss ###########################

Route::group(['prefix'=>'franchise','as'=>'franchise'], function(){

//login
Route::get('/', 'Auth\LoginController@showFranchiseLoginForm');
Route::get('/login', 'Auth\LoginController@showFranchiseLoginForm');
Route::post('/login', 'Auth\LoginController@franchiseLogin');

//Dashboard
Route::group(['middleware' => ['auth:franchise','franchise_validate','account_valid']], function () {
Route::get('/dashboard', 'Franchises\HomeController@index')->name('dashboard');
//Stations
Route::model('stations','\App\Station');
Route::resource('/stations','Franchises\StationsController'); 
Route::post('/stations/lists','Franchises\StationsController@lists');
Route::get('/stations/{id}/change-status','Franchises\StationsController@changeStatus');
Route::post('/stations/{id}/change-status',array('as' => 'stations.change-status','uses' => 'Franchises\StationsController@postChangeStatus'));
//profile
Route::resource('profile',"Franchises\UserController");
Route::get('profile',"Franchises\UserController@edit");
 //change nozzile status
Route::post('stations/add_nozil',array('as' => 'stations.add_nozil','uses' => 'Franchises\StationsController@addNozzil'));
Route::get('/stations/{id}/change-nozzil-status','Franchises\StationsController@changeNozzilStatus');
Route::post('/stations/{id}/change-nozzil-status',array('as' => 'stations.change-nozzil-status','uses' => 'Franchises\StationsController@postChangeNozzilStatus'));
//change nozzil types
Route::get('/stations/{id}/change-nozzil-type','Franchises\StationsController@changeNozzilType');
Route::post('/stations/{id}/change-nozzil-type',array('as' => 'stations.change-nozzil-type','uses' => 'Franchises\StationsController@postChangeNozzilType'));
Route::post('/stations/change_nozzil_price_capacity','Franchises\StationsController@changeNozzilPriceCapacity');



Route::model('chargers', 'App\StationNozzle');
Route::resource('chargers', 'Franchises\ChargerController');
Route::post('/chargers/lists','Franchises\ChargerController@lists');


Route::get('users_reports',array("as"=>'.user.reports','uses'=>'Franchises\ReportsController@userReports'));
Route::resource('transactions','Franchises\Transactions');
Route::model('transactions','App\Transaction');





Route::match(['get', 'post'], 'chargingreport',array('as'=>'.charging_report','uses'=>'Franchises\Transactions@chargingReport'));

Route::get('station/{country}/cps', 'Franchises\StationsController@getChargersByStations');

Route::post('/recent-activity','Franchises\HomeController@recentActivity');

Route::get('/recentregistred', 'Franchises\HomeController@recentRegisteredUsers')->name('recentregistred');
 });




 Route::model('appusers','\App\AppUsersController');
 Route::post('/appusers/lists','Franchises\AppUsersController@lists');
 Route::resource('appusers','Franchises\AppUsersController');
 Route::get('/appusers/{id}/change-status','Franchises\AppUsersController@changeStatus');
 Route::post('/appusers/{id}/change-status',array('as' => '.appusers.change-status','uses' => 'Franchises\AppUsersController@postChangeStatus'));
 Route::get('appusers/{id}/filter',array('as' => '.appusers.filter','uses' => 'Franchises\AppUsersController@filter'));
 Route::post('/appusers/users','Franchises\AppUsersController@sampleTable');


});

//locations states cities
Route::resource('country','CountryController');
Route::get('country/{country}/states', 'CountryController@getStates');
Route::get('state/{country}/city', 'StateController@getCities');
Route::resource('states','StateController');
 


#################// End     franchise Functionsss ###########################




//QR CODE
Route::get('/qr-code/{id}/{con}/generate/','CommonController@qrCodeGenerate');
Route::get('/download/qr/{id}/{code}','CommonController@qrCodeGeneratePDF');




Route::get('/franchise/qr-code/{id}/{code}/generate','CommonController@qrCodeGenerate');




// Route::get('sendmessage',function(){

//     $to='9533402327';
//     $message="This IS Testing";
//     \App\Classes\Helper::sendMsg($to ,$to);
// });


Route::get('pdf',function(){

   return view('emails.payment_success');
});

Route::post('soucre',function(){
    return json_encode('/dashboard');
});




###############################################################################################
##############################            Reports          ####################################
###############################################################################################

Route::get('users_reports',array("as"=>'user.reports','uses'=>'ReportsController@userReports'));

Route::get('charge_stations_reports',array("as"=>'chargestations.reports','uses'=>'ReportsController@chargeStationsReports'));

Route::get('organization_wise_stations_reports',array("as"=>'organization.reports','uses'=>'ReportsController@organizationsWiseStationsReports'));
Route::get('/get_chargers/{id}','ReportsController@getChargersByStationReport');


Route::get('slots',function(){
    return App\SlotTimings::select('timings')->get();
});
###############################################################################################
##############################            Reports          ####################################
###############################################################################################


Route::get('bookings',"CommonController@bookings");

Route::get('booking/list/{id}',"CommonController@bookingsList");



Route::get('booking/details/{id}',"CommonController@bookingsdetails");


Route::resource('log', 'LogCheckController');


Route::get('logs', '\Rap2hpoutre\LaravelLogViewer\LogViewerController@index');




Route::post('/get/users',"CommonController@GetUsers");