<!DOCTYPE html>
<html lang="<?php echo e(app()->getLocale()); ?>">
<head>
<title><?php echo $__env->yieldContent('title'); ?> - <?php echo e(config('config.site_name')); ?></title> 
<!-- Meta Informations -->
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<meta content="width=device-width, initial-scale=1, maximum-scale=1, user-scalable=no" name="viewport">
<meta name="_token" content="<?php echo e(csrf_token()); ?>">
<meta property="og:site_name" content="<?php echo e(config('config.site_name')); ?>" />
<meta property="og:locale" content="en_US" />
<meta property="og:type" content="website" />
<meta property="og:url" content="<?php echo e(url('/')); ?>" /><meta charset="utf-8" />    
<?php echo e(HTML::style('https://fonts.googleapis.com/css?family=Raleway:100,600')); ?>

<?php echo e(HTML::style('css/mobiscroll.jquery.lite.min.css')); ?>

<?php echo $__env->make('layouts.partials.links', \Illuminate\Support\Arr::except(get_defined_vars(), array('__data', '__path')))->render(); ?>

<?php echo $__env->yieldContent('links'); ?>
<?php echo e(HTML::style('http://cdn.bootcss.com/toastr.js/latest/css/toastr.min.css')); ?>



</head>
<body >
<?php if($errors->any()): ?>
<script> window.onload = function() { var title="Error"; var type="error";var msg="<?php echo e($errors->first()); ?>";
                        if(type=="error"){  Command: toastr["error"](msg,title);  }  };
</script>
<?php endif; ?>
<?php if(Session::has('success')): ?><script>
 window.onload = function() {
var title="Success";var type="success";var msg="<?php echo e(Session::get('success')); ?>";
 if(type=="success"){ Command: toastr["success"](msg,title); }};
                    </script>
<?php elseif(Session::has('error')): ?> <script>
 window.onload = function() {     var title="Error";  var type="error"; var msg="<?php echo e(Session::get('error')); ?>";
if(type=="error"){ Command: toastr["error"](msg,title);}};  </script>
<?php endif; ?>                  
<!-- ########## START: LEFT PANEL ########## -->
<?php echo $__env->make('layouts.partials.sidebar', \Illuminate\Support\Arr::except(get_defined_vars(), array('__data', '__path')))->render(); ?>
<!-- ########## END: LEFT PANEL ########## -->

<!-- ########## START: HEAD PANEL ########## -->
<?php echo $__env->make('layouts.partials.header', \Illuminate\Support\Arr::except(get_defined_vars(), array('__data', '__path')))->render(); ?>

<!-- ########## END: HEAD PANEL ########## -->

<?php echo $__env->make('layouts.partials.right_sidebar', \Illuminate\Support\Arr::except(get_defined_vars(), array('__data', '__path')))->render(); ?>
<!-- ########## START: MAIN PANEL ########## -->
<?php echo $__env->yieldContent('content'); ?>
<?php echo $__env->make('layouts.partials.footer', \Illuminate\Support\Arr::except(get_defined_vars(), array('__data', '__path')))->render(); ?>
</div><!-- br-mainpanel -->
<!-- ########## END: MAIN PANEL ########## -->

<?php echo $__env->make('layouts.partials.scripts', \Illuminate\Support\Arr::except(get_defined_vars(), array('__data', '__path')))->render(); ?>
<?php echo e(HTML::script('http://cdn.bootcss.com/toastr.js/latest/js/toastr.min.js')); ?>

<script type="text/javascript">
$(".success").click(function(){
		toastr.success('We do have the Kapua suite available.', 'Success Alert', {timeOut: 5000})
});
toastr.options = {  "closeButton": true,  "debug": false,  "newestOnTop": true,  "progressBar": false,  "positionClass": "toast-top-right",  "preventDuplicates": false,  "onclick": null,  "showDuration": 30,  "hideDuration": 1000,  "timeOut": 5000,  "extendedTimeOut": 1000,  "showEasing": "swing",  "hideEasing": "linear",  "showMethod": "fadeIn",  "hideMethod": "fadeOut"
}

</script>
<?php echo $__env->yieldContent('scripts'); ?>

<script src="https://ajax.aspnetcdn.com/ajax/jquery.validate/1.15.1/jquery.validate.js"></script>
<?php echo e(HTML::script('js/mobiscroll.jquery.lite.min.js')); ?> 
<script src="">
  mobiscroll.settings = {
        lang: 'en',   // Specify language like: lang: 'pl' or omit setting to use default
        theme: 'ios'  // Specify theme like: theme: 'ios' or omit setting to use default
    };</script>

</body>
</html>