<!DOCTYPE html>
<html lang="<?php echo e(app()->getLocale()); ?>">
<head>
	<meta charset="utf-8">
	<meta http-equiv="X-UA-Compatible" content="IE=edge">

	 <title><?php echo $__env->yieldContent('title'); ?> - <?php echo e(config('config.site_name')); ?></title> 

	<!-- Meta Informations -->
	<meta content="width=device-width, initial-scale=1, maximum-scale=1, user-scalable=no" name="viewport">
    <meta name="_token" content="<?php echo e(csrf_token()); ?>">
	<meta property="og:site_name" content="<?php echo e(config('config.site_name')); ?>" />
	<meta property="og:locale" content="en_US" />
	<meta property="og:type" content="website" />
	<meta property="og:url" content="<?php echo e(url('/')); ?>" /><meta charset="utf-8" />
       

	<!-- Favicon -->
    <!--  -->
    <link rel="shortcut icon" href="<?php echo e(asset('assets/img/logo.png')); ?>"> 
    <!--Morris Chart CSS -->
<link href="<?php echo e(asset('assets/lib/font-awesome/css/font-awesome.css')); ?>" rel="stylesheet">
<link href="<?php echo e(asset('assets/lib/Ionicons/css/ionicons.css')); ?>" rel="stylesheet">
<link href="<?php echo e(asset('assets/lib/perfect-scrollbar/css/perfect-scrollbar.css')); ?>" rel="stylesheet">
<link href="<?php echo e(asset('assets/lib/jquery-switchbutton/jquery.switchButton.css')); ?>" rel="stylesheet">
<link href="<?php echo e(asset('assets/lib/rickshaw/rickshaw.min.css')); ?>" rel="stylesheet">
<link href="<?php echo e(asset('assets/lib/chartist/chartist.css')); ?>" rel="stylesheet">
<!-- vendor css -->
<link href="<?php echo e(asset('assets/lib/highlightjs/github.css')); ?>" rel="stylesheet">
<link href="<?php echo e(asset('assets/lib/datatables/jquery.dataTables.css')); ?>" rel="stylesheet">
<link href="<?php echo e(asset('assets/lib/select2/css/select2.min.css')); ?>" rel="stylesheet">
<!-- Bracket CSS -->

<!-- Editors -->
<link href="<?php echo e(asset('assets/lib/medium-editor/medium-editor.css')); ?>" rel="stylesheet">
<link href="<?php echo e(asset('assets/lib/medium-editor/default.css')); ?>" rel="stylesheet">
<link href="<?php echo e(asset('assets/lib/summernote/summernote-bs4.css')); ?>" rel="stylesheet">


<link rel="stylesheet" href="<?php echo e(asset('assets/css/bracket.css')); ?>">


	
    <!-- Fonts -->
    <link href="https://fonts.googleapis.com/css?family=Raleway:100,600" rel="stylesheet" type="text/css">
	
	<?php echo $__env->make('layouts.partials.links', \Illuminate\Support\Arr::except(get_defined_vars(), array('__data', '__path')))->render(); ?>
	
	<?php echo $__env->yieldContent('links'); ?>
    <link rel="stylesheet" href="http://cdn.bootcss.com/toastr.js/latest/css/toastr.min.css">
</head>
<body >
<?php if($errors->any()): ?>

            <script>
                       window.onload = function() {
                        var title="Error";
                        var type="error";
                        var msg="<?php echo e($errors->first()); ?>";

                        if(type=="error"){
                            Command: toastr["error"](msg,title);
                        }
            };
            </script>
<?php endif; ?>

     
  <div class="container">
        <div class="row justify-content-center">
			<?php echo $__env->yieldContent('content'); ?>


            
		<?php echo $__env->make('layouts.partials.footer', \Illuminate\Support\Arr::except(get_defined_vars(), array('__data', '__path')))->render(); ?>
    </div>
</div>
    <?php echo $__env->make('layouts.partials.scripts', \Illuminate\Support\Arr::except(get_defined_vars(), array('__data', '__path')))->render(); ?>
    

    
    <script src="http://maps.google.com/maps/api/js?key=AIzaSyDedw7jUE0W3kHltX2lNOhzkicm3GvBHbQ&&libraries=places"></script>
    <script src="<?php echo e(asset('assets/lib/gmaps/gmaps.js')); ?>"></script>
  <script src="<?php echo e(asset('assets/lib/jquery/jquery.js')); ?>"></script>
  <script src="<?php echo e(asset('assets/lib/popper.js/popper.js')); ?>"></script>
  <script src="<?php echo e(asset('assets/lib/bootstrap/bootstrap.js')); ?>"></script>
  <script src="<?php echo e(asset('assets/lib/perfect-scrollbar/js/perfect-scrollbar.jquery.js')); ?>"></script>
  <script src="<?php echo e(asset('assets/lib/moment/moment.js')); ?>"></script>
  <script src="<?php echo e(asset('assets/lib/jquery-ui/jquery-ui.js')); ?>"></script>
  <script src="<?php echo e(asset('assets/lib/jquery-switchbutton/jquery.switchButton.js')); ?>"></script>
  <script src="<?php echo e(asset('assets/lib/peity/jquery.peity.js')); ?>"></script>
 


  <script src="<?php echo e(asset('assets/js/bracket.js')); ?>"></script>
  <script src="<?php echo e(asset('assets/js/ResizeSensor.js')); ?>"></script>
  

  <script src="<?php echo e(asset('assets/lib/highlightjs/highlight.pack.js')); ?>"></script>
  <script src="<?php echo e(asset('assets/lib/datatables/jquery.dataTables.js')); ?>"></script>
  <script src="<?php echo e(asset('assets/lib/datatables-responsive/dataTables.responsive.js')); ?>"></script>
  <script src="<?php echo e(asset('assets/lib/select2/js/select2.min.js')); ?>"></script>


<!-- Editore -->
    <script src="<?php echo e(asset('assets/lib/summernote/summernote-bs4.min.js')); ?>"></script>
    <script src="<?php echo e(asset('assets/lib/medium-editor/medium-editor.js')); ?>"></script>
    

  <script src="<?php echo e(asset('assets/innoapps.js')); ?>"></script>
  <script>
    $(function () {
      // validate.init();
      'use strict';

      $('#datatable1').DataTable({
        responsive: true,
        language: {
          searchPlaceholder: 'Search...',
          sSearch: '',
          //            lengthMenu: '_MENU_ items/page',
        }
      });
      $(".dataTables_length select").select2({
  tags: true
});


      // Select2
      $('.dataTables_length select').select2({ minimumResultsForSearch: Infinity });

    });


    $.ajaxSetup({
headers: {
    'X-XSRF-TOKEN': decodeURIComponent(/XSRF-Token=([^;]*)/ig.exec(document.cookie)[1])
}
});
  </script>
  <script>
    $(function () {

    

<?php if(!empty($table_info['source'])): ?>
$(document).ready(function() {
  var id='#'+"<?php echo e($table_info['id']); ?>"; 
  var source="<?php echo e($table_info['source']); ?>/lists";

    $(id).DataTable({
						"processing": true,
						lengthChange: false,
            "serverSide": true,
            "ajax":{
                     "url": source,
                     "type": "POST",
									 },

        });
    
} );
<?php endif; ?>


$('select[name=country_id]').change(function() {
          var country =  $(this).val();
  
            var url = '<?php echo e(url('country')); ?>/'+ $(this).val()+'/states';
            
            $.get(url, function(data) {       
                var select = $('form select[name= state_id]');

                select.empty();
                var selectc = $('form select[name= city_id]');

                selectc.empty();
                select.append("<option value=''>Select State</option>");
                $.each(data,function(key, value) {
                    select.append('<option value=' + value.state_id + '>' + value.state_name + '</option>');
                });
            });
        });



        $('select[name=state_id]').change(function() {
          var state =  $(this).val();
  
            var url = '<?php echo e(url('state')); ?>/'+ $(this).val()+'/city';
            
            $.get(url, function(data) {       
                var select = $('form select[name= city_id]');

                select.empty();
                select.append("<option value=''>Select City</option>");
                $.each(data,function(key, value) {
                    select.append('<option value=' + value.city_id + '>' + value.city_name + '</option>');
                });
            });
        });
    })
  </script>

        <script src="http://cdn.bootcss.com/toastr.js/latest/js/toastr.min.js"></script>
        <script type="text/javascript">
	$(".success").click(function(){
		toastr.success('We do have the Kapua suite available.', 'Success Alert', {timeOut: 5000})
	});

</script>
	<script>

toastr.options = {
  "closeButton": true,
  "debug": false,
  "newestOnTop": true,
  "progressBar": false,
  "positionClass": "toast-top-right",
  "preventDuplicates": false,
  "onclick": null,
  "showDuration": 300,
  "hideDuration": 1000,
  "timeOut": 5000,
  "extendedTimeOut": 1000,
  "showEasing": "swing",
  "hideEasing": "linear",
  "showMethod": "fadeIn",
  "hideMethod": "fadeOut"
}
</script>

	<?php echo $__env->yieldContent('scripts'); ?>
	
</body>
</html>