<!doctype html>
<html>
<head id="print">
 <div id="printThis">
    <meta charset="utf-8">
    <title>#<?php echo e($invoice->charging_id); ?></title>

    <style media="print">
            @page  {
             size: auto;
             margin: 40px 0px 0px 130px;
                  }
           </style>
    
    <style>
     
    .invoice-box {
        max-width: 800px;
        /* margin: auto; */
        padding: 30px;
        border: 1px solid #eee;
        box-shadow: 0 0 10px rgba(0, 0, 0, .15);
        font-size: 16px;
        line-height: 24px;
        font-family: 'Helvetica Neue', 'Helvetica', Helvetica, Arial, sans-serif;
        color: #555;
    }
    
    .invoice-box table {
        width: 100%;
        line-height: inherit;
        text-align: left;
    }
    
    .invoice-box table td {
        padding: 5px;
        vertical-align: top;
    }
    
    .invoice-box table tr td:nth-child(2) {
        text-align: right;
    }
    
    .invoice-box table tr.top table td {
        padding-bottom: 20px;
    }
    
    .invoice-box table tr.top table td.title {
        font-size: 45px;
        line-height: 45px;
        color: #333;
    }
    
    .invoice-box table tr.information table td {
        padding-bottom: 40px;
    }
    
    .invoice-box table tr.heading td {
        background: #eee;
        border-bottom: 1px solid #ddd;
        font-weight: bold;
    }
    
    .invoice-box table tr.details td {
        padding-bottom: 20px;
    }
    
    .invoice-box table tr.item td{
        border-bottom: 1px solid #eee;
    }
    
    .invoice-box table tr.item.last td {
        border-bottom: none;
    }
    
    .invoice-box table tr.total td:nth-child(2) {
        border-top: 2px solid #eee;
        font-weight: bold;
    }
    
    @media  only screen and (max-width: 600px) {
        .invoice-box table tr.top table td {
            width: 100%;
            display: block;
            text-align: center;
        }
        
        .invoice-box table tr.information table td {
            width: 100%;
            display: block;
            text-align: center;
        }
    }
    
    /** RTL **/
    .rtl {
        direction: rtl;
        font-family: Tahoma, 'Helvetica Neue', 'Helvetica', Helvetica, Arial, sans-serif;
    }
    
    .rtl table {
        text-align: right;
    }
    
    .rtl table tr td:nth-child(2) {
        text-align: left;
    }

    @media  print
{    
    .no-print, .no-print *
    {
        display: none !important;
    }
    .invoice-box {
    max-width: 100%;
    /* margin: auto; */ 
    padding: 11px;
    border: 11px solid #eee;
    box-shadow: 0 0 24px rgba(0, 0, 0, .15);
    font-size: 18px;
    line-height: 27px;
    font-family: 'Helvetica Neue', 'Helvetica', Helvetica, Arial, sans-serif;
    color: #555;
}
}
    </style>
</head>

<body>
    <div class="invoice-box">
        <table cellpadding="0" cellspacing="0">
            <tr class="top">
                <td>
                    <table>
                        <tr>
                            <td class="title">
                                    <?php if(File::exists(config('constants.upload_path.logo').config('config.logo'))): ?>
                                    <a href="/"><img src="<?php echo e(url(config('constants.upload_path.logo').config('config.logo'))); ?>" class="" alt="Logo"></a>
                                    <?php endif; ?>
                            </td>
                        </tr>
                    </table>
                </td>
                <td>
                        <table>
                            <tr style="text-align: -webkit-right;">
                                <td>
                                    <p style='font-size:16px; font-weight:bold;margin-bottom: 7px;'><?php echo config('config.company_name'); ?></h2>
                                    <p style='font-size:12px; font-weight:bold;margin-bottom: 7px;'><?php echo config('config.address'); ?>

                                    <?php echo config('config.zipcode'); ?></p>
                                     <p style='margin-bottom: 7px;'><?php echo trans('messages.email'); ?> : <?php echo config('config.email'); ?> | <?php echo trans('messages.phone'); ?> : <?php echo config('config.phone'); ?></p>
                                </td>
                            </tr>
                        </table>
                    </td>
                
            </tr>
            
            <tr class="information">
                <td>
                    <table>
                        <tr>
                            <td>
                                <h6><b>User Information</b></h6>
                                <b>Name :</b> <?php echo e($invoice->first_name.' '.$invoice->lastt_name); ?><br>
                                <b>Email :</b> <?php echo e($invoice->email); ?><br>
                                <b>Mobile : </b> <?php echo e($invoice->mobile); ?>

                            </td>
                        </tr>
                    </table>
                </td>
                <td >
                        <table>
                            <tr>
                                <td style="text-align: -webkit-left;">
                                 <h6><b>Charger Information</b></h6>
                                 <p>
                                    <b>Station ID      &nbsp;: </b> <?php echo e($invoice->station_id); ?><br>
                                    <b>CP ID           &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;: </b> <?php echo e($invoice->nozzle_id); ?><br>
                                    <b>Station Location    &nbsp;: </b> <?php echo e($invoice->location_name); ?><br>
                                    <b>Station Name    &nbsp;: </b> <?php echo e($invoice->station_name); ?><br>
                                    <b>Station Address &nbsp;: </b> <?php echo e($invoice->address); ?><br>
                                    <b>Application     &nbsp;: </b> <?php echo e(ucfirst($invoice->application)); ?>

                                 </p>
                                </td>
                            </tr>
                        </table>
                    </td>
            </tr>
            
            <tr class="heading">
                <td>
                    Payment Method
                </td>
                
                <td>
                    Check #
                </td>
            </tr>
            
            <tr class="details">
                <td>
                   Payment Status
                </td>
                <td>
                        <?php echo e($invoice->order_status); ?>

                </td>
                
            </tr>
            <tr class="details">
            <td>
                    Payment Mode
            </td>
            <td>
                    <?php echo e($invoice->type); ?>

            </td>
           </tr>
            
            <tr class="heading">
                <td>
                    Details
                </td>
                <td>
                    Amount
                </td>
            </tr>
            <tr class="item">
                    <td>
                        Per/KWT
                    </td>
                    <td>
                            ₹<?php echo e($invoice->price); ?>

                    </td>
                </tr>
                <tr class="item">
                        <td>
                            Used KWT
                        </td>
                        <td>
                            <?php echo e($invoice->power_usage); ?> KWT
                        </td>
                    </tr>
            <tr class="item">
                <td>
                    Base Fare
                </td>
                <td>
                   ₹<?php echo e($invoice->base_fare); ?>

                </td>
            </tr>
           

            

            <tr class="total">
                <td></td>
                
                <td>
                   Total:  ₹<?php echo e($invoice->amount); ?>

                </td>
            </tr>
        </table>
        <br>
        
    </div>
    <div class="row no-print pull-right">
            <div class="col-xs-12" style="margin-top: 9px; margin-bottom: 10px; margin-right: 11px;">
              
           <button type="button" style="cursor: pointer; margin-right: 14px;" class="btn btn-default" onclick="qrPrint();"><i class="fa fa-print"></i> Print
              </button>
              <a href='/download/pdf/<?php echo e($invoice->id); ?>'><button   style="cursor: pointer; margin-right: 14px;" data-id="<?php echo e($invoice->id); ?>" type="button" class="btn btn-primary pull-right" style="margin-right: 5px;">
                <i class="fa fa-download"></i> Generate PDF
              </button></a>
              
            </div>
          </div>
    <script>
        $(document).on("click", "#js-download", function(e) {
            id=$(this).data("id")

e.preventDefault();

$.ajax({
    url: '/download/pdf/'+id,
    data: $("#js-pdf-form").serialize(),
    success:function(data) {
     
    },
    error:function() {
    }
});

});


        function qrPrint() {
        printElement(document.getElementById("printThis"));
        }
        
        function printElement(elem) {
        var domClone = elem.cloneNode(true);
        
        var $printSection = document.getElementById("printSection");
        
        if (!$printSection) {
            var $printSection = document.createElement("div");
            $printSection.id = "printSection";
            document.body.appendChild($printSection);
        }
        
        $printSection.innerHTML = "";
        $printSection.appendChild(domClone);
        document.title = '<?php echo e($invoice->first_name.' '.$invoice->lastt_name); ?>  #Invoice <?php echo e($invoice->id); ?>  Transaction Id :<?php echo e($invoice->transaction_id); ?>';
        window.print();
        }


  </script>
</body>
</div>

</html>